--after kill 3 skeletons auto end with titan effect
handler = 0
phase = 0
destroyed = 0
freyaspawned = 0
playonce = 0
finish = 0
dragonce = 0
heroarrived = 0
shouldPlayGiveOrderMovie = true
shouldPlayGiveOrderMovie2 = true
shouldPlayTapUnitMovie = true
shouldPlayTapUnitMovie2 = true
handler1 = 0
handler2 = 0
handler3 = 0
handler4 = 0
queuedKills = {}
SkeletonNotDead = 0
singleanalytic = 0
CallMeOnce = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("SpawnPaladinFX")
  QueueVFX("PA_TutorialFireball")
end

function onLevelStart()
	SetUseEnteringAnims(true) -- start anim of skeletons climbing out of the floor
	rainingfire()		-- fireballs from sky effect in battle area
	SetMinimalUI()		-- disable UI display as level starts
	SetWinnable(false)	-- level cannot be completed even if no enemy units are alive
	SetCinematicTimeout(-1) -- level will never go to cinematic camera
	DisableNecromancer()	-- no ability to ressurect dead units after mission fail
--	SetUseEnteringAnims(true) -- start anim of skeletons climbing out of the floor
	SetTriggerCallbacks("Trigger1", Trigger1_onTriggerEnter) -- first triggerzone MOVE TO COMMAND
	SetTriggerCallbacks("wrongway", wrongway_onTriggerEnter) -- heading backwards from start line warning triggerzone
	SetTriggerCallbacks("stoparmy", stoparmy_onTriggerEnter)
	SetTriggerCallbacks("Losetrigger", Losetrigger_onTriggerEnter) -- heading past wrongway trigger lose battle after warning
	SetTriggerCallbacks("ignoredskeleton", ignoredskeleton_onTriggerEnter) -- really paying no attention to skeleton1 and passing stopmilitia trigger
	SetTroopAndSpellSelectorEnabled(false)
	SetTriggerCallbacks("killtrigger1", killtrigger1_onTriggerEnter)
	SetTriggerCallbacks("killtrigger2", killtrigger2_onTriggerEnter)
	SetTriggerCallbacks("killtrigger3", killtrigger3_onTriggerEnter)
	SetTriggerCallbacks("killtrigger4", killtrigger4_onTriggerEnter)
	SetTriggerCallbacks("killtrigger5", killtrigger5_onTriggerEnter)
	SetTriggerCallbacks("stopmilitia", stopmilitia_onTriggerEnter)		-- used to stop player is they pass first skeletons without attacking them
	SetPanningCamera(-58.0, 160, 28.8, 0.05, -0.3) -- focusX, focusY, zoom, heading, pitch

	SetAI1()			--
	SetAI2()
	SetAI2almarand()
	AddTimer(12.0, spawnendarmy)			-- START THE SPAWN FOR FAR ENEMY UNITS TO ADVANCE TOWARDS 300 STYLE PIKE WALL


	--GiveSpellImmediate("Apocalypse", 1)		-- gives the spell required to complete the mission
	PlaySwfMovie("Media/UI/StorySetUp.swf")
	SetMusicScriptID ("FTUE")
	PlayMusicCue ("FTUE", "FTUE_01_Enter")
	LogMetricsMilestoneEvent("ftue", "ftue_1000_epicbattle") -- analytic callback "an epic battle rages" starts
	AddTimer(2.8, StartCameraIntro)
	SetAlliedPlayers(0, 2)
--	AddTimer(7.5, SetAI4a)


end

-- --------------------------------------			FREEZE / UNFREEZE ENTIRE ARMY COMMANDS 		-----------

function SetAI1() -- freeze army side 1 in place - Pike units at Elder Stone & Archers behind them
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function SetAI2() -- freeze army side 2 in place - Front Row Enemy Militia
	local units = GetUnits("*", "CampMilitia25", 3)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function SetAI2almarand() -- freeze Almarand in place
	local units = GetUnits("*", "FallenINTRO*", 3)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function SetAI2bArcher() -- freeze back rows of enemy army
	local units = GetUnits("*", "CampArcher20", 3)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function SetAI3()  -- unfreeze "300" style defenders
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
	end
end

function SetAI4()  -- unfreeze army side2 front rows
	local units = GetUnits("*", "CampMilitia25", 3)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
	end
end

function SetAI4a() -- unfreeze almarand
	local units = GetUnits("*", "FallenINTRO*", 3)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
	end
end

function Setskeleton()	-- stops skeletons from moving
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function Setskeletongo() -- unleashes skeletons when player hits trigger 1
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
	end
end

-- stops all player units
function Stopplayer()
	local units = GetUnits("*", "*", 0)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end


function stoparmy_onTriggerEnter(unit)		-- might not need this...CONSTANT SPAWNS MOVING FORWARD
	if unit.id == "CampMilitia20" then
		SetAI2bArcher()
	end
end

---------------------------------------------------------------------------------------------------------------

function StartCameraIntro()
	PlayCameraAnimation("CAMERA_INTRO")		-- intro cinematic camera
end

function onSwfMovieEnd(movie)
	print("onSwfMovieEnd", movie)
	--if movie=="Media/UI/StorySetUp.swf" then
		--SetCutsceneSkipperEnabled(true)
	--end
	if movie == "Media/UI/Tutorial_SpellCommands.swf" then

	end
end

-- Called if the user taps on the "skip" button.
function onCutsceneSkip()
	print("onCutsceneSkip phase=",phase)
	SetCutsceneSkipperEnabled(false) -- disable 'skip' button - the player is in control now
	CancelAllTimers() -- Make sure nothing unexpected is queued up...
	rainingfire() -- ...but we still want our raining fireballs!
	SetPanningCameraLimit(140, 230)
  AddTimer(8.0, spawnendarmy)			-- (RE)START THE SPAWN FOR FAR ENEMY UNITS TO ADVANCE TOWARDS 300 STYLE PIKE WALL
	if phase==0 then
		SetAI4()
		SetAI4a()
		phase = 1
	end
	if phase<2 then
		onCameraAnimationFinish("CAMERA_CLASH")
	end
end

function playTapUnitMovie()
	local units = GetUnits("*", "FallenINTRO*", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
		for i,unit in pairs(units) do
		DisableAttackDamage(unit)
		end
  if shouldPlayTapUnitMovie then
	HideDialog()
	ShowDialogDismiss("talkingheads/full/soldier", "TXT_BATTLETUTORIAL_1")																							-- TAP THE UNIT TEXT
    local allies = GetUnits("*", "Militia5", 0) -- get player Militia unit
    PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
    shouldPlayTapUnitMovie = false

  end
end

function playTapUnitMovie2()
  if shouldPlayTapUnitMovie2 then
    local allies = GetUnits("*", "IntroHero*", 0) -- get player Militia unit
   -- PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
    shouldPlayTapUnitMovie2 = false
  end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		phase = 1
		PlaySwfMovie("Media/UI/StorySetUp2.swf")
		LogMetricsMilestoneEvent("ftue", "ftue_1100_almarandgates") -- analytic call for "almarand is at the gates"
		AddTimer(3.0, PlayCameraAnimation,"CAMERA_CLASH")
--		AddTimer(3.0, SetAI3)
		AddTimer(2.0, SetAI4)
--		AddTimer(0.1, SetAI4a)
		SetAI4a()		-------------------------------------------
--	end
	elseif cameraName == "CAMERA_CLASH" then
		SetCutsceneSkipperEnabled(false) -- disable 'skip' button - the player is in control now
		local allies = GetUnits("*", "Militia5", 0) -- get player Militia unit
		AddTimer(4.0, playTapUnitMovie)
		AddTimer(4.0, LogMetricsMilestoneEvent, "ftue", "ftue_1300_showselecttap") -- analytic call for showing tap UI overlay
		PlayMusicCue ("FTUE", "FTUE_02_Player_Control")
		ForceSelectAlly(allies[1])
		EnableCameraControl(false)
		SetPanningCamera(-59.5, 175.2, 66.9, 0.04, -0.25) -- focusX, focusY, zoom, heading, pitch
		SetPanningCameraLimit(140, 230)
		phase = 2
		AddTimer(0.2,ShowDialog,"talkingheads/full/soldier","TXT_BATTLETUTORIAL_2")
		LogMetricsMilestoneEvent("ftue", "ftue_1200_deadarisen") -- analytic call back for player first control
		SpawnUnits("killsingle")
		Setskeleton()
    PlaySFX("SFX_RAISEDEAD_FTUE")
		SetTriggerCallbacks("startkillsingle", startkillsingle_onTriggerEnter, startkillsingle_onTriggerLeave)
		local units = GetUnits("*", "*", 3) -- advancing Faction ADDED IN TURNING DAMAGE OFF FOR END ARMIES FIGHTING BATTLE HERE --
		for i,unit in pairs(units) do
			DisableAttackDamage(unit)
		end
	local units = GetUnits("*", "*", 2) -- defending faction -- ADDED IN TURNING DAMAGE OFF FOR END ARMIES FIGHTING BATTLE HERE --  										WE WANT DEFENDERS DOING DAMAGE HERE
		for i,unit in pairs(units) do
		DisableAttackDamage(unit)
		end
	local units = GetUnits("*", "FallenINTRO*", 3) -- advancing Faction ADDED IN TURNING DAMAGE OFF FOR END ARMIES FIGHTING BATTLE HERE --
		for i,unit in pairs(units) do
		EnableAttackDamage(unit)
		end
--	end
	elseif cameraName == "CAMERA_ACTION*" then  									-- DOESNT SEEM TO BE SETTING CAMERA TO THE BELOW SETING!!!!!!!!!!!!!!!!!!!!
		SetPanningCameraLimit(159, 326)
--		SetPanningCamera(-76.7, 205, 10, 0.1, -0.25) -- moved to set new position just before titan intro camera plays (BUG wont change camera position)
		playTapUnitMovie2()
	elseif cameraName == "CAMERA_ELDERSTONE" then
		castApocalypse()
  end
end

-- ------------------------------			GENERIC FUNCTIONS USED THROUGHOUT MISSION 		-------------------

function playGiveOrderMovie()
  if shouldPlayGiveOrderMovie then
    local allies = GetUnits("*", "Militia5", 0) -- get player Militia unit
    PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands02.swf", allies[1])

  end
end

function playGiveOrderMovie2()
  if shouldPlayGiveOrderMovie2 then
    local allies = GetUnits("*", "IntroHero*", 0) -- get player Titan unit
    --PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands02.swf", allies[1])
  end
end

function onUnitSelected(unit)
	if unit.side == 0 then
		if phase == 2 then
			phase = 3
			shouldPlayTapUnitMovie = false
			EnableSelectionChange(false)
			SetStandGuardButtonEnabled(false)
			ClearTargetCircles() -- Cancels effect of ForceSelectAlly
			--HideUnitGuideArrow(unit)
			LogMetricsMilestoneEvent("ftue", "ftue_1400_tapfirstunit") -- analytic call for first selection of militia unit
			CloseTutorialMovie()
			HideDialog()
			--ShowDialogDismiss("talkingheads/full/soldier", "TXT_SP1A_GIVE_ORDER")
			AddTimer(0.5, playGiveOrderMovie)
			AddTimer(0.5, LogMetricsMilestoneEvent,"ftue", "ftue_1500_showmoveorder") -- analytic call for showing first move order UI overlay
		elseif phase > 2 then
			shouldPlayTapUnitMovie2 = false
			CloseTutorialMovie()
		end
		if heroarrived == 1 and unit.spawnId=="Hero" then
			EnableSelectionChange(false)
			AddTimer(0.5, playGiveOrderMovie2)
			heroarrived = 2
		end
	end
end

function onUnitOrderGiven(unit, orderType)
	if heroarrived == 0 then
		shouldPlayGiveOrderMovie = false
		CloseTutorialMovie()
		HideDialog()
		EnableCameraControl(true)
		if singleanalytic == 0 then
			LogMetricsMilestoneEvent("ftue", "ftue_1600_movefirstunit") -- analytic call for first move order with militia unit
			singleanalytic = 1
		end
	end
	if heroarrived == 2 then
		shouldPlayGiveOrderMovie2 = false
		CloseTutorialMovie()
		ClearTargetCircles() -- Cancels effect of ForceSelectAlly
		EnableCameraControl(true)
		EnableSelectionChange(true)
		heroarrived = 4
	end
end

function onUnitDeselected()
	if phase == 2 then
		local allies = GetUnits("*", "*", 0) -- get all attackers
		ForceSelectAlly(allies[1])

    -- if we deselect our unit before we've given the order, we should start the cycle again
		if shouldPlayGiveOrderMovie then
			CloseTutorialMovie()
			shouldPlayTapUnitMovie = true
			AddTimer(0.5, playTapUnitMovie)
		end
	end
	if heroarrived == 1 then
		local allies = GetUnits("*", "IntroHero*", 0) -- get player titan
		ForceSelectAlly(allies[1])
	    -- if we deselect our unit before we've given the order, we should start the cycle again
		if shouldPlayGiveOrderMovie2 then
			CloseTutorialMovie()
			--shouldPlayTapUnitMovie2 = true
			--AddTimer(0.5, playTapUnitMovie2)
		end
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 and CallMeOnce == 0 then		-- calls in the hero once skeleton is dead OR doesnt get called at all if player ignores skeleton and charges ahead to ignoreskeleton trigger
			SkeletonNotDead = 1
			DisableTrigger("stopmilitia")
			DisableTrigger("ignoredskeleton")
			EnableSelectionChange(true)
			PlaySFX("SFX_RAISEDEAD_FTUE")
			SpawnUnits("killsecond")
			SpawnUnits("spawn2")
			Setskeleton()
			AddTimer(1.0 , freyaentrance)
			AddTimer(2.0, Stopplayer)
			SetTriggerCallbacks("startdefenders", startdefenders_onTriggerEnter)
			SetTriggerCallbacks("Endgame", Endgame_onTriggerEnter)
		end
		--if destroyed == 5 and playonce == 0 then
			--CALL TO ACTION
			--playonce = 1
			--AddTargetCircleWithArrow("Endgame")
			--ShowDialog("talkingheads/full/Kobar", "TXT_BATTLETUTORIAL_8")
		--end
		 if destroyed ==5 then
			AddTimer(1.0,playanimation)
		end
	end
end

function playanimation()
	shouldPlayGiveOrderMovie2 = false
	CloseTutorialMovie()
	ClearTargetCircles()
	DeselectAll()
	EnableSelectionChange(false)
	GiveNamedUnitMoveOrder("Hero","Endgame")
end

function freyaentrance()
		AddTimer(2.5, PlayMusicCue, "FTUE", "FTUE_03_Titan_Spawn")
		AddTimer(2.5, PlaySFX,"sfx_ftue_TitanSpawn_entry")
		AddTimer(2.5, PlayVFX,"SpawnPaladinFX", "StaffofPower")
		AddTimer(3.0, camchange)
		AddTimer(5.5 ,SpawnUnits,"Hero")
		AddTimer(5.5 ,comedykill)
		AddTimer(7.0, ShowDialog, "talkingheads/full/Kobar", "TXT_BATTLETUTORIAL_3")
		AddTimer (40.0, endoftime)
end

function camchange()
	SetPanningCamera(-76.7, 205, 10, 0.1, -0.25) -- focusX, focusY, zoom, heading, pitch
end

function comedykill()		-- FREYA LANDS ON killsecond SKELETON UNIT KILLING IT
	local units = GetUnits("killsecond", "*", 1)
	for i,u in pairs(units) do
		RadialDamageUnit(u, 100, 100, 4)
	end
	heroarrived = 1
	LogMetricsMilestoneEvent("ftue", "ftue__1700_titanfall") -- analytic callback titan falls form the sky
  PlaySFX("sfx_ftue_TitanSpawn_land")
end

----------------------------------------------------------------------------------------------------------------

--						FIRST TRIGGER					--------------------------------------------------------
-- Enter first trigger to spawn an enemy unit
function Trigger1_onTriggerEnter(unit)
	if unit.attacker and phase == 1 then
--		AddTimer(11.0, SpawnUnits,"killsecond")

--		Stopplayer()
	end
end

function startkillsingle_onTriggerEnter(unit)			-- sets first skeleton to move forward and attack
	if unit.attacker then
		Setskeletongo()
		DisableTrigger("startkillsingle")
		ForceGiveMoveOrder("")

	end
end

function ignoredskeleton_onTriggerEnter(unit)		-- player is being an arse and ignoring first skeleton so trigger hero spawn anyway and block path
	if unit.attacker and SkeletonNotDead == 0 then
		CallMeOnce = 1
		SkeletonNotDead = 2
		EnableSelectionChange(true)
		PlaySFX("SFX_RAISEDEAD_FTUE")
		SpawnUnits("killsecond")
		SpawnUnits("spawn2")
		Setskeleton()
		AddTimer(1.0 , freyaentrance)
		AddTimer(2.0, Stopplayer)
		SetTriggerCallbacks("startdefenders", startdefenders_onTriggerEnter)
		SetTriggerCallbacks("Endgame", Endgame_onTriggerEnter)
	end
end

function stopmilitia_onTriggerEnter(unit)
	if unit.attacker and destroyed ~=1 then
		Stopplayer()
		DisableTrigger("stopmilitia")
	elseif unit.attacker and destroyed == 1 then
		DisableTrigger("stopmilitia")
	end
end

function startdefenders_onTriggerEnter(unit) 			-- Used to trigger second wave of skeletons
	if unit.attacker then
		Setskeletongo()
		DisableTrigger("startdefenders")

		-- DAMAGE TURN ON ARMY, FREYA AND SKELETONS
--		SetAI3()
		SetAI4()

--[[		local units = GetUnits("*", "*", 2)
			for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end
		local units = GetUnits("*", "*", 3)
			for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end]]

	end
end

-- END TRIGGER BEFORE LARGE ARMY ---------------------------------------------------------------------------------------

function Endgame_onTriggerEnter(unit)
	if unit.attacker then
		if unit.spawnId == "Hero" then
			HideDialog()
			playonce = 1 -- In case we've skipped forwards
			ShowDialog("talkingheads/full/Kobar", "TXT_BATTLETUTORIAL_11")
			LogMetricsMilestoneEvent("ftue", "ftue_1800_movefrontlines") -- analytic call back for any unit reaching front line of battle
			--ClearAllGuideArrows()
			--SetTroopAndSpellSelectorEnabled(true)
			SetPanningCamera(-75, 253, 10, 0.1, -0.25) -- focusX, focusY, zoom, heading, pitch AFTER SPELL HAS BEEN CAST
			CancelTimer(endoftime)
			AddTimer(0.0, endoftime)
		end
	end
end

function endoftime()
	PlayBattlefieldAnimation("ELDERSTONE1")
	PlayCameraAnimation("CAMERA_ELDERSTONE")
	finish = 1
	DisableTrigger("Endgame")
	Stopplayer()
	ForceGiveMoveOrder("")
	local allies = GetUnits("*", "IntroHero*", 0) -- get player Militia unit
		PlayUnitAnimation(allies[1], "ActivateElderStone")
	DeselectAll()
	EnableSelectionChange(false)
	EnableCameraControl(false)
	local units = GetUnits("*", "FallenINTRO*", 3) -- END OF MISSION ALMARANDS DAMAGE TURNED BACK ON
	for i,unit in pairs(units) do
		EnableAttackDamage(unit)
		end
	--else
		--Stopplayer()
		--ShowDialog("talkingheads/full/soldier", "TXT_BATTLETUTORIAL_12")
		--end
	--end
end

function playhandswipe()
	--PlayTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
--	phase = 5
--	ShowUIGuideArrow("TroopSpellList")
end

function castApocalypse()
	if finish == 1 then
		WinSilently()
    local units = GetUnits("*", "*", 2)
			for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end
		local units = GetUnits("*", "*", 3)
			for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end
		local change = GetUnits("*", "*", 0)
			for i,unit in pairs(change) do
			SwitchSide(unit , 3)
			-- Kill player's units because apocalypse won't, and want to stop their SFX
			KillUnit(unit)
			HideDeadUnit(unit)
		end
		LogMetricsMilestoneEvent("ftue", "ftue_1900_showapocalypse") -- analytic call back for displaying apocalypse spell
		CastSpell("Apocalypse", 1, "Apocalypsepos", 0)
		CloseTutorialMovie()
		AddTimer(4.0,gameover)
		--ClearAllGuideArrows()
		LogMetricsMilestoneEvent("ftue", "ftue_2000_apocalypsenow") -- analytic call for player using apocalypse spell
		PlaySFX("sfx_ftue_ApocalypseSpell")
		PlayMusicCue ("FTUE", "FTUE_04_Spell_Cast")
	end
end

function gameover()
--	PlaySwfMovie("Media/UI/IntroCinematic.swf") -- outro movie
	LogMetricsMilestoneEvent("ftue", "ftue_2100_splashscreenload") -- analytic call for end of ftue battle
	WinSilently()
end

function spawnendarmy()						-- spawns a particle effect and offset timer for the spawned unit then calls the function below to turn off damage
		handler1 = math.random() * 4.0
		handler2 = math.random() * 4.0
		handler3 = math.random() * 4.0
		handler4 = math.random() * 4.0

		AddTimer(handler1, PlayVFX,"PA_SpawnReinforcement", "pos1")
		AddTimer(handler1 + 2.0, SpawnOneEnemyUnit, "enemyarmy1")

		AddTimer(handler2, PlayVFX,"PA_SpawnReinforcement", "pos2")
		AddTimer(handler2 + 2.0, SpawnOneEnemyUnit, "enemyarmy2")

		AddTimer(handler3, PlayVFX,"PA_SpawnReinforcement", "pos3")
		AddTimer(handler3 + 2.0, SpawnOneEnemyUnit, "enemyarmy3")

		AddTimer(handler4, PlayVFX,"PA_SpawnReinforcement", "pos4")
		AddTimer(handler4 + 2.0, SpawnOneEnemyUnit, "enemyarmy4")

		AddTimer(20.0, spawnendarmy)
end

function SpawnOneEnemyUnit(spawnPoint)		-- turns off damage for each unit created, called each time a unit is spawned from the above function
	RespawnUnits(spawnPoint)

	local units = GetUnits("*", "*", 3) -- advancing Faction ADDED IN TURNING DAMAGE OFF FOR END ARMIES FIGHTING BATTLE HERE --
	for i,unit in pairs(units) do
		DisableAttackDamage(unit)
	end
end

function killtrigger1_onTriggerEnter(unit)
	doKillTrigger(unit, "killtrigger1")
end

function killtrigger2_onTriggerEnter(unit)
	doKillTrigger(unit, "killtrigger2")
end

function killtrigger3_onTriggerEnter(unit)
	doKillTrigger(unit, "killtrigger3")
end

function doKillTrigger(unit, triggerName)
	if unit.spawnId == "[START]Almarand" then

	elseif unit.side == 3 then
		local units = GetUnitsInTrigger(triggerName, 3)
		for i,unit in pairs(units) do
			if unit.spawnId ~= "[START]Almarand" and queuedKills[unit]==nil then
				queuedKills[unit] = True
				AddTimer(3.0, KillUnit, unit)
				AddTimer(6.0, doHide, unit)
			end
		end
	end
end

function doHide(unit)
	HideDeadUnit(unit)
	queuedKills[unit] = nil
end

-- -----------------------------			VISUAL PROPS  	---------------------------------------------------
function rainingfire()
  PlayVFXRandomLocation("PA_TutorialFireball", 50, 35, 0, 0, 300 )
  AddTimer(0.4+math.random(2), rainingfire)
end

--[[function raininghell()
	PlayVFX("PA_TutorialFireball", "strikes"..math.random(7))
	AddTimer(math.random(4), raininghell)
end]]

----------------------------------------------------------------------------------------------------------------

--										WRONG WAY HEADING SOUTH WARNING
-- if player heads south from start position
function wrongway_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(0.0, ShowDialog, "talkingheads/full/soldier", "TXT_BATTLETUTORIAL_6")  		-- change portrait!!
--		ShowGuideArrowForTrigger("Trigger1")
		Stopplayer()
	end
end

function Losetrigger_onTriggerEnter(unit)
	ShowDialog("talkingheads/full/soldier", "TXT_BATTLETUTORIAL_7")   -- change portrait!!
	AddTimer(3.0, Lose)
end
