SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

	CreateRandomisedListOfThings("List_Units","RagnarRaid1")
	CreateRandomisedListOfThings("List_Units2","MossmaneRaid1")
	CreateRandomisedListOfThings("List_Units3","ElithenRaid2")
	CreateRandomisedListOfThings("List_Units4","MilitiaRaid2")
	CreateRandomisedListOfThings("List_Units5","MilitiaRaid3")
	CreateRandomisedListOfThings("List_Units6","Unak2")
	CreateRandomisedListOfThings("List_Units7","MaidenRaid2")
	CreateRandomisedListOfThings("List_Units8","SkeletonRaid2")
	CreateRandomisedListOfThings("List_Units9","Mossmane1")
	CreateRandomisedListOfThings("List_Units10","Mossmane2")
	CreateRandomisedListOfThings("List_Units11","ArcherRaid1")
	

function onDeployStart()
	
	RespawnUnits("start", Army25)
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
	
end

function waveMultiplier()
	UseContestWaveMultiplier(10)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 10 then
			AddTimer(0.5, spawnWave2)
		end
		if destroyed == 22 then
			AddTimer(0.5, spawnWave3)
		end
		if destroyed == 34 then
			AddTimer(0.5, spawnWave4)
		end
		if destroyed == 47 then
			AddTimer(0.5, spawnWave5)
		end
		if destroyed == 61 then
			AddTimer(0.5, spawnWave6)
		end
		if destroyed == 74 then
			AddTimer(0.5, spawnWave7)
		end
		if destroyed == 88 then
		SetWinnable(true)
		end
	end
end

function spawnWave2()

	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25)  -- 1 raid skeleton
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  -- 1 raid militia
	
	RespawnUnits("Skeleton1", Army25)
	RespawnUnits("Skeleton2", Army25)
	RespawnUnits("Skeleton3", Army25)
	RespawnUnits("Skeleton4", Army25)
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  -- 1 unit
	RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  -- 1 unit
	RespawnUnits("Unak1", Army25)
	RespawnUnits("Spearman1", Army25)
	RespawnUnits("Militia1", Army25)
	RespawnUnits("Militia2", Army25)
	
end



function spawnWave3()


	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  -- 1 raid unit
	
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  -- 1 units
	RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  -- 1 units
	RespawnUnits("Skeleton5", Army25)
	RespawnUnits("Skeleton6", Army25)
	RespawnUnits("Maiden1", Army25)
	RespawnUnits("Maiden2", Army25)
	RespawnUnits("Militia1", Army25)
	RespawnUnits("Militia2", Army25)
	RespawnUnits("Unak1", Army25)
	
end

function spawnWave4()
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  -- 1 raid unit
	
	RespawnUnits("Spearman1", Army25)
	RespawnUnits("Unak1", Army25)
	RespawnUnits("Archer1", Army25)
	RespawnUnits("Spearman2", Army25)
	RespawnUnits("Militia1", Army25)
	RespawnUnits("Militia2", Army25)
	RespawnUnits("Ragnar1", Army25)
	RespawnUnits("Ragnar2", Army25)
	RespawnUnits("Mossmane2", Army25)
	
end


function spawnWave5()

	 RespawnUnits("Titan1", Titan5)
	 
	 RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  -- 1 raid unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  -- 1 raid unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units11"),Army25)  -- 1 raid unit
	 
	 RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  -- 1  unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  -- 1  unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  -- 1  unit
	 RespawnUnits("Archer1", Army25)
	 RespawnUnits("Spearman2", Army25)
	 RespawnUnits("Unak1", Army25)
	 RespawnUnits("Spearman1", Army25)
	 RespawnUnits("Skeleton5", Army25)
	 RespawnUnits("Maiden1", Army25)
	 RespawnUnits("Maiden2", Army25)
	 
end


function spawnWave6()

	RespawnUnits("Titan2", Titan5)
	
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  -- 1 raid unit
	
	RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  -- 1  unit
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  -- 1  unit
	RespawnUnits("Archer1", Army25)
	RespawnUnits("Spearman2", Army25)
	RespawnUnits("Unak1", Army25)
	RespawnUnits("Spearman1", Army25)
	RespawnUnits("Maiden1", Army25)
	RespawnUnits("Maiden2", Army25)
	
end


function spawnWave7()


	
	RespawnUnits("Titan3", Titan6)
	
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  -- 1 raid unit
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  -- 1 raid unit
	
	 RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  -- 1  unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  -- 1  unit
	 RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  -- 1  unit
	 RespawnUnits("Archer1", Army25)
	 RespawnUnits("Spearman2", Army25)
	 RespawnUnits("Unak1", Army25)
	 RespawnUnits("Spearman1", Army25)
	 RespawnUnits("Skeleton5", Army25)
	 RespawnUnits("Maiden1", Army25)
	
end



function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_10_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_10_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_10_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_10_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

