SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

	CreateRandomisedListOfThings("List_Units","GroupTopLeftNormal3","GroupTopLeftNormal5","GroupTopLeftNormal7")
	CreateRandomisedListOfThings("List_Units1","GroupMiddleLeftNormal4","GroupMiddleLeftNormal7")
	CreateRandomisedListOfThings("List_Units2","GroupBottomLeftNormal3","GroupBottomLeftNormal6")
	CreateRandomisedListOfThings("List_Units3","GroupBottomMiddleNormal5","GroupBottomMiddleNormal8")
	CreateRandomisedListOfThings("List_Units4","GroupBottomRightNormal1","GroupBottomRightNormal4")
	CreateRandomisedListOfThings("List_Units5","GroupMiddleRightNormal4","GroupMiddleRightNormal8")
	CreateRandomisedListOfThings("List_Units6","GroupTopRightNormal3","GroupTopRightNormal4","GroupTopRightNormal7")
	CreateRandomisedListOfThings("List_Units7","GroupTopMiddleNormal1","GroupTopMiddleNormal5","GroupTopMiddleNormal6")

	CreateRandomisedListOfThings("List_Units8","GroupTopLeftRaid1")
	CreateRandomisedListOfThings("List_Units9","GroupMiddleLeftRaid1")
	CreateRandomisedListOfThings("List_Units10","GroupBottomLeftRaid1")
	CreateRandomisedListOfThings("List_Units11","GroupBottomMiddleRaid1")
	CreateRandomisedListOfThings("List_Units12","GroupBottomRightRaid2")
	CreateRandomisedListOfThings("List_Units13","GroupMiddleRightRaid2")
	CreateRandomisedListOfThings("List_Units14","GroupTopRightRaid1")
	CreateRandomisedListOfThings("List_Units15","GroupTopMiddleRaid3")
	
	CreateRandomisedListOfThings("List_Units16","TitanB")
	CreateRandomisedListOfThings("List_Units17","TitanC")
	CreateRandomisedListOfThings("List_Units18","TitanF")


function onDeployStart()
	
	RespawnUnits("SkeletonRaid2", Army25)
	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units14"),Army25)  
	
	RespawnUnits("Skeleton1", Army25)
	RespawnUnits("Skeleton2", Army25)
	RespawnUnits("GroupTopLeftNormal3", Army25)
	RespawnUnits("GroupTopLeftNormal6", Army25)
	RespawnUnits("GroupTopRightNormal8", Army25)
	RespawnUnits("GroupTopRightNormal4", Army25)
	RespawnUnits("GroupMiddleRightNormal1", Army25)
	RespawnUnits("GroupMiddleLeftNormal1", Army25)
	
	
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	--GiveDefenderSpoil("D_6")
	--GiveDefenderSpoil("D_7")
	--GiveDefenderSpoil("D_8")
	--GiveDefenderSpoil("D_9")
	--GiveDefenderSpoil("D_10")

	--GiveDefenderSpoil("D_16")
	--GiveDefenderSpoil("D_17")
	--GiveDefenderSpoil("D_18")
	--GiveDefenderSpoil("D_19")
	--GiveDefenderSpoil("D_20")
	
	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
	AddTimer(0.3, waveMultiplier)
	
	
end

function waveMultiplier()
	UseContestWaveMultiplier(11)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 11 then
			AddTimer(0.5, spawnWave2)
		end
		if destroyed == 23 then
			AddTimer(0.5, spawnWave3)
		end
		if destroyed == 36 then
			AddTimer(0.5, spawnWave4)
		end
		if destroyed == 49 then
			AddTimer(0.5, spawnWave5)
		end
		if destroyed == 63 then
			AddTimer(0.5, spawnWave6)
		end
		if destroyed == 78 then
			AddTimer(0.5, spawnWave7)
		end
		if destroyed == 93 then
		SetWinnable(true)
		end
	end
end

function spawnWave2()

	--GiveDefenderSpoil("D_1")
	--GiveDefenderSpoil("D_2")
	--GiveDefenderSpoil("D_3")
	--GiveDefenderSpoil("D_4")
	--GiveDefenderSpoil("D_5")


	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units14"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units15"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	
end



function spawnWave3()

	--GiveDefenderSpoil("D_1")
	--GiveDefenderSpoil("D_2")
	--GiveDefenderSpoil("D_3")
	--GiveDefenderSpoil("D_4")
	--GiveDefenderSpoil("D_5")
	
	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units14"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units15"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  
	
end

function spawnWave4()

	--GiveDefenderSpoil("D_1")
	--GiveDefenderSpoil("D_2")
	--GiveDefenderSpoil("D_3")
	--GiveDefenderSpoil("D_4")
	--GiveDefenderSpoil("D_5")
	
	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units14"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units13"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	

	
end


function spawnWave5()

	--GiveDefenderSpoil("D_1")
	--GiveDefenderSpoil("D_2")
	--GiveDefenderSpoil("D_3")
	--GiveDefenderSpoil("D_4")
	--GiveDefenderSpoil("D_5")

	RespawnUnits(GetRandomisedRandomThing("List_Units16"),Titan6) 
	
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units13"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units12"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  

end


function spawnWave6()

	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")

	RespawnUnits(GetRandomisedRandomThing("List_Units17"),Titan6) 
	
	RespawnUnits(GetRandomisedRandomThing("List_Units8"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units9"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units10"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units11"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units12"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	
end


function spawnWave7()

	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	
	RespawnUnits(GetRandomisedRandomThing("List_Units18"),Titan6) 
	
	RespawnUnits(GetRandomisedRandomThing("List_Units11"),Army25) 
	RespawnUnits(GetRandomisedRandomThing("List_Units12"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units13"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units14"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units15"),Army25)  
	
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units1"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units4"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units5"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units6"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units7"),Army25)  
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army25)  
	
end



function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_11_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_11_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_11_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_11_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

