SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0

math.randomseed(os.time())
local randomSpawn6 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

CreateRandomisedListOfThings("List_Units","Group1")
CreateRandomisedListOfThings("List_Units2","Group4")
CreateRandomisedListOfThings("List_Units3","SkeletonRaid1","SkeletonRaid2")

function onDeployStart()
	SpawnUnits("SkeletonRaid1", Army19)
	SpawnUnits("SkeletonRaid2", Army19)
	SpawnUnits("Group2", Army19) -- 2 units
	SpawnUnits("Group4", Army19) -- 2 units
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	GiveDefenderSpoil("H_5_5")
	GiveDefenderSpoil("H_77_5")
	GiveDefenderSpoil("H_6_10")
	GiveDefenderSpoil("H_289_10")
	GiveDefenderSpoil("H_63_10")
	GiveDefenderSpoil("H_401_10")
	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(3)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			AddTimer(0.5, vfxWave2)
			AddTimer(1.5, spawnWave2)
		end
		if destroyed == 13 then
			AddTimer(0.5, vfxWave3)
			AddTimer(1.5, spawnWave3)
		end
		if destroyed == 21 then
			AddTimer(0.5, vfxWave4)
			AddTimer(1.5, spawnWave4)
		end
		if destroyed == 29 then
			AddTimer(0.5, vfxWave5)
			AddTimer(1.5, spawnWave5)
		end
		if destroyed == 36 then
			AddTimer(0.5, vfxWave6)
			AddTimer(1.5, spawnWave6)
		end
		if destroyed == 41 then
		SetWinnable(true)
		end
	end
end

function vfxWave2()
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft1")
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft2")
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft3")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight1")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight2")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight3")
end

function spawnWave2()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army19)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army19)  -- 2 units
	RespawnUnits("ArcherTopRight1", Army19)
	RespawnUnits("ArcherTopLeft1", Army19)
	RespawnUnits("SkeletonRight1", Army19)
end

function vfxWave3()
	PlayVFX("PA_SpawnReinforcement", "vfxTop1")
	PlayVFX("PA_SpawnReinforcement", "vfxTop2")
	PlayVFX("PA_SpawnReinforcement", "vfxTop3")
	PlayVFX("PA_SpawnReinforcement", "vfxTop4")
end

function spawnWave3()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army20)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army20)  -- 2 units
	RespawnUnits("UnakTopRaid1", Army20)
	RespawnUnits("UnakTopRaid2", Army20)
	RespawnUnits("SkeletonRight1", Army20)
	RespawnUnits("SkeletonLeft1", Army20)
end

function vfxWave4()
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft1")
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft2")
	PlayVFX("PA_SpawnReinforcement", "vfxTopLeft3")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight1")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight2")
	PlayVFX("PA_SpawnReinforcement", "vfxTopRight3")
end

function spawnWave4()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army20)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army20)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units3"),Army20)  -- 1 unit
	RespawnUnits("ArcherTopLeftRaid1", Army20)
	RespawnUnits("ArcherTopRightRaid1", Army20)
	RespawnUnits("SkeletonRight1", Army20)	
end

function vfxWave5()
	PlayVFX("PA_SpawnReinforcement", "vfxTop1")
	PlayVFX("PA_SpawnReinforcement", "vfxTop2")
	PlayVFX("PA_SpawnReinforcement", "vfxTop3")
	PlayVFX("PA_SpawnReinforcement", "vfxTop4")
end

function spawnWave5()
	RespawnUnits("UnakTopRaid1", Army21)
	RespawnUnits("UnakTopRaid2", Army21)
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army21)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army21)  -- 2 units
	RespawnUnits("SkeletonLeft1", Army21)	
end

function vfxWave6()
	
end

function spawnWave6()
	RespawnUnits("Titan", Titan3)
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army22)  -- 2 units
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army22)  -- 2 units
end


function introText()
	randomIntroText1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_3_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_3_TALKING_HEAD_V2","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_3_TALKING_HEAD_V3","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)

	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	
end

