SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0

math.randomseed(os.time())
local randomSpawn6 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

CreateRandomisedListOfThings("List_Units","MossmaneGroupLeft1")

function onDeployStart()
	SpawnUnits("start", Army21)
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	GiveDefenderSpoil("H_47_5")
	GiveDefenderSpoil("H_99_5")
	GiveDefenderSpoil("H_48_10")
	GiveDefenderSpoil("H_100_10")
	GiveDefenderSpoil("H_365_10")
	GiveDefenderSpoil("EV_316_10")
	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	AddTimer(0.3, waveMultiplier)
	
	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(5)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			AddTimer(0.5, vfxWave2)
			AddTimer(1.5, spawnWave2)
		end
		if destroyed == 14 then
			AddTimer(0.5, vfxWave3)
			AddTimer(1.5, spawnWave3)
		end
		if destroyed == 21 then
			AddTimer(0.5, vfxWave4)
			AddTimer(1.5, spawnWave4)
		end
		if destroyed == 28 then
			AddTimer(0.5, vfxWave5)
			AddTimer(1.5, spawnWave5)
		end
		if destroyed == 37 then
			AddTimer(0.5, vfxWave6)
			AddTimer(1.5, spawnWave6)
		end
		if destroyed == 44 then
			AddTimer(0.5, vfxWave7)
			AddTimer(1.5, spawnWave7)
		end
		if destroyed == 52 then
		SetWinnable(true)
		end
	end
end

function vfxWave2()
	
end

function spawnWave2()
	RespawnUnits("MossmaneCloseLeft1", Army21)
	RespawnUnits("MossmaneCloseRight1", Army21)
	RespawnUnits("MossmaneRaidMiddle1", Army21)
	RespawnUnits("MilitiaRaidLeft1", Army21)
	RespawnUnits("MilitiaCloseLeft1", Army21)
	RespawnUnits("MilitiaCloseRight1", Army21)
	RespawnUnits("MossmaneMiddle1", Army21)
end

function vfxWave3()
	
end

function spawnWave3()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army21)  -- 1 raid troop + 1 normal troop
	RespawnUnits("MilitiaRaidLeft1", Army21)
	RespawnUnits("SkeletonRaidMiddle1", Army21)
	RespawnUnits("MossmaneRaidMiddle1", Army21)
	RespawnUnits("UnakCloseRight1", Army21)
	RespawnUnits("UnakCloseLeft1", Army21)
end

function vfxWave4()
	
end

function spawnWave4()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army22)  -- 1 raid troop + 1 normal troop
	RespawnUnits("UnakRaidTop1", Army22)
	RespawnUnits("MossmaneCloseLeft1", Army22)
	RespawnUnits("MossmaneCloseRight1", Army22)
	RespawnUnits("MossmaneRaidMiddle1", Army22)
	RespawnUnits("MilitiaFarRight1", Army22)
end

function vfxWave5()
	
end

function spawnWave5()
	RespawnUnits("MossmaneGroupLeft1", Army23) -- 1 raid + 1 normal
	RespawnUnits("MossmaneGroupRight1", Army23) -- 1 raid + 1 normal
	RespawnUnits("MossmaneRaidMiddle1", Army23)
	RespawnUnits("MilitiaFarRight1", Army23)
	RespawnUnits("MilitiaFarLeft1", Army23)
	RespawnUnits("SkeletonBottomRight1", Army23)
	RespawnUnits("SkeletonBottomLeft1", Army23)

end

function vfxWave6()
	
end

function spawnWave6()
	RespawnUnits("Titan1", Titan3)
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army24)  -- 1 raid troop + 1 normal troop
	RespawnUnits("MilitiaRaidLeft1", Army24)
	RespawnUnits("SpearmanCloseRight1", Army24)
	RespawnUnits("MilitiaCloseLeft1", Army24)
	RespawnUnits("UnakCloseLeft1", Army24)
end

function vfxWave7()
	
end

function spawnWave7()
	RespawnUnits("Titan2", Titan4)
	RespawnUnits("MossmaneRaidCloseLeft1", Army25)
	RespawnUnits("MossmaneRaidCloseRight1", Army25)
	RespawnUnits("MilitiaCloseRight1", Army25)
	RespawnUnits("SpearmanCloseRight1", Army25)
	RespawnUnits("MilitiaCloseLeft1", Army25)
	RespawnUnits("UnakCloseLeft1", Army25)
	RespawnUnits("SkeletonBottomLeft1", Army25)
end


function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_5_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_5_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_5_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_5_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

