

destroyed = 0
SpellLevel = 0
Army = 0
Rank = 0



function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	AddTargetCircle("protect")													-- central circle shows the place to protect
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 3 then
			SpellLevel = 1
			Army = 1
		elseif Rank >= 4 then
			SpellLevel = Rank -2
			Army = Rank -3						
	end
end


function onLevelStart()
	SetupVictoryBar()
	SetTriggerCallbacks("protect", protect_onTriggerEnter) -- central area player is supposed to protect
	RespawnUnits("rand1", Army)
	AddTimer(1.0,  FireText)
	
end

function FireText()
	ShowDialog("talkingheads/full/Kobar","TXT_FORTWAVES1_WAVE1")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_FORTWAVES1_INTRO")
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			SpawnUnits("rand2", Army)
			ShowDialog ("talkingheads/full/Kobar", "TXT_FORTWAVES1_WAVE2")
		elseif destroyed == 6 then
			SpawnUnits("rand3", Army)
			ShowDialog ("talkingheads/full/Kobar", "TXT_FORTWAVES1_WAVE3")
		elseif destroyed == 11 then
			SpawnUnits("rand4", Army)
			ShowDialog ("talkingheads/full/Kobar", "TXT_FORTWAVES1_WAVE4")
			SetWinnable(true)
		end
	end
end



function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(4/14)
	AddVictoryBarMarker(6/14)
	AddVictoryBarMarker(11/14)
	AddVictoryBarMarker(1.0)
end
















