
turn = 0
destroyed = 0
SpellLevel = 0
Army = 0



function onDeployStart()
	createStartingTroops(False)
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	CreateRandomisedListOfThings("rand1","rand2","rand3","rand4")
	AddTargetCircle("protect")													-- central circle shows the place to protect
	DisableNecromancer()														-- no necro to revive the dead
end

function createStartingTroops(forPlinthInspector)
	local Rank = GetPlayerCastleLevel()
		if Rank <= 3 then
			SpellLevel = 1
			Army = 1
		elseif Rank == 4 then
			SpellLevel = 2
			Army = 2
		elseif Rank == 5 then
			SpellLevel = 3
			Army = 3
		elseif Rank == 6 then
			SpellLevel = 4
			Army = 4
		elseif Rank == 7 then
			SpellLevel = 5
			Army = 5
		elseif Rank == 8 then
			SpellLevel = 6
			Army = 6
		elseif Rank == 9 then
			SpellLevel = 7
			Army = 7
		elseif Rank == 10 then
			SpellLevel = 8
			Army = 8
		elseif Rank == 11 then
			SpellLevel = 9
			Army = 9
		elseif Rank == 12 then
			SpellLevel = 10
			Army = 10
		elseif Rank > 13 then
			SpellLevel = 11
			Army = 11
		elseif Rank > 14 then
			SpellLevel = 12
			Army = 12
		elseif Rank > 15 then
			SpellLevel = 13
			Army = 13
		elseif Rank > 16 then
			SpellLevel = 14
			Army = 14	
		elseif Rank > 17 then
			SpellLevel = 15
			Army = 15	
		elseif Rank > 18 then
			SpellLevel = 16
			Army = 16	
		elseif Rank > 19 then
			SpellLevel = 17
			Army = 17
		elseif Rank > 20 then
			SpellLevel = 18
			Army = 18
		elseif Rank > 21 then
			SpellLevel = 19
			Army = 19
		elseif Rank > 22 then
			SpellLevel = 20
			Army = 20		
		elseif Rank > 23 then
			SpellLevel = 21
			Army = 21	
		elseif Rank > 24 then
			SpellLevel = 22
			Army = 22	
		elseif Rank > 25 then
			SpellLevel = 23
			Army = 23				
	end
end

function onLevelStart()
	SetupVictoryBar()
	SetTriggerCallbacks("protect", protect_onTriggerEnter) -- central area player is supposed to protect
	RespawnUnits("rand1", Army)
	RespawnUnits("rand2", Army)
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogDismiss("talkingheads/full/guard","TXT_SP21_1")
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
	end
	if destroyed == 2 then
		RespawnUnits("rand1", Army)
	end
	if destroyed == 4 then
		RespawnUnits("rand2", Army)
	end
	if destroyed == 6 then
		RespawnUnits("rand3", Army)
		SetWinnable(true)
	end
end


function protect_onTriggerEnter(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_SP21_2")
		AddTimer(3.0, gameover)
		
	end
end


function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(2/10)
	AddVictoryBarMarker(4/10)
	AddVictoryBarMarker(6/10)
	AddVictoryBarMarker(1.0)
end



function gameover()
	Lose()
end
















