

destroyed = 0
enemydead = 0
placement = 0
rearguard = 0
standing = 0
happenonce = 0
pnum = {}
endzone = 0
Respawns = 0
SpellLevel = 0
Army = 5
Army1 = 5
Army2 = 5
Rank = 0


function onDeployStart()
	createStartingTroops(False)  -- This part here
	AddTargetCircle("moveto2")   -- move to targets for player 
	AddTargetCircle("moveto1")	-- move to targets for player

end



function onLevelStart()
	SetVictoryBarEnabled(false)
	AddTimer(240, outoftime) -- set lose condition to kick in after 4 minutes
	SetWinnable(false)	-- level cannot be completed even if no enemy units are alive
	SetTriggerCallbacks("moveto1", moveto1_onTriggerEnter)
	SetTriggerCallbacks("moveto2", moveto2_onTriggerEnter)
	SetTriggerCallbacks("waitzone", waitzone_onTriggerEnter)
	SetTriggerCallbacks("startattack", startattack_onTriggerEnter)
	SetTriggerCallbacks("early",earlyattack_onTriggerEnter)
	--SetPanningCamera(47, -149, 59.5, -0.59, -0.68) -- focusX, focusY, zoom, heading, pitch
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 5
	SpellLevel = 3
	Army = 5

--		SpawnUnits("spawn1",Army) 
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army1) 
		SpawnUnits("spawn3",Army1)		
		SpawnUnits("early1",Army)
		SpawnUnits("spawn4",Army2)
	end
end


function outoftime()		-- lose condition fires after 4 minute timer reaches zero
	Lose()
end

function onCameraAnimationFinish(cameraName)
  if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard", "TXT_SP9_1")
  end
end

function onUnitSelected(unit)

end

function onUnitDeselected()

end

function earlyattack_onTriggerEnter(unit)
  SpawnUnits("early1",Army)
  HideDialog()
  ShowDialog("talkingheads/full/guard","TXT_SP9_12")
end


function moveto1_onTriggerEnter(unit)
	placement = placement + 1
	if unit.attacker then
		HideDialog()
		DisableTrigger("moveto1")
		ShowDialog("talkingheads/full/guard","TXT_SP9_3")
		positioncheck()
	end
end


function moveto1_onTriggerLeave(unit)
	if unit.attacker then
		placement = placement -1
	end
end



function moveto2_onTriggerEnter(unit)
	rearguard = rearguard + 1
	if unit.attacker then
		HideDialog()
		DisableTrigger("moveto2")
		ShowDialog("talkingheads/full/guard","TXT_SP9_4")	
		positioncheck()
	end
end


function moveto2_onTriggerLeave(unit)
	rearguard = rearguard - 1
end


--[[function onUnitOrderGiven(unit, orderType)
	if orderType == "STAND_GROUND" then
		standing = standing + 1
	end
	if standing == #pnum then
	end
end]]


function positioncheck()
	if placement >= 1 and rearguard >= 1 then
		DisableTrigger("moveto1")
		DisableTrigger("moveto2")
		DisableTrigger("early")
		AddTimer(8.0 , patrolstarts)
		ClearTargetCircles()  
	end
end


function patrolstarts()
	HideDialog()
	ShowDialog("talkingheads/full/guard","TXT_SP9_6","this popup at 0 second")
	SpawnUnits("spawn1",Army) 
	SetVictoryBarEnabled(true)
	AddTimer(8.0,wave2)
end

function wave2()
	SpawnUnits("spawn2",Army)   
	AddTimer(20.0,wave3)
end

function wave3()
	SpawnUnits("spawn3",Army)
	SpawnUnits("spawn4",Army2)
	SetWinnable(true) 
end

function waitzone_onTriggerEnter(unit)
	if unit.spawnId == "spawn1" then
		DisableTrigger("waitzone")
--		ShowDialog("talkingheads/full/guard","TXT_SP9_11","this popup at 0 second")
	end
end


function startattack_onTriggerEnter(unit)
	if unit.defender then
		HideDialog()
		ShowDialog("talkingheads/full/guard","TXT_SP9_8","this popup at 0 second")
		DisableTrigger("startattack")
	end
end













