Army = 1
Army1 = 2
Army2 = 1
destroyed = 0

escortDead = false
escortComplete = false

function onDeployStart()
--	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("spawn_wave2", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
--	SetTriggerCallbacks("spawn_wave3", onTriggerEnter_spawn_wave3)
	SetTriggerCallbacks("spawn_lastwave", onTriggerEnter_spawn_lastwave)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	SetWinnable(false)
	SetStandGuardButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
--	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MISSIONSP_C3M1_1","BOTTOM_LEFT")
--	AddTargetCircle("pikeman_start")
	AddTargetCircle("waypoint_1a")
	AddTimer(4.5, showGoal)
	--
	-- <Kooz> DOT-24527: Show banner icons for allied units
--	local units = GetUnits("*", "*", 2)
--	for i,unit in pairs(units) do
--		SetForceShowBannerIcon(unit, true)
--	end
end

function onLevelStart()
--	SetAlliedPlayers(0,2)
--	SetEnemyPlayers(1,2)
--	SetVictoryBarEnabled(false)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
end

function showGoal()
	FrameCamera("waypoint_1a")
	AddTimer(3.0, camReturn1)
	AddTimer(4.5, showCave)
	AddTimer(4.0, removeText)
end

function showCave()
	FrameCamera("cave")
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MISSIONSP_C3M1_2","BOTTOM_LEFT")
	AddTimer(4.0, camReturn2)
	AddTimer(4.0, removeText)
end

function removeText()
	HideDialog()
end

function camReturn1()
	ReturnCamera()
end

function camReturn2()
	ReturnCamera()
	EnableControls()
end

function EnableControls()
	SetStandGuardButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function onTriggerEnter_Start_Zone(unit)
	if unit.attacker then
		DisableTrigger("start_zone")
--		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
		AddTimer(4,SpawnWaveOne)
--		moveStartTo1A()
	end
end

--[[
function moveStartTo1A()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
	AddTimer(4.0, moveStartTo1A)
end

function waypoint1ADelay(unit)
	SetUnitStandGuard(unit, false)
--	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	AddTimer(2,SpawnWaveTwo)
end
--]]

function onTriggerEnter_Waypoint1B(unit)
	if unit.attacker then
		AddTimer(1,SpawnWaveTwo)
		DisableTrigger("spawn_wave2")
	end
end
	
function onTriggerEnter_spawn_lastwave(unit)
	if unit.attacker then
		AddTimer(1,SpawnLastWave)
		DisableTrigger("spawn_lastwave")
	end
end

function SpawnWaveOne()
	ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN8D_2_3","BOTTOM_LEFT")
	AddTimer(3.5, removeText)
	SpawnUnits("wave1",Army1)
end

function SpawnWaveTwo()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_4")
	SpawnUnits("wave2",Army1)
end

function SpawnLastWave()
--	ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN8D_2_5","BOTTOM_LEFT")
--	AddTimer(3.5, removeText)
	SpawnUnits("lastwave",Army)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1a)
		end
	end
end
	
function onTriggerEnter_Waypoint1a(unit)
	if unit.attacker then
		DisableTrigger("waypoint_1a")
		AddTimer(3,finish) 
		end
	end

function finish()
	ClearTargetCircles()
	Win()
end

--[[
function onTriggerEnter_Waypoint1A(unit)
	if unit.attacker then
		AddTimer(3, LevelComplete)
		DisableTrigger("waypoint_1a")
	end
end

function LevelComplete()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_6")
	AddTimer(2, Win)
end
--]]

function createStartingTroops(forPlinthInspector)
	--SpawnUnits("startTitan")
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("wave1",Army1)
		SpawnUnits("wave2",Army1)
		SpawnUnits("lastwave",Army)
	end
end

--[[
function onTriggerEnter_Waypoint1A(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1a")
		SetUnitStandGuard(unit, true)
		AddTimer(1,finish) -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
--		escortComplete = true
		ClearTargetCircles()
		
		enemyUnits =  GetUnits("*", "*", 1)
		if #enemyUnits > 0 then
			ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN8D_2_7","BOTTOM_LEFT")
			AddTimer(3.5, removeText)
		else
			LevelComplete()
		end
	
	end
end

function finish() -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
	Win()
end
--]]


--[[]
function onUnitDestroyed(unit)
	if unit.spawnId == "movingUnit_[start]" then
	
		ShowDialogInPosition("talkingheads/full/guard","TXT_MISSIONSP_C3M1_3","BOTTOM_LEFT")
		
		escortDead = true
		AddTimer(2,Lose)
	elseif unit.defender then -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
		destroyed = destroyed + 1
		if destroyed == 7 then
			Win()
		end
	end
	elseif unit.defender then
		if escortComplete then
			enemyUnits =  GetUnits("*", "*", 1)
			if #enemyUnits == 0 then
				LevelComplete()
			end
		end

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		HideDialog()
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_2")
		--AddTargetCircleWithArrow("start_zone")
	end

--]]
