-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 18
Army = 10
Army1 = 9
Army2 = 8

CreateRandomisedListOfThings("List_Units","Spawn4a","Spawn4b")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN10_5_2","BOTTOM_LEFT")
	ShowDialogInPosition("talkingheads/full/guard","TXT_SP21_1","BOTTOM_LEFT")
	AddTargetCircleWithArrow("highlight")
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(7.0, enableControls)
	--SpawnUnits("Enemy")
	SetTriggerCallbacks("skeletonTrigger", enter_onTriggerEnterSkeleton)
	SetTriggerCallbacks("charge", enter_onTriggerEnterCharge)
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("lossArea", enter_onTriggerEnter)
	--ClearTargetCircles()
	AddTimer(16.0, spawnWave1)
	--AddTimer(50.0, moveUnits)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

--function moveUnits()
	--GiveNamedUnitMoveOrder("Wave2","lossArea")
	--GiveNamedUnitMoveOrder("Wave3","lossArea")
	--GiveNamedUnitMoveOrder("Wave4a","lossArea")
	--GiveNamedUnitMoveOrder("Wave4b","lossArea")
	--GiveNamedUnitMoveOrder("Wave5","lossArea")
	--GiveNamedUnitMoveOrder("Titan","lossArea")
	--AddTimer(15.0, moveUnits)
--end

function triggercheck()
	local var1 = CountDefendersInTrigger("lossArea")
	local var2 = CountAttackersInTrigger("lossArea")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 and var2 > 0 then
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true
		AddTimer(2.5, triggercheck2)
	end 
	--Success()
	
end

function triggercheck2()
	local var1 = CountDefendersInTrigger("lossArea")
	if var1 == 1 then 
		ShowDialogInPosition("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_3_LOSE","BOTTOM_LEFT")
		Lose()
	elseif var1 > 0 then
		triggercheck()
	end 
	--Success()
	
end

function enter_onTriggerEnter(unit)
	triggercheck()
	AddTimer(3.0, enter_onTriggerEnter)
end

function spawnWave1()
	SpawnUnits("Wave1",Army)
	AddTimer(20.0, spawnWave2)
end

function spawnWave2()
	SpawnUnits("Wave2",Army2)
	AddTimer(20.0, spawnWave3)
end

function spawnWave3()
	SpawnUnits("Wave3",Army1)
	AddTimer(20.0, spawnWave4)
end

function spawnWave4()
	SpawnUnits("Wave4a",Army2)
	SpawnUnits("Titan",Titan)
	AddTimer(10.0, spawnWave5)
end

function spawnWave5()
	SpawnUnits("Wave5",Army2)
end

--function enter_onTriggerEnterCharge(unit)
	--GiveUnitMoveOrder("Enemy","charge")
	--GiveUnitMoveOrder("Skeleton","charge")
	--DisableTrigger("charge")
--end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 19 then
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Wave1",Army)
		SpawnUnits("Wave2",Army2)
		SpawnUnits("Wave3",Army1)
		SpawnUnits("Wave4a",Army2)
		SpawnUnits("Titan",Titan)
		SpawnUnits("Wave5",Army2)
	end	
end
