-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 25
Army = 10
Army1 = 9
Army2 = 9

CreateRandomisedListOfThings("List_Units","Spawn4a","Spawn4b")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	AddTimer(5.0, framecamera)
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(7.0, enableControls)
	SpawnUnits("Titan",Titan)
	SpawnUnits("Ranged",Army1)
	SpawnUnits("Melee",Army)
	SpawnUnits("Melee2",Army2)
end

function framecamera()
	AddTargetCircle("titan")
	FrameCamera("camera")
	ShowDialogInPosition("talkingheads/full/guard","TXT_STORY_TEXT_CAMPAIGN9GRIND7","BOTTOM_LEFT")
	AddTimer(4.0, ReturnCamera)
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("charge1", enter_onTriggerEnterRagnar)
	SetTriggerCallbacks("skeleton", enter_onTriggerEnterSkeleton)
	ClearTargetCircles()
	--AddTimer(16.0, spawnWave1)
	--AddTimer(50.0, moveUnits)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnterRagnar(unit)
	SpawnUnits("Ragnar",Army2)
	--ShowDialogInPosition("Portraits/Guard_talkinghead","Ragnar from the flanks!*","BOTTOM_LEFT")
	--Standstill()
	DisableTrigger("charge1")
end

function enter_onTriggerEnterSkeleton(unit)
	--ShowDialogInPosition("Portraits/Guard_talkinghead","The undead are spawning around us!*","BOTTOM_LEFT")
	SpawnUnits("Skeleton",Army2)
	--Standstill()
	DisableTrigger("skeleton")
end

function Standstill() -- tells the unit to stand ground
                local units = GetUnits("*", "*", 0)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 22 then
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("Ranged",Army1)
		SpawnUnits("Melee",Army)
		SpawnUnits("Melee2",Army2)
		SpawnUnits("Ragnar",Army2)
		SpawnUnits("Skeleton",Army2)
	end		
end
