-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 30
Army = 14
Army1 = 13
Army2 = 12
Army3 = 11

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function onDeployStart()
	-- register the triggers in the level
	--AddTimer(4.5, framecamera)
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("Enemy")
	SpawnUnits("Wave1",Army2)
	SpawnUnits("Wave2",Army1)
	SpawnUnits("Wave3",Army)
	SpawnUnits("Wave4",Army)
	SpawnUnits("Wave5",Army3)
	SpawnUnits("Titan",Titan)
end



-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("centre", enter_onTriggerEnter)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("Skeleton",Army)
		DisableTrigger("centre")
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 24 then
			Win()
		end
	end
end


function createStartingTroops(forPlinthInspector)
	--SpawnUnits("Wall")
	if forPlinthInspector then
		SpawnUnits("Enemy")
		SpawnUnits("Wave1",Army2)
		SpawnUnits("Skeleton",Army)
		SpawnUnits("Wave2",Army1)
		SpawnUnits("Wave3",Army)
		SpawnUnits("Wave4",Army)
		SpawnUnits("Wave5",Army3)
		SpawnUnits("Titan",Titan)
	end
end
