SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
captured = false
wave_count = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_INTRO")
	createStartingTroops(False)  -- This establishes the scaling and what shows on the plinth inspector
	AddTargetCircle("trigger2")
end

function onLevelStart()
	SetupVictoryBar()
	SetVictoryBarFill(0)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetWinnable(false)	
	AddTimer(20.0, triggercheck)
	SetBattleTimeoutTime(145)
	AddTimer(1.0, Move1)
	AddTimer(40.0, Mission1)
end

function trigger1_onTriggerEnter(unit)

	if unit.attacker then
		ClearTargetCircles()
	end

end

--Victory Conditions Start

function triggercheck()
	local var1 = CountDefendersInTrigger("trigger1")
	
	local var2 = CountAttackersInTrigger("trigger1")
	if var1 > var2 then
	 captured = true
	elseif var1 < var2 then
	 captured = false
	end 
	Success()
end

function Success()
	AddTimer(1.0, triggercheck)
	if captured == true then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_FAIL")
		AddTimer(2.0, Fail)
		DisableTrigger("trigger2")
	end

end

function Fail()
	Lose()
end

function Mission1()
	if captured == false and wave_count == 1 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx1")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 2 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx4")
		PlayVFX("PA_SpawnReinforcement", "fx5")
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_WAVE1")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 3 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx6")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 4 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx8")
		PlayVFX("PA_SpawnReinforcement", "fx9")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 5 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx8")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 6 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx6")
		PlayVFX("PA_SpawnReinforcement", "fx7")
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_WAVE2")
		AddTimer(12.0, Mission1)
	elseif captured == false and wave_count == 7 then
		AddTimer(1.0, SpawnDudes)
		PlayVFX("PA_SpawnReinforcement", "fx4")
		AddTimer(12.0, Mission1)	
	elseif captured == false and wave_count == 8 then
		AddTimer(1.0, SpawnDudes)
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_WAVE3")
		PlayVFX("PA_SpawnReinforcement", "fx1")
		PlayVFX("PA_SpawnReinforcement", "fx2")
		PlayVFX("PA_SpawnReinforcement", "fx3")
		AddTimer(12.0, Victory)
	end
end

function SpawnDudes()

	if captured == false and wave_count == 1 then
		RespawnUnits("spawn1a", Army2)
		Move1()
	elseif wave_count == 2 then
		RespawnUnits("spawn2", Army1)
		RespawnUnits("spawn2a", Army2)
		Move1()
	elseif wave_count == 3 then
		RespawnUnits("spawn3a", Army2)
		Move1()
	elseif wave_count == 4 then
		RespawnUnits("spawn4", Army1)
		RespawnUnits("spawn4a", Army2)
		Move1()
	elseif wave_count == 5 then
		RespawnUnits("spawn4a", Army2)
		Move1()
	elseif wave_count == 6 then
		RespawnUnits("spawn3", Army1)
		RespawnUnits("spawn3a", Army2)
		Move1()	
	elseif wave_count == 7 then
		RespawnUnits("spawn2a", Army2)
		Move1()
	elseif wave_count == 8 then
		RespawnUnits("spawn1", Army1)
		RespawnUnits("spawn1a", Army2)
		SpawnUnits("titan",Army2)
		Move1()
	end

end

function Victory()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING_3_6_VICTORY")
	Win()
end

--Victory Conditions End

--Move Functions

function Move1()
	wave_count = wave_count + 1
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger2")
	end
end

--End Move Functions

--Here is where the ranking of the grind will be made for enemy levels

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(1/8)
	AddVictoryBarMarker(2/8)
	AddVictoryBarMarker(3/8)
	AddVictoryBarMarker(4/8)
	AddVictoryBarMarker(5/8)
	AddVictoryBarMarker(6/8)
	AddVictoryBarMarker(7/8)
	AddVictoryBarMarker(1.0)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
		SetVictoryBarFill(0.12)
		elseif destroyed == 5 then
		SetVictoryBarFill(0.25)
		elseif destroyed == 6 then
		SetVictoryBarFill(0.375)
		elseif destroyed ==	8 then
		SetVictoryBarFill(0.5)
		elseif destroyed == 9 then
		SetVictoryBarFill(0.625)
		elseif destroyed == 11 then
		SetVictoryBarFill(0.75)
		elseif destroyed == 13 then
		SetVictoryBarFill(0.875)
		elseif destroyed == 15 then
		SetVictoryBarFill(1.0)
		end
	end
end

function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 14 then			
			Army = 14
			Army1 = 13
			Army2 = 12
			SpellLevel = 12
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("start",Army2)   

		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
	    SpawnUnits("start",Army2)
	    SpawnUnits("titan",Army2)
		RespawnUnits("spawn1",Army1)
		RespawnUnits("spawn1a",Army2)
		RespawnUnits("spawn1a",Army2)
		RespawnUnits("spawn2",Army1)
		RespawnUnits("spawn2a",Army2)
		RespawnUnits("spawn2a",Army2)
		RespawnUnits("spawn3",Army1)
		RespawnUnits("spawn3a",Army2)
		RespawnUnits("spawn3a",Army2)
		RespawnUnits("spawn4",Army1)
		RespawnUnits("spawn4a",Army2)
		RespawnUnits("spawn4a",Army2)
	end
end