Army = 24
Army1 = 24
Army2 = 24

function onDeployStart()
	SpawnUnits("Enemy", Army2)
	SpawnUnits("Enemy1", Army)
	SetWinnable(false)
	--ShowDialog("talkingheads/full/soldier", "TXT_CAMPAIGN_10_10_1")
	ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10_10_2")

			-- <Kooz> DOT-24527: Show banner icons for allied units
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetForceShowBannerIcon(unit, true)
	end
		-- <jkung> DoT-28739: added Kooz's script above AND increaased the hitpoints on the titan in UnitTypes.json
	AddTimer(4.5, HideTalkingHead)
	
end

function HideTalkingHead()
	HideDialog()
end

function onLevelStart()
	
	SetAlliedPlayers(0, 2)
	SetEnemyPlayers(1,2)
	
	units = GetUnits("*","Hero_Story_Commander*")
	CheckCommanderHealth(units[1],0)
	
	SecondWaveStandGuard(true)
	

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		--ClearShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10_10_3")
		
	end
end

function CheckCommanderHealth(enemyCommanderUnit,messagesShown)
	
	--print(enemyCommanderUnit.health)
	
	if enemyCommanderUnit.health < 0.6 and messagesShown == 0 then
	
		ClearShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10_10_4")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 1
		
	elseif enemyCommanderUnit.health < 0.4 and messagesShown == 1 then
	
		ClearShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10_10_5")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 2
		
	elseif enemyCommanderUnit.health < 0.2 and messagesShown == 2 then
	
		ClearShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10_10_6")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 3
	
	end
	
	if enemyCommanderUnit.health > 0 then
		AddTimer(1,CheckCommanderHealth,enemyCommanderUnit,messagesShown)
	end
end

function onUnitDestroyed(unit)
	
	if unit.id == "Hero_Story_Commander7" then
		AddTimer(1,ClearShowDialog,"talkingheads/full/guard", "TXT_CAMPAIGN_10_10_7")
		AddTimer(3,Lose)
	else
		remainingUnits = GetUnits("*","*",1)
		if #remainingUnits <= 0 then
			AddTimer(1,Win)
		elseif #remainingUnits <= 7 then
			SecondWaveStandGuard(false)
		end
	end
end

function ClearShowDialog(talkingHead, message)
	HideDialog()
	ShowDialog(talkingHead, message)
end

function InvincibleForShortTime(unit)
	EnableInvincibility(unit)
	AddTimer(5,DisableInvincibility,unit)
end

function SecondWaveStandGuard(standGround)
	
	units = GetUnits("secondWave_[START]",Army)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, standGround)
	end
	
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Enemy", Army2)
		SpawnUnits("Enemy1", Army)
		SpawnUnits("secondWave_[START]",Army)
	end
end