destroyed = 0
SpellLevel = 0
Rank = 0
Army = 24
Army1 = 24
Army = 24
Titan = 32

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	createStartingTroops(False)
	SpawnUnits("suicidesquad",Army)
	SpawnUnits("Leader",Titan)
local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10A_2_1")
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10A_2_2")
	end
end


function onLevelStart()
	SetTriggerCallbacks("middle", middle_onTriggerEnter, middle_onTriggerLeave)
	SetTriggerCallbacks("killzone", killzone_onTriggerEnter, killzone_onTriggerLeave)
	SetTriggerCallbacks("spellenable", spellenable_onTriggerEnter, spellenable_onTriggerLeave)
	AddTimer(40.0, patwarning)
	AddTimer(45.0, patrigger)
	AddTimer(3.0, suicidesquad)
	    SetBattleTimeoutTime(240,0)
	SetWinnable(false)
    SetVictoryBarType("ASSASSINATION")
	DisableAiSpells()
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state.
	end
end

function onUnitDestroyed(unit)
	if unit.spawnId == "Leader" then
	   AddTimer(0.5,YouWin)
	end
end

function YouWin()
   Win()
 end

 function patwarning()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10A_2_3")
end

function patrigger(unit)
	SpawnUnits("travellers",Army1)
	GiveNamedUnitMoveOrder("travellers", "middle")
end

function suicidesquad()
	GiveNamedUnitMoveOrder("suicidesquad", "killzone")
end


function killzone_onTriggerEnter(unit)
	if unit.spawnId == "suicidesquad" then
		local units = GetUnits("suicidesquad","*", 1)
			for i,unit in pairs(units) do
				KillUnit(unit, true)
			end
		end
end

function spellenable_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("spellenable")
		EnableAiSpells()
	end
end



function createStartingTroops(forPlinthInspector)
	
	if forPlinthInspector then
		SpawnUnits("travellers",Army1)
		SpawnUnits("suicidesquad",Army)
        SpawnUnits("Leader",Titan)
		SpawnUnits("Enemy",Army1)
	end
end










