destroyed = 0
wave = false
Army = 23
Army1 = 23
Army2 = 23
Titan = 32

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army2)
	SetWinnable(false)
	createStartingTroops(False)
	--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10A5_INTRO")
	--ShowDialog("talkingheads/full/almarand", "TXT_CAMPAIGN10A5_REPLY")	
	
end

function onLevelStart()

	SetTriggerCallbacks("waves", waves_onTriggerEnter, waves_onTriggerLeave)
	SetTriggerCallbacks("titan", titan_onTriggerEnter, titan_onTriggerLeave) 
	
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed <= 2 and wave == false then
			DisableTrigger("waves")
			PlayVFX("PA_SpawnReinforcement", "titan")	
			AddTimer(1.0, titanspawn)
		end
	end
end

function waves_onTriggerEnter(unit)

	if unit.attacker then
		DisableTrigger("waves")
		PlayVFX("PA_SpawnReinforcement", "titan")	
		AddTimer(1.0, titanspawn) 
		wave = true
	end


end

function titanspawn()
	
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN105A_WAVE")
	SpawnUnits("titanspawn",Titan)
	SpawnUnits("spawn1",Army1)
	AddTimer(10.0, spawn2)
	
end

function spawn2()
	SpawnUnits("spawn2",Army1)
	--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN105A_WAVE2")
	SetWinnable(true)

end


function createStartingTroops(forPlinthInspector)



		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army2)
		SpawnUnits("titanspawn",Titan)
		SpawnUnits("spawn1",Army1)
		SpawnUnits("spawn2",Army1)
		
	end
end
