destroyed = 0
Army = 15
Army1 = 15
Army2 = 20
Army3 = 30
Hero = 40
Ragnar = 50
Unak = 55
Almarand = 60

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SetMultipleUnitSelectionButtonEnabled(false)
    SetStandGuardButtonEnabled(false)
    SetAutoOrdersButtonEnabled(false)
    SetFightButtonEnabled(false)
	SetWinnable(false)
	ShowDialog("talkingheads/full/archivist","TXT_11_10_1")
	AddTimer(1, belecreply)
	SpawnUnits("start", Army)
	SpawnUnits("start2", Army)
	AddTimer(8.5, enablebuttons)
end

function belecreply()
	ShowDialog("talkingheads/full/guard","TXT_11_10_2")
end

-- "HERO" TITAN AND MOSSMANES

function onLevelStart()
--	SetVictoryBarEnabled(true)
	SetWinnable(false)
end

function enablebuttons()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function heroTalk()
	ShowDialog ("talkingheads/full/generictitan","TXT_11_10_3")
end

function heroFX()
	PlayVFX("PA_SpawnReinforcement", "heroFX")
	PlayVFX("PA_SpawnReinforcement", "mossFX1")
	PlayVFX("PA_SpawnReinforcement", "mossFX2")
	AddTimer(1.0, camHero)
end 

function camHero()
	SpawnUnits("hero1", Hero)
	SpawnUnits("heroA", Army)
end

-- "RAGNAR" TITAN + RAGNAR UNITS

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			AddTimer(1.0, heroTalk)
			AddTimer(7.0, heroFX)
		elseif destroyed == 12 then
			AddTimer(2.0, ragnarTalk)
			AddTimer(8.0, ragnarFX)
		elseif destroyed == 20 then
			AddTimer(2.0, unakTalk)
			AddTimer(8.0, unakFX)
		elseif destroyed == 28 then
			AddTimer(2.00, almarandTalk)
		end
		if unit.spawnId == "almarand" then
			Win()
		end
	end
end

function ragnarTalk()
	ShowDialog("talkingheads/full/almarand","TXT_11_10_4")
end

function ragnarFX()
	PlayVFX("PA_SpawnReinforcement", "ragnarFX")
	PlayVFX("PA_SpawnReinforcement", "ragnarFX1")
	PlayVFX("PA_SpawnReinforcement", "ragnarFX2")
	PlayVFX("PA_SpawnReinforcement", "ragnarFX3")
	AddTimer(1.0, camRagnar)
end 

function camRagnar()
	SpawnUnits("ragnar2", Ragnar)
	SpawnUnits("ragnarA", Army2)
	AddTimer(1, ragDelay1FX)
	AddTimer(2, ragDelay2FX)
	AddTimer(2.75, ragDelay3FX)
	AddTimer(2.95, ragDelay4FX)	
	SpawnUnits("ragnarB", Army2)
--	RespawnUnits("start", Army)
end

function ragDelay1FX()
	PlayVFX("PA_SpawnReinforcement", "ragnarB1FX")
	AddTimer(1.0, ragDelay1)
end

function ragDelay2FX()
	PlayVFX("PA_SpawnReinforcement", "ragnarB2FX")
	AddTimer(1.0, ragDelay2)
end

function ragDelay3FX()
	PlayVFX("PA_SpawnReinforcement", "ragnarB3FX")
	AddTimer(1.0, ragDelay3)
end

function ragDelay4FX()
	PlayVFX("PA_SpawnReinforcement", "ragnarB4FX")
	AddTimer(1.0, ragDelay4)
end

function ragDelay1()
	SpawnUnits("ragnarB1", Army2)
end

function ragDelay2()
	SpawnUnits("ragnarB2", Army2)
end

function ragDelay3()
	SpawnUnits("ragnarB3", Army2)
end

function ragDelay4()
	SpawnUnits("ragnarB4", Army2)
end

-- "UNAK" TITAN + UNAK ARCHER + Elithan Pikemen

function unakTalk()
	ShowDialog("talkingheads/full/guard","TXT_11_10_5")
end

function unakFX()
	PlayVFX("PA_SpawnReinforcement", "unakFX")
	AddTimer(1.0,camUnak)
end 

function camUnak()
	SpawnUnits("unak3", Unak)
	AddTimer(1, unakDelay1FX)
	AddTimer(2, unakDelay2FX)
	AddTimer(2.75, unakDelay3FX)
	AddTimer(2.95, unakDelay4FX)	
	AddTimer(3.0, unakDelay5FX)
	AddTimer(3.5, unakDelay6FX)
	AddTimer(4.0, unakDelay7FX)	
--	RespawnUnits("start", Army)
end

function unakDelay1FX()
	PlayVFX("PA_SpawnReinforcement", "unakA1FX")
	AddTimer(1.0, unakDelay1)
end

function unakDelay2FX()
	PlayVFX("PA_SpawnReinforcement", "unakA2FX")
	AddTimer(1.0, unakDelay2)
end

function unakDelay3FX()
	PlayVFX("PA_SpawnReinforcement", "unakA3FX")
	AddTimer(1.0, unakDelay3)
end

function unakDelay4FX()
	PlayVFX("PA_SpawnReinforcement", "unakA4FX")
	AddTimer(1.0, unakDelay4)
end

function unakDelay5FX()
	PlayVFX("PA_SpawnReinforcement", "unakB1FX")
	AddTimer(1.0, unakDelay5)
end

function unakDelay6FX()
	PlayVFX("PA_SpawnReinforcement", "unakB2FX")
	AddTimer(1.0, unakDelay6)
end

function unakDelay7FX()
	PlayVFX("PA_SpawnReinforcement", "unakB3FX")
	AddTimer(1.0, unakDelay7)
end

function unakDelay1()
	SpawnUnits("unakA1", Army1)
end

function unakDelay2()
	SpawnUnits("unakA2", Army1)
end

function unakDelay3()
	SpawnUnits("unakA3", Army1)
end

function unakDelay4()
	SpawnUnits("unakA4", Army1)
end

function unakDelay5()
	SpawnUnits("unakB1", Army3)
end

function unakDelay6()
	SpawnUnits("unakB2", Army3)
end

function unakDelay7()
	SpawnUnits("unakB3", Army3)
end

-- SPAWN ALAMARAND TITAN LAST FIGHT!!!

function almarandTalk()
	FrameCamera("camAlmarand")
	ShowDialog("talkingheads/full/guard","TXT_11_10_5")
	EnableCameraControl(false)
	AddTimer(6.5, ReturnCamera)
	AddTimer(2.00, almarandFX1)
	AddTimer(2.20, almarandFX2)
	AddTimer(2.40, almarandFX3)
	AddTimer(2.60, almarandFX4)
	AddTimer(3.25, almarandFX5)
end

function almarandFX1()
	PlayVFX("PA_SpawnReinforcement", "almarandFX1")
end 

function almarandFX2()
	PlayVFX("PA_SpawnReinforcement", "almarandFX2")
end 

function almarandFX3()
	PlayVFX("PA_SpawnReinforcement", "almarandFX3")
end 

function almarandFX4()
	PlayVFX("PA_SpawnReinforcement", "almarandFX4")
end 

function almarandFX5()
	PlayVFX("PA_SpawnReinforcement", "almarandFX5")
	AddTimer(1.0,camAlmarand)
end 

function camAlmarand()
	SpawnUnits("almarand", Almarand)
--	SpawnUnits("A", Army)
--	RespawnUnits("start", Army)
end

function createStartingTroops(forPlinthInspector)
       
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
        SpawnUnits("almarand", Almarand)
		SpawnUnits("unakA1", Army1)
		SpawnUnits("unakA2", Army1)
		SpawnUnits("unakA3", Army1)
		SpawnUnits("unakA4", Army1)
		SpawnUnits("unakB1", Army3)
		SpawnUnits("unakB2", Army3)
		SpawnUnits("unakB3", Army3)
		SpawnUnits("start", Army)
		SpawnUnits("start2", Army)
		SpawnUnits("hero1", Hero)
		SpawnUnits("heroA", Army)
		SpawnUnits("ragnar2", Ragnar)
		SpawnUnits("ragnarA", Army2)
		SpawnUnits("ragnarB", Army2)
		SpawnUnits("ragnarB1", Army2)
		SpawnUnits("ragnarB2", Army2)
		SpawnUnits("ragnarB3", Army2)
		SpawnUnits("ragnarB4", Army2)

	end
end

