capture = false
destroyed = 0
fillup = 0
Army = 24
Army1 = 24
Army2 = 24
Titan = 42

function onDeployStart()
	SetWinnable(true)
	createStartingTroops(false)
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_11_7_INTRO")
	
end

function onLevelStart()
	SetVictoryBarEnabled(true)
	SetTriggerCallbacks("escape", escape_onTriggerEnter, escape_onTriggerLeave)
	SetTriggerCallbacks("titan1", titan1_onTriggerEnter, titan1_onTriggerLeave)
	SetTriggerCallbacks("titan2", titan2_onTriggerEnter, titan2_onTriggerLeave)
	holdposition()
	moveskeletons()
	triggercheck()
end

function holdposition()
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGuard(unit, true)
	end
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("skeleton",Army)
	SpawnUnits("militia",Army)
	SpawnUnits("pike",Army1)
	SpawnUnits("unak",Army2)
	SpawnUnits("archer",Army)
	SpawnUnits("titan",Titan)
	
	if forPlinthInspector then
		SpawnUnits("skeleton",Army)
		SpawnUnits("militia",Army)
		SpawnUnits("pike",Army1)
		SpawnUnits("unak",Army2)
		SpawnUnits("archer",Army)
		SpawnUnits("titan",Titan)
	end
end

function triggercheck()
	local var1 = CountDefendersInTrigger("escape")
	
	local var2 = CountAttackersInTrigger("escape")
	if var1 > var2 then
	 capture = true
	elseif var1 < var2 then
	 capture = false
	end 
	Success()	
end

function Success()
	AddTimer(3.0, triggercheck)
	
	if capture == true then
		--ShowDialog ("talkingheads/full/guard","TXT_CAMPAIGN_11_7_LOSE")
		AddTimer(3.0, EndMission)
	end
end

function EndMission()
	Lose()
end

function moveskeletons()
	local units = GetUnits("skeleton", "*", 1)
	for i,unit in pairs(units) do
	--ShowDialog ("talkingheads/full/tash","TXT_CAMPAIGN_11_7_TAUNT")
	GiveUnitMoveOrder(unit, "escape")
	end
--[[
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "titan1")
	end
--]]
end

function onUnitDestroyed(unit)
		if unit.defender then
			destroyed = destroyed + 1
			if destroyed == 3 then
			local units = GetUnits("militia", "*", 1)
			for i,unit in pairs(units) do
			--ShowDialog ("talkingheads/full/tash","TXT_CAMPAIGN_11_7_MILITIA")
			GiveUnitMoveOrder(unit, "escape")
			AddTimer(15.0, movepikes)
			end
--[[			
			local units = GetUnits("titan", "*", 1)
			for i,unit in pairs(units) do
			GiveUnitMoveOrder(unit, "titan2")
			end
--]]
		end
	end
end

function movepikes()
		
	local units = GetUnits("pike", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "escape")
	--ShowDialog ("talkingheads/full/tash","TXT_CAMPAIGN_11_7_PIKE")
	AddTimer(25.0, moveother)
	end
--[[	
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "titan1")
--]]
end

function moveother()
		
		--ShowDialog ("talkingheads/full/tash","TXT_CAMPAIGN_11_7_LAST")
		DisableTrigger("titan1")
		DisableTrigger("titan2")
		
		local units = GetUnits("titan", "*", 1)
		for i,unit in pairs(units) do
--		SetUnitStandGuard(unit, false)
		GiveUnitMoveOrder(unit, "escape")
		end
		
		local units = GetUnits("archer", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger1")
		end
		
		local units = GetUnits("unak", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger1")
		end
end

--[[

function titan1_onTriggerEnter(unit)
		if unit.spawnId == "titan" then
			local units = GetUnits("titan", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGuard(unit, true)
		end
	end
end


function titan2_onTriggerEnter(unit)
		if unit.spawnId == "titan" then
			local units = GetUnits("titan", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGuard(unit, true)
		end
	end
end
--]]
