destroyed = 0
Army = 1
selectionCount = 0
orderGiven = false
waitingForOrder = false
shouldPlayTapUnitMovie = true

function onDeployStart()
	createStartingTroops(False)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SpawnUnits("Enemy",Army)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	inDeploy = true
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	DisableNecromancer(true)
	
	if HasBattleBeenRestarted() then
		ShowDialogInPosition("talkingheads/full/guard","TXT_SP1A_BATTLE_RESTARTED","BOTTOM_LEFT")
		orderGiven = true -- Don't need to re-do the tutorial parts
		shouldPlayTapUnitMovie = false

		SetAutoOrdersButtonEnabled(true)
		SetFightButtonEnabled(true)
		SetMultipleUnitSelectionButtonEnabled(true)
  else
		EnableSelectionChange(false) -- Don't allow player to select unit before the popup
		SetFightButtonEnabled(false)
  end
end

function onLevelStart()
    --SetPanningCamera(2, 10, -60, 0, 60) -- focusX, focusY, zoom, heading, pitch
    SetCamera(2, 10, -60, 0, 60) -- focusX, focusY, zoom, heading, pitch / focusX, focusY, ficusZ, angle, zoom
	SetStandGuardButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
    SetStandGuardButtonEnabled(false)
    inDeploy = false
    EnableSelectionChange(true)
	HideDialog()
	CloseTutorialMovie()
end


function onUnitOrderGiven(unit, orderType)
  if inDeploy and waitingForOrder then
    waitingForOrder = false
    orderGiven = true
    CloseTutorialMovie()
    EnableSelectionChange(true)
    AddTimer(1.0, function()
		HideDialog()
        --ShowDialog("Portraits/Guard_top","TXT_SP1A_GIVE_ORDER_OK")
		ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_MOVEMENT","BOTTOM_LEFT")
		AddTimer(5.0, removeText)
    end)
    AddTimer(1.0, SetFightButtonEnabled, true)
  end
end


function createStartingTroops(forPlinthInspector)
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
	SpawnUnits("Enemy",Army)
	end
end

function playTapUnitMovie()
  if shouldPlayTapUnitMovie then
    local allies = GetUnits("*", "Militia", 0) -- get player Militia unit
    PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[2])
    shouldPlayTapUnitMovie = false
  end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
	    --ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_3D_1_1","TOP_LEFT")
		--AddTimer(0.5, framecamera)
		--AddTimer(0.5,buttonunlock)
		 ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE2_BATTLE_1A","BOTTOM_LEFT")
		--AddTimer(5, HideDialog)
		EnableSelectionChange(true)
		AddTimer(1.0, playTapUnitMovie)
	end
end

function onUnitSelected(unit)
  if inDeploy and unit.attacker and not orderGiven then
	shouldPlayTapUnitMovie = false
	CloseTutorialMovie()
	HideDialog()
    ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_TAP_DRAG","BOTTOM_LEFT")
	--AddTimer(5, HideDialog)
    AddTimer(0.1, PlayTutorialMovieOnUnit, "Media/UI/Tutorial_UnitCommands02.swf", unit)
    EnableSelectionChange(false)
    waitingForOrder = true
  end
end

function framecamera(seconds)
    --ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_3D_1_2","TOP_LEFT")
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(3, ReturnCamera)
	AddTimer(3.5,buttonunlock)
	--AddTimer(6,framecamera1)
end

function buttonunlock()
    SetFightButtonEnabled(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 then
			ShowDialogInPosition("talkingheads/full/knight","TXT_FTUE2_ARMY_2C","BOTTOM_RIGHT")
			AddTimer(4.0, removeText)
		end
		if destroyed == 3 then
			SpawnUnits("spawn", Army)
			ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE2_BATTLE_2A","BOTTOM_LEFT")
			AddTimer(4.0, removeText)
		end
		if destroyed == 4 then
			SetWinnable(true)
			Win()
		end
	end
end

function removeText()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("start",Army)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("spawn",Army)
	end
end






