Army = 1
Army1 = 1
destroyed = 0

escortDead = false
escortComplete = false

function onDeployStart()
	SpawnUnits("Enemy",Army)
	SpawnUnits("wave1",Army)
	SetTriggerCallbacks("loss", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)
	SetTriggerCallbacks("loss1", onTriggerEnter_End_Zone1, onTriggerLeave_End_Zone1)
	SetTriggerCallbacks("flankLeft", onTriggerEnter_flankLeft, onTriggerLeave_flankLeft)
	SetTriggerCallbacks("flankRight", onTriggerEnter_flankRight, onTriggerLeave_flankRight)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(4.5, showVillage)
end

function onLevelStart()
	--ClearTargetCircles()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
--	AddTimer(20.0, spawnWaveOne)
end

--[[
function spawnWaveOne()
	SpawnUnits("wave1",Army)
end
--]]

function onTriggerEnter_End_Zone(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
	end
end

function onTriggerEnter_End_Zone1(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
	end
end

function showVillage()
	FrameCamera("cam")
	ShowDialog("talkingheads/full/guard","TXT_MISSION3A_4_1")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTargetCircle("loss")
	AddTargetCircle("loss1")
	AddTimer(4.0, returnCam)
end

function returnCam()
	ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_2")
	ReturnCamera()
	AddTimer(3.0, EnableControls)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("wave1",Army)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			Win()
		end
	end
end


