destroyed = 0
Army = 2
Army1 = 5
Army2 = 5

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	SpawnUnits("Enemy1",Army1)
	SpawnUnits("Enemy2",Army1)
	SpawnUnits("Enemy3",Army)
	SpawnUnits("Pikemen",Army1)
	SetWinnable(false)
	createStartingTroops(False)
	SetStandGuardButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	EnableSelectionChange(false)
--[[
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_2_1") JKung DOT-29894 - Temporarily disabling talking heads
	AddTimer(4.0, removeText)
--]]
	AddTimer(4.5, showPikemen)

	local units = GetUnits("Pikemen", "*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onLevelStart()

	SetTriggerCallbacks("enemy1Left", onTriggerEnter_enemy1Left, onTriggerLeave_enemy1Left) --JKung DOT-29894 - Temporarily diabling Spearmen move orders
	SetTriggerCallbacks("enemy1Right", onTriggerEnter_enemy1Right, onTriggerLeave_enemy1Right)
	SetTriggerCallbacks("enemy2Left", onTriggerEnter_enemy2Left, onTriggerLeave_enemy2Left)
	SetTriggerCallbacks("enemy2Right", onTriggerEnter_enemy2Right, onTriggerLeave_enemy2Right)
	SetTriggerCallbacks("enemy3Left", onTriggerEnter_enemy3Left, onTriggerLeave_enemy3Left)
	SetTriggerCallbacks("enemy3Right", onTriggerEnter_enemy3Right, onTriggerLeave_enemy3Right)
	SetTriggerCallbacks("attack", onTriggerEnter_topLeft, onTriggerLeave_topLeft)

	SetVictoryBarEnabled(false)
	--Standstill()

	GiveNamedUnitMoveOrder("Enemy", "enemy1Left")
	GiveNamedUnitMoveOrder("Enemy1", "enemy2Left")
	GiveNamedUnitMoveOrder("Enemy2", "enemy3Left")

	
	local units = GetUnits("Pikemen", "*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onTriggerEnter_enemy1Left(unit)
	if unit.spawnId == "Enemy" then
		GiveNamedUnitMoveOrder("Enemy", "enemy1Right")
	end
end

function onTriggerEnter_enemy1Right(unit)
	if unit.spawnId == "Enemy" then
		GiveNamedUnitMoveOrder("Enemy", "enemy1Left")
	end
end

function onTriggerEnter_enemy2Left(unit)
	if unit.spawnId == "Enemy1" then
		GiveNamedUnitMoveOrder("Enemy1", "enemy2Right")
	end
end

function onTriggerEnter_enemy2Right(unit)
	if unit.spawnId == "Enemy1" then
		GiveNamedUnitMoveOrder("Enemy1", "enemy2Left")
	end
end

function onTriggerEnter_enemy3Left(unit)
	if unit.spawnId == "Enemy2" then
		GiveNamedUnitMoveOrder("Enemy2", "enemy3Right")
	end
end

function onTriggerEnter_enemy3Right(unit)
	if unit.spawnId == "Enemy2" then
		GiveNamedUnitMoveOrder("Enemy2", "enemy3Left")
	end
end

function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("Enemy",Army1)
		SpawnUnits("Enemy1",Army1)
		SpawnUnits("Enemy2",Army1)
		SpawnUnits("Enemy3",Army)
		SpawnUnits("Pikemen",Army1)
	end
	
end

function removeText()
	HideDialog()
end

function showPikemen()
	FrameCamera("attack")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_2_2")
	AddTargetCircle("target")
	AddTimer(4.0, removeText)
	AddTimer(4.0, goHome)
end

function goHome()
	ReturnCamera()
--	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_2_3") JKung DOT-29894 - Disabling talking head about timing your trooops
	AddTimer(4.0, removeText)
	AddTimer(0.1, EnableControls)  -- JKung DOT-29894 - reduced timer from 4.0 to 0.1 seconds as the above dialog is disabled.
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
--	SetAutoOrdersButtonEnabled(true)
	EnableSelectionChange(true)
end

function EnemyMove()
	local units = GetUnits("reinforce", "*", 1)
	for i,unit in pairs(units) do
	GiveNamedUnitMoveOrder("reinforce", "finish")
	end

end

function onUnitDestroyed(unit)
	if unit.spawnId == "Pikemen" then
	   AddTimer(0.5,YouWin)
	end
end

function YouWin()
   Win()
 end

 function Standstill() -- tells the unit to stand ground
                local units = GetUnits("Pikemen", "*", 1)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
                SetCanGrowAwareness("Pikemen",false)
				AddTimer(1.0, Standstill)
end
