
SpellLevel = 0
Army = 5
Army1 = 5
Army2 = 5
Rank = 0
triggered = 0
triggered1 = 0
destroyed = 0

function QueueAssets()
	QueueVFX("ElderStone_EnergyProp") -- main effect
	QueueVFX("ElderStone_EnergyPropStones") -- small effect
end


function onDeployStart()
	PlayVFX("ElderStone_EnergyProp", "fx1") -- main effect
	PlayVFX("ElderStone_EnergyPropStones", "fx2") -- small effect
	PlayVFX("ElderStone_EnergyPropStones", "fx3")
	createStartingTroops(False)  -- This part here
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
	SetTriggerCallbacks("trap1", trap1_onTriggerEnter, trap1_onTriggerLeave)
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start1",Army1)
		DisableTrigger("trap")
		triggered = triggered +1
	end
end

function trap1_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start2",Army2)
		DisableTrigger("trap1")
		triggered1 = triggered1 +1
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 and triggered == 0 then
			SpawnUnits("start1",Army1)
		end
		if destroyed == 5 and triggered1 == 0 then
			SpawnUnits("start2",Army2)
		end
	end
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("start",Army)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army1)
		SpawnUnits("start2",Army2)
	end
end

