Army = 5
Titan = 9
PlayerUnits = 0
Endpoint = 0
destroyed = 0
defending = 0
SpellLevel = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
    SetWinnable(false)
	createStartingTroops(False)
	SpawnUnits("Enemy",Army)
end

function onLevelStart()
	StopVFX("ElderStone_EnergyPropStones", "trigger1")
	StopVFX("ElderStone_EnergyPropStones", "trigger2")
	StopVFX("ElderStone_EnergyPropStones", "trigger3")
	StopVFX("ElderStone_EnergyPropStones", "trigger4")
	SetVictoryBarFill(0.3)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
		    SetVictoryBarFill(0.4)
		end
		if destroyed == 2 then
		    SetVictoryBarFill(0.45)
		end
		if destroyed == 3 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4D_5_2")
			PlayVFX("ElderStone_EnergyPropStones", "trigger1")
	        PlayVFX("ElderStone_EnergyPropStones", "trigger2")
	        PlayVFX("ElderStone_EnergyPropStones", "trigger3")
	        PlayVFX("ElderStone_EnergyPropStones", "trigger4")	
		    SetVictoryBarFill(0.5)
		end
		if destroyed == 4 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4D_5_3")
			PlayVFX("PA_SpawnReinforcement", "titanspawn")
		    AddTimer(1.0, SpawnOneEnemyUnit)
		    AddTimer(1.0, spawntitan)
			SetVictoryBarFill(0.55)
		end
		if destroyed == 5 then
			SetVictoryBarFill(0.6)
		end
		if destroyed == 6 then
			SetVictoryBarFill(0.65)
		end
		if destroyed == 7 then
			SetVictoryBarFill(0.7)
		end
		if destroyed == 8 then
			SetVictoryBarFill(0.75)
		end
		if destroyed == 9 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4D_5_4")
			AddTimer(6,win)
			SetVictoryBarFill(1)
		end
	end
end

function spawntitan()
    SpawnUnits("titan",Titan)
	StopVFX("ElderStone_EnergyPropStones", "trigger1")
	StopVFX("ElderStone_EnergyPropStones", "trigger2")
	StopVFX("ElderStone_EnergyPropStones", "trigger3")
	StopVFX("ElderStone_EnergyPropStones", "trigger4")
end

function win()
    Win()
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 2
	SpellLevel = 0
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("spawn1",Army)
		SpawnUnits("titan",Titan)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		PlayVFX("ElderStone_EnergyPropStones", "trigger1")
	    PlayVFX("ElderStone_EnergyPropStones", "trigger2")
	    PlayVFX("ElderStone_EnergyPropStones", "trigger3")
	    PlayVFX("ElderStone_EnergyPropStones", "trigger4")	
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4D_5_1")
	end
end


function SpawnOneEnemyUnit()
	RespawnUnits("spawn1",Army)
end





