PlayerUnits = 0
Endpoint = 0
destroyed = 0
defending = 0
SpellLevel = 0
Army = 6
Titan = 10

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army)
    SetWinnable(false)
	createStartingTroops(False)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
end

function onLevelStart()
	--SpawnUnits("spawn1",Army)
	SetVictoryBarFill(0.4)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4E_5_3")
			PlayVFX("PA_SpawnReinforcement", "titanspawn")
		    AddTimer(1.0, spawntitan)
			SetVictoryBarFill(0.7)
		end
		if destroyed == 6 then
			AddTimer(6,win)
			SetVictoryBarFill(1)
		end
	end
end

function spawntitan()
    SpawnUnits("titan",Titan)
end

function win()
    Win()
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 2
	SpellLevel = 0
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("titan",Titan)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
    ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4E_5_1","TOP_LEFT")
	FrameCamera("camera")
	AddTimer(5, ReturnCamera)
	EnableCameraControl(false)
	AddTargetCircleWithArrow("capture")
	AddTimer(6,framecamera1)
end

function framecamera1(seconds)
    ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4E_5_2","TOP_LEFT")
	AddTimer(6,buttonunlock)
	ClearTargetCircles()
	AddTargetCircle("capture")
	AddTimer(6, buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end





