SpellLevel = 0
Army = 15
Army1 = 15
Titan = 22
Rank = 0
PlayerUnits = 0
Endpoint = 0
destroyed = 0
defending = 0

function QueueAssets()
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	createStartingTroops(False)
	raininghell()
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter)
	--SetPanningCamera(95.2, -134.9, 70.1, -0.48, -0.1) -- focusX, focusY, zoom, heading, pitch
	PlayVFX("ElderStone_EnergyProp", "shape1")
	PlayVFX("ElderStone_EnergyPropStones", "shape2")
	PlayVFX("ElderStone_EnergyPropStones", "shape3")
	PlayVFX("ElderStone_EnergyPropStones", "shape4")
	PlayVFX("ElderStone_EnergyPropStones", "shape5")
	PlayVFX("ElderStone_EnergyPropStones", "shape6")
	PlayVFX("ElderStone_EnergyPropStones", "shape7")
	PlayVFX("ElderStone_EnergyPropStones", "shape8")
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 7
	SpellLevel = 5


	SpawnUnits("start",Army)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn1",Army1)
		SpawnUnits("titan",Titan)
	end
end


function onLevelStart()
	AddTimer(360,Lose)
	--SetPanningCamera(95.2, -134.9, 70.1, -0.48, -0.1) -- focusX, focusY, zoom, heading, pitc
	PlayVFX("ElderStone_EnergyProp", "shape1")
	AddTimer(30.0,stopfx)
end

function stopfx()
	StopVFX("ElderStone_EnergyProp")
	--ShowDialog("talkingheads/full/guard","TXT_MISSION8_3")
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard", "TXT_C51_1")
	end

end

function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("trigger1")
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn1",Army1)
		SpawnUnits("titan",Titan)
		--ShowDialog("talkingheads/full/guard", "TXT_C51_2")	
	end
end

function raininghell()
	CastSpell("Fireball", SpellLevel, "strikes"..math.random(7), 3)
--	PlayVFX("PA_TutorialFireball", "strikes"..math.random(7))
	AddTimer(math.random(8), raininghell)
end








