AttackersZone1 = false
DefendersZone1 = true
Captured = false
respawner = 0
killcount = 0
SpellLevel = 0
Army = 8
Titan = 20
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	AddTargetCircle("Capture")
	createStartingTroops(False)
	SetWinnable(false)
	AddTimer(1.0, SpawnOneEnemyUnit)
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(4.0,startgame)
end

function onLevelStart()
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave) 
	SetTriggerCallbacks("trap1", trap1_onTriggerEnter, trap1_onTriggerLeave) 
	SetTriggerCallbacks("Capture", Capture_onTriggerEnter) 
	triggercheck()
	SetBattleTimeoutTime(360,0)
	AddTimer(360, Lose)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN6G3_2")
	end
end

function startgame()
	HideDialog()
end

function triggercheck()
	local var1 = CountDefendersInTrigger("Capture")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true
	end 
	
	local var3 = CountAttackersInTrigger("Capture")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	Success()
end

function Success()
	AddTimer(3.0, triggercheck)
	if DefendersZone1 == false and AttackersZone1 == true then 
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN6G3_3" )
		Captured = true
	else
		Captured = false
	end
	if Captured == true then
		Win()
	end
end

function SpawnOneEnemyUnit()
	SpawnUnits("startTitan",Titan)
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start1",Army)
		DisableTrigger("trap")
	end
end

function trap1_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start2",Army)
		RespawnUnits("start3",Army)
		DisableTrigger("trap1")
	end
end

--function capture_onTriggerEnter(unit)
	--if unit.attacker then
		--SetWinnable(true)
		--DisableTrigger("capture")
	--end
--end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("start",Army)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("start3",Army)
		SpawnUnits("startTitan",Titan)
	end
end

