destroyed = 0
Army = 18
Army1 = 18

-- called at before the deploy phase
function onDeployStart()
	SpawnUnits("Enemy",Army)
	SpawnUnits("Enemy1",Army1)
	-- register the triggers in the level
	SetTriggerCallbacks("NEW_SHAPE", onTriggerEnter_trigger_NEW_SHAPE, onTriggerLeave_trigger_NEW_SHAPE)
	ShowDialogDismiss("talkingheads/full/guard", "TXT_CAMPAIGN6D_4_1")	
end


-- called after the deploy phase
function onLevelStart()
	--SetPanningCamera(26.2,-99,53,-0.43,-0.40)
	SetBattleTimeoutTime(480)
	SetAI1() -- allies
	SetAI2() -- enemy attacking allies
	HideDialog()
	SetWinnable(false)

	

		
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end
 


function onTriggerEnter_trigger_NEW_SHAPE(unit)
	if unit.attacker then
		DisableTrigger("NEW_SHAPE") 
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
	end
	SetWinnable(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
			AddTargetCircleWithArrow("highlight1")
			AddTimer(15.0,removeHighlight)
		end
	end
end


function removeHighlight() -- sets attacker on allies to not do damage
	ClearTargetCircles()
end

function createStartingTroops(forPlinthInspector)
	
	
	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Enemy1",Army1)
		SpawnUnits("extra",Army1)
	end
end
