SpellLevel = 16
firewall = true
SpellActive = false
placement = 0
Army = 23
Army1 = 23

function QueueAssets()
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SpawnUnits("Enemy",Army)
	PlayVFX("ElderStone_EnergyPropStones", "trigger3")
	PlayVFX("ElderStone_EnergyPropStones", "trigger4")
	SetTriggerCallbacks("fireballtrigger", fireballtrigger_onTriggerEnter)
	SetTriggerCallbacks("final_trigger", final_trigger_onTriggerEnter)
	ShowDialog("talkingheads/full/guard","TXT_CAMP9D4_INTRO")
	SetWinnable(false)
		
end


function onLevelStart()

		AddTimer(6.0, raininghell1)

end

function fireballtrigger_onTriggerEnter(unit)
		
		if unit.attacker then
			firewall = false
			ShowDialog("talkingheads/full/guard","TXT_CAMP9D4_CONTROL")
			SetTriggerCallbacks("final_trigger", final_trigger_onTriggerEnter)
			SetTriggerCallbacks("defense", defense_onTriggerEnter, defense_onTriggerLeave)
			AddTargetCircle("defense")
			AddTimer(10.0, FinalSpawn)
			DisableTrigger("fireballtrigger")
		end
end

function FinalSpawn()

	SetWinnable(true)
	SpawnUnits("spawn1", Army1)
	

end

function final_trigger_onTriggerEnter(unit)
		
		if unit.defender then

			DisableTrigger("final_trigger")
			raininghell()
		
		end
end

-- Fireball Rain START

function raininghell1()

	if firewall == true then
		ShowDialog("talkingheads/full/guard","TXT_CAMP9D4_WARNING")
		CastSpell("Fireball", SpellLevel, "fireball1", 1)
		raininghell2()
	end
		
end

function raininghell2()

	CastSpell("Fireball", SpellLevel, "fireball2", 1)
	raininghell3()
		
end

function raininghell3()

	CastSpell("Fireball", SpellLevel, "fireball3", 1)
	raininghell4()
		
end

function raininghell4()

	CastSpell("Fireball", SpellLevel, "fireball4", 1)
	raininghell5()
		
end

function raininghell5()

	CastSpell("Fireball", SpellLevel, "fireball5", 1)
	AddTimer(60.0, raininghell1)
	
end

-- Fireball Rain END

-- Friendly Fireball Rain START

function defense_onTriggerEnter(unit)
	
	if unit.attacker then
		placement = placement + 1
		raininghell()
		print(placement)
	end
		
end


function defense_onTriggerLeave(unit)
	if unit.attacker then
		placement = placement - 1
		raininghell()
		mandef()
		print(placement)
	end
end

function mandef()

	if placement == 0 then
		ShowDialog("talkingheads/full/guard","TXT_CAMP9D4_MANDEF")
	end

end

function raininghell()

	if firewall == false and placement >= 1 then
		CastSpell("Fireball", SpellLevel, "fireball"..math.random(5), 0)
		AddTimer(math.random(3), raininghell)
	end
		
end


-- Friendly Fireball Rain END

function createStartingTroops(forPlinthInspector)

	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn1",Army1)
		SpawnUnits("Enemy",Army)
	end
end