AttackersZone1 = false
AttackersZone2 = false
DefendersZone1 = true
DefendersZone2 = true
Captured1 = false
Captured2 = false
capture_one = false
capture_two = false
lose_count = 0
Titan = 34
Army = 24
Army1 = 24
Army2 = 24
Army3 =24

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	SpawnUnits("Enemy",Army)
	--ShowDialog("talkingheads/full/guard","TXT_CAMP_9D6_INTRO")
	AddTargetCircle("capturezone_1")
	AddTargetCircle("capturezone_2")
	SetTriggerCallbacks("capturezone_1", capturezone_1_onTriggerEnter, capturezone_1_onTriggerLeave) 
	SetTriggerCallbacks("capturezone_2", capturezone_2_onTriggerEnter, capturezone_2_onTriggerLeave)
	SetTriggerCallbacks("spawntrigger", spawntrigger_onTriggerEnter, spawntrigger_onTriggerLeave) 
	createStartingTroops(False)
	spawn_skele()
	terror()


end

function spawntrigger_onTriggerEnter(unit)
		
		if unit.attacker then
			SpawnUnits("finalspawn",Army1)
		end
end

function WinGame()
	
	if capture_one == true and capture_two == true then

		finalspawn()
	end	
	
end

function finalspawn()
	
	DisableTrigger("triggerspawn")
	SpawnUnits("finalspawn",Army1)
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1, SpawnTitanUnit)


end

function SpawnTitanUnit()

	SpawnUnits("finaltitan",Titan)
	--ShowDialog("talkingheads/full/unakdip","TXT_CAMP_9D6_TITANSPAWN") --replace with unak talking head
	SetWinnable(true)

end

function terror()
	
	if capture_one == false and capture_two == false then
		CastSpell("Terror", 8, "terror"..math.random(3), 3)
		AddTimer(math.random(5), terror)
	elseif capture_one == true and capture_two == false then
		CastSpell("Terror", 8, "terror"..math.random(3), 3)
		AddTimer(math.random(5), terror)
	elseif capture_one == false and capture_two == true then
		CastSpell("Terror", 8, "terror"..math.random(3), 3)
		AddTimer(math.random(5), terror)
	end
		
end

function spawn_skele()

	if capture_one == false and capture_two == false then
		lose_count = lose_count + 1
		RespawnUnits("spawn1",Army3)
		AddTimer (60.0, spawn_skele)
		check_win()
	elseif capture_one == true and capture_two == false then
		lose_count = lose_count + 1
		RespawnUnits("spawn1",Army3)
		AddTimer (60.0, spawn_skele)
		check_win()
	elseif capture_one == false and capture_two == true then
		lose_count = lose_count + 1
		RespawnUnits("spawn1",Army3)
		AddTimer (60.0, spawn_skele)
		check_win()
	end
end

function check_win()

	if lose_count >= 6 then
		
		--ShowDialog("talkingheads/full/guard","TXT_CAMP_9D6_LOSE")
		Lose()
		
	end

end

-- Start Capture Zone 1 Sections

function capturezone_1_onTriggerEnter(unit)
	
	if unit.attacker and capture_one == false then
		
			AddTimer(1.0, triggercheck1)
			
	end

end

function triggercheck1()
	if capture_one == false then
		local var1 = CountDefendersInTrigger("capturezone_1")
		if var1 == 0 then 
			DefendersZone1 = false
		elseif var1 > 0 then
			DefendersZone1 = true	
		end 
			
		local var3 = CountAttackersInTrigger("capturezone_1")
		if var3 == 0 then 
			AttackersZone1 = false
		elseif var3 > 0 then
			AttackersZone1 = true
		end 
		success1()
	end
	
end

function success1()
	
	if AttackersZone1 == true then
	
		capture_one = true
		--ShowDialog("talkingheads/full/guard","TXT_CAMP_9D6_CAP")
		AddTimer(1.0, triggercheck1)
		WinGame()
		
	end

end

-- End Capture Zone 1 Section

-- Start Capture Zone 2 Sections

function capturezone_2_onTriggerEnter(unit)
	
	if unit.attacker and capture_two == false then
		
			AddTimer(1.0, triggercheck2)
			
	end

end

function triggercheck2()
	if capture_two == false then
		local var1 = CountDefendersInTrigger("capturezone_2")
		if var1 == 0 then 
			DefendersZone2 = false
		elseif var1 > 0 then
			DefendersZone2 = true	
		end 
			
		local var3 = CountAttackersInTrigger("capturezone_2")
		if var3 == 0 then 
			AttackersZone2 = false
		elseif var3 > 0 then
			AttackersZone2 = true
		end 
		success2()
	end
	
end

function success2()
	
	if AttackersZone2 == true then
	
		capture_two = true
		--ShowDialog("talkingheads/full/guard","TXT_CAMP_9D6_CAP")
		AddTimer(1.0, triggercheck2)
		WinGame()
		
	end

end

-- End Capture Zone 2 Section


function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("finalspawn",Army1)
		SpawnUnits("finaltitan",Titan)
		RespawnUnits("spawn1",Army3)
		RespawnUnits("spawn1",Army3)
		RespawnUnits("spawn1",Army3)
		RespawnUnits("spawn1",Army3)
		RespawnUnits("spawn1",Army3)
		
	end
end