destroyed = 0
SpellLevel = 11
Army = 12
Army1 = 12
Rank = 0
Titan = 22

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
   -- ShowDialog("talkingheads/full/elithendip", "TXT_CAMPAIGN_ELITHEN_3_6_1")
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	AddTimer(4.5,startgame)
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function onLevelStart()
    SetVictoryBarFill(0)
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
	    PlayVFX("ElderStone_EnergyPropStones", "portal")
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_ELITHEN_3_6_2")
		AddTimer(2, incoming)
		DisableTrigger("trap")
	end
end

function incoming()
		PlayVFX("PA_SpawnReinforcement", "titan")
		AddTimer(1.0, titan)
end

function titan()
    SpawnUnits("titan",Titan)
	SpawnUnits("start1",Army)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
	   -- ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_ELITHEN2_6_3")
		SetVictoryBarFill(0.5)
		SpawnUnits("start2",Army)
		end
		if destroyed == 5 then
	    --SpawnUnits("start2",Army)
		SetVictoryBarFill(0.8)
		end
		if destroyed == 8 then
		    AddTimer(6,ending)
			StopVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(1)
		end
	end
end

function ending()
    HideDialog()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -3
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -3
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -3
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -3
			Army1 = Rank
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 8
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -3
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 10
			Army1 = 13
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -3
			Army1 = Rank 
			Titan = 26
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("friendly",Army1)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("titan",Titan)
	end
end










