AttackersZone1 = false
AttackersZone2 = false
DefendersZone1 = true
DefendersZone2 = true
capture_one = false
capture_two = false
capture_1_count = 0
capture_2_count = 0
SpellLevel = 7
Army = 9
Rank = 0
Titan = 14

function QueueAssets()
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	ShowDialog("talkingheads/full/guard","TXT_CAMP_MOSS_1_10_INTRO")
	AddTimer(5, stoptalking1) -- DOT-30437 Jkung Add these timers to stop talking heads after 5 seconds
	SetWinnable(false)														
--	SetTriggerCallbacks("capturezone_1", capturezone_1_onTriggerEnter, capturezone_1_onTriggerLeave) -- DOT-30437 Jkung Moved these trigger callbacks to timers triggered by regions in areas before reaching these portals. 
--	SetTriggerCallbacks("capturezone_2", capturezone_2_onTriggerEnter, capturezone_2_onTriggerLeave)
	SetTriggerCallbacks("unblock", unblock_onTriggerEnter, unblock_onTriggerLeave)
	SetTriggerCallbacks("unblock2", unblock2_onTriggerEnter, unblock2_onTriggerLeave)
	SetTriggerCallbacks("timerA", timerA_onTriggerEnter) -- DOT-30437 Jkung Callback trigger to trigger/activate callback for capturezone_1.
	capture_1_on()
--	capture_2_on() -- DOT-30437 Jkung Not needed. Will spawn 2nd target circle after disable first target circle
	--poisongas()
	lightningshield()
	createStartingTroops(False)
	
end

function stoptalking1() -- DOT-30437 Jkung Stop talking head function1
	HideDialog()
end

function timerA_onTriggerEnter(unit) -- DOT-30437 Jkung Attackers trigger timer for trigger1 function,  preventing Raise Dead from triggering capture of 1st portal stone.
	if unit.attacker then
		AddTimer(15, trigger1)
	end
end

function trigger1() -- DOT-30437 Jkung when timerA trigger is crossed by attackers, it trigger callback for capturezone_1
	SetTriggerCallbacks("capturezone_1", capturezone_1_onTriggerEnter, capturezone_1_onTriggerLeave) 
end

function onLevelStart()
	SetVictoryBarEnabled(false)
	standground()
	DisableAiSpells()
	
end

function standground()
local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)		
	end
end

function unblock_onTriggerEnter(unit)
	if unit.attacker then
		local units = GetUnits("start2", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGuard(unit, false)
			SetTriggerCallbacks("capturezone_2", capturezone_2_onTriggerEnter, capturezone_2_onTriggerLeave) -- DOT-30437 Jkung Sets trigger callback for capturezone_2, preventing Raise Dead from triggering capture of 2nds portal stone.
			DisableTrigger("unblock")
		end
	end
end

function unblock2_onTriggerEnter(unit)
	if unit.attacker then
		local units = GetUnits("start3", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGuard(unit, false)
			DisableTrigger("unblock2")
		end
		local units = GetUnits("titan", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGuard(unit, false)
			--DisableTrigger("unblock2")
		end
	end
end

function WinGame()
	
	if capture_one == true and capture_two == true then
		SetWinnable(true)
	end	
	
end

-- Start Lightning Shield Functions

function lightningshield()
	
	if capture_one == false and capture_two == false then
		CastSpell("Lightning", 25, "storm"..math.random(3), 3)
		AddTimer(math.random(5), lightningshield)
	elseif capture_one == true and capture_two == false then
		CastSpell("Lightning", 25, "storm"..math.random(3), 3)
		AddTimer(math.random(5), lightningshield)
	elseif capture_one == false and capture_two == true then
		CastSpell("Lightning", 25, "storm"..math.random(3), 3)
		AddTimer(math.random(5), lightningshield)
	end
	
	
end
	
--End Lighting Shield Section


-- Start Capture Zone 1 Sections

function capturezone_1_onTriggerEnter(unit)
	
	if unit.attacker and capture_one == false then
		
			AddTimer(1.0, triggercheck1)
	end

end

function triggercheck1()
	if capture_one == false then
		local var1 = CountDefendersInTrigger("capturezone_1")
		if var1 == 0 then 
			DefendersZone1 = false
		elseif var1 > 0 then
			DefendersZone1 = true	
		end 
			
		local var3 = CountAttackersInTrigger("capturezone_1")
		if var3 == 0 then 
			AttackersZone1 = false
		elseif var3 > 0 then
			AttackersZone1 = true
		end 
		success1()
	end
	
end

function success1()
	
	if AttackersZone1 == true then 
		capture_1_count = capture_1_count + 1
	end
	AddTimer(1.0, triggercheck1)
	capturezone_1_complete()

end

function capturezone_1_complete()
	
	if capture_1_count >=5 then
			DisableTrigger("capturezone_1")
			capture_one = true
			zone1_captured()
			WinGame()
	end
end

function capture_1_on()
	
	if capture_one == false then
		AddTargetCircle("capturezone_1")
	end
	
end

function zone1_captured()

	if capture_one == true then
		PlayVFX("ElderStone_EnergyPropStones", "fx_1")
		ShowDialog("talkingheads/full/guard","TXT_CAMP_MOSS_1_10_CAPTURE1")
		ClearTargetCircles() -- DOT-30437 Jkung
		AddTimer(5, stoptalking2) -- DOT-30437 Jkung turns off 2nd talking head in 5 seconds
	end
	
end

function stoptalking2()
	HideDialog()
	AddTargetCircle("capturezone_2") -- DOT-30437 Jkung
end

-- End Capture Zone 1 Section

-- Start Capture Zone 1 Sections

function capturezone_2_onTriggerEnter(unit)
	
	if unit.attacker and capture_two == false then
		AddTimer(1.0, triggercheck2)
	end

end

function triggercheck2()
	
	if capture_two == false then
		local var1 = CountDefendersInTrigger("capturezone_2")
		if var1 == 0 then 
			DefendersZone2 = false
		elseif var1 > 0 then
			DefendersZone2 = true	
		end 
			
		local var3 = CountAttackersInTrigger("capturezone_2")
		if var3 == 0 then 
			AttackersZone2 = false
		elseif var3 > 0 then
			AttackersZone2 = true
		end 
		success2()
	end
	
end

function success2()
	
	if AttackersZone2 == true then 
		capture_2_count = capture_2_count + 1
	end
	AddTimer(1.0, triggercheck2)
	capturezone_2_complete()

end

function capturezone_2_complete()
	
	if capture_2_count >=5 then
			capture_two = true
			zone2_captured()
			WinGame()
	end
end

--[[  -- DOT-30437 Jkung
function capture_2_on()
	
	if capture_two == false then
		AddTargetCircle("capturezone_2")
	end
	
end
--]]

function zone2_captured()

	if capture_two == true then
		PlayVFX("ElderStone_EnergyPropStones", "fx_4")
		ShowDialog("talkingheads/full/guard","TXT_CAMP_MOSS_1_10_CAPTURE2")
		AddTimer(5, stoptalking3) -- DOT-30437 Jkung stops talking head #3 after 5 seconds
		ClearTargetCircles() -- DOT-30437 Jkung
		DisableTrigger("capturezone_2")
		EnableAiSpells()
	end
end

function stoptalking3()
	HideDialog()
end

-- End Captures Zones 2 Section

-- Misc Function Section

--function poisongas()
	--CastSpell("PoisonCloud", SpellLevel, "poison"..math.random(2), 3)  -- format is CastSpell("spellname",SpellLevel,"name of trigger area"..math.random(maximum trigger numbers), 3 for hitting both sides).   The trigger zones all need to be the same name
	--AddTimer(math.random(5), poisongas) -- loop for it to cast again after a random value between 1 and the value set
--end

-- End Misc Function Section

function createStartingTroops(forPlinthInspector)
--[[	
		Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 then			
			Army = Rank -2
			Army1 = Rank
			Army2 = Rank -3
			Titan = 8
		elseif Rank == 6 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank -3
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Army2 = 4
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Army2 = Rank -3
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Army2 = Rank -3
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank -3
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Army2 = 8
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Army2 = Rank -3
			Titan = 22
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("start1",Army)
	SpawnUnits("start2",Army)
	SpawnUnits("start3",Army2)
	SpawnUnits("titan", Titan)

	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
	SpawnUnits("start",Army)
	SpawnUnits("start1",Army)
	SpawnUnits("start2",Army)
	SpawnUnits("start3",Army2)
	SpawnUnits("titan", Titan)

		

	end
end
