SkeletonsDead = 0
destroyed = 0
SpellLevel = 7
Army = 8
Rank = 0
Titan = 14
titanAlive = 0

function QueueAssets()
  QueueVFX("ElderStone_EnergyPropStones")
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetTriggerCallbacks("titanspawn", titanspawn_onTriggerEnter, titanspawn_onTriggerLeave)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetWinnable(false)
end


function onUnitDestroyed(unit)		-- checks if the skels are still alive, if not then spawn the mossmane allies
	if unit.spawnId == "spawn1" then
		SkeletonsDead = SkeletonsDead + 1
			if SkeletonsDead == 4 then
				SpawnUnits("mossmane",Army1)
				--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_1_9_2")
				ClearTargetCircles()
				newcircle()
				askHim()
			end
	end	
end

function askHim()
    if titanAlive == 0 then
	    titanarrival()
	end
	if titanAlive == 1 then
	end
end

function newcircle()
    AddTargetCircleWithArrow("circle2")
	AddTimer(15,arrowcirclegone)
end

function arrowcirclegone()
    ClearTargetCircles()
	AddTargetCircle("circle2")
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 8
		elseif Rank == 6 then			
			Army = Rank -2
			Army1 = Rank -1
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("start",Army1)
	SpawnUnits("spawn1",Army)
	
	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn1",Army)
		SpawnUnits("start",Army1)
		SpawnUnits("titan1",Titan)
	end
end

function titanspawn_onTriggerEnter(unit)
		if unit.attacker then
			
			--PlayVFX("PA_SpawnReinforcement", "spawnfx")
			--AddTimer(1.0, spawntitan)
			DisableTrigger("titanspawn")
			--titanAlive = titanAlive + 1
			askHim()
		end
end

function titanarrival()
    PlayVFX("PA_SpawnReinforcement", "spawnfx")
	AddTimer(1.0, spawntitan)
	titanAlive = titanAlive + 1
end
function spawntitan()

	SpawnUnits("titan1",Titan)
	SetWinnable(true)

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("circle")
	ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_1_9_1")
	AddTargetCircleWithArrow("circle")
	EnableCameraControl(false)
	AddTimer(7, ReturnCamera)
	AddTimer(8,buttonunlock)
end

function buttonunlock()
    HideDialog()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	ClearTargetCircles()
	AddTargetCircle("circle")
end