
destroyed = 0
SpellLevel = 0
Army = 8
Army1 = 8
Rank = 0
Titan = 17


function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	--AddTargetCircle("protect")													-- central circle shows the place to protect
	createStartingTroops(False)
end

function createStartingTroops(forPlinthInspector)
--[[
   Rank = GetPlayerCastleLevel()
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
	SpawnUnits("starter",Army)
	
	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("starter",Army)
		SpawnUnits("random1",Army)
		SpawnUnits("random2",Army)
		SpawnUnits("random3",Army)
		SpawnUnits("random4",Army)
		SpawnUnits("titan",Titan)
	end
end


function onLevelStart()
	SetupVictoryBar()
	SetVictoryBarFill(0)
	SetTriggerCallbacks("protect", protect_onTriggerEnter) -- central area player is supposed to protect. doesn't require the player to be in it, but we might want to adjust that later.
	SpawnUnits("random1",Army)
	AddTimer(1.0,  FireText)
end

function FireText()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_3_3_1")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_3_3_2")
	end
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			SpawnUnits("random2",Army)
			--ShowDialog ("talkingheads/full/guard", "TXT_CAMPAIGN_MOSSMANE_3_3_3")
		    SetVictoryBarFill(0.2)
		elseif destroyed == 6 then
			SpawnUnits("random3",Army)
			--ShowDialog ("talkingheads/full/guard", "TXT_CAMPAIGN_MOSSMANE_3_3_4")
			SetVictoryBarFill(0.4)
		elseif destroyed == 11 then
			SpawnUnits("random4",Army)
			SpawnUnits("titan",Titan)
			--ShowDialog ("talkingheads/full/guard", "TXT_CAMPAIGN_MOSSMANE_3_3_5")	
            SetVictoryBarFill(0.7)			
		elseif destroyed == 15 then
            SetVictoryBarFill(1.0)	
            SetWinnable(true)			
		end
	end
end



function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(0.2)
	AddVictoryBarMarker(0.4)
	AddVictoryBarMarker(0.7)
	AddVictoryBarMarker(1.0)
end



















