destroyed = 0
SpellLevel = 9
Army = 13
Army3 = 13
Rank = 0
sentReinforcements = false

function QueueAssets()
  QueueVFX("firedamage")
  QueueVFX("fireUnak")
end

function onDeployStart()
    createStartingTroops(False)
	PlayVFX("firedamage","Big_Fire_Effect_1")
	PlayVFX("firedamage","Big_Fire_Effect_2")
	PlayVFX("firedamage","Big_Fire_Effect_3")
	PlayVFX("fireUnak","Fire_Effect_1")
	PlayVFX("fireUnak","Fire_Effect_2")
	PlayVFX("fireUnak","Fire_Effect_3")
	
	--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_RAGNAR_2_2_1")
	--ShowDialog("talkingheads/full/Kobar", "TXT_CAMPAIGN_RAGNAR_2_2_2")
	
end


function onLevelStart()
	
	SetWinnable(false)
	
	SetVictoryBarEnabled(false)
	
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		HideDialog()
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_RAGNAR_2_2_3")
		
	end
end


function onUnitDestroyed(unit)
	
	local enemyUnitsRemaining = GetUnits("*","*",1)
	if #enemyUnitsRemaining <= 2 and not sentReinforcements then
	
		SpawnUnits("reinforcement_1",Army3)
		SpawnUnits("reinforcement_2")
		
		AddTimer(2,SpawnUnits,"reinforcement_3")

		--AddTimer(4,ShowDialog,"talkingheads/full/Kobar", "TXT_CAMPAIGN_RAGNAR_2_2_4")
		
		sentReinforcements = true
		
	elseif #enemyUnitsRemaining == 0 and sentReinforcements then
		
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_RAGNAR_2_2_5")
		
		AddTimer(2,Win)
		
	end
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 and Rank <= 11 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Army3 = Rank -3
		elseif Rank >= 12 then
			SpellLevel = 12
			Army = 10
			Army1 = 11
			Army2 = 12
			Army3 = 9
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("ragnar",Army3)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("reinforcement_1",Army3)
		SpawnUnits("reinforcement_2",Army)
		SpawnUnits("reinforcement_3",Army)
		SpawnUnits("ragnar",Army3)
	end
end

