
-- Global variables, sets variables for the skeletons to appear.
spawnCounter = 0
spawnTurn = 0
SpellLevel = 0
Army = 0
Titan = 0
Rank = 0

function QueueAssets()
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

--deploy phase, sets the initial 2 talking heads to set the scene
function onDeployStart()
 --ShowDialog("talkingheads/full/guard", "TXT_SP16_7")
 createStartingTroops(False)
 end
 
 function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 9
	SpellLevel = 17
	Army = 22
	Army1 = 22
	Army2 = 22
	Titan = 34

 SpawnUnits("start",Army)
 SpawnUnits("titan",Titan)
 
 	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("skeleton1",Army2)
		SpawnUnits("skeleton2",Army2)
		SpawnUnits("skeleton3",Army2)
		SpawnUnits("skeleton4",Army2)
		SpawnUnits("titan",Titan)
	end
end

function stopdefender()
 local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function startdefender()
 local units = GetUnits("*","*",1)
   for i,unit in pairs(units) do
      SetUnitStandGuard(unit, false)
  end
end

function trigger1_onTriggerEnter(unit)
  startdefender()
  DisableTrigger ("trigger1")
end


-- battle start
function onLevelStart()
 -- stopdefender()
  --SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter)
	AddTimer(8.0,SpawnLoop)
	SetBattleTimeoutTime(300)
	PlayVFX("ElderStone_EnergyProp", "shape1")
	PlayVFX("ElderStone_EnergyPropStones", "shape2")
	PlayVFX("ElderStone_EnergyPropStones", "shape3")
	PlayVFX("ElderStone_EnergyPropStones", "shape4")
	PlayVFX("ElderStone_EnergyPropStones", "shape5")
	PlayVFX("ElderStone_EnergyPropStones", "shape6")
	PlayVFX("ElderStone_EnergyPropStones", "shape7")
	PlayVFX("ElderStone_EnergyPropStones", "shape8")
	PlayVFX("ElderStone_EnergyPropStones", "shape9")
	PlayVFX("ElderStone_EnergyPropStones", "shape10")
	PlayVFX("ElderStone_EnergyPropStones", "shape11")

end

-- spawns troops alternating between sides
function SpawnLoop()
 	spawnCounter = spawnCounter + 1
	if spawnTurn == 0 then
	--ShowDialog("talkingheads/full/brendon", "TXT_SP16_3")	
		RespawnUnits("skeleton1",Army2)
		spawnTurn = spawnTurn + 1
	elseif spawnTurn == 1 then
		RespawnUnits("skeleton2",Army2)
	--ShowDialog("talkingheads/full/brendon", "TXT_SP16_4")	
		spawnTurn = spawnTurn + 1
	elseif spawnTurn == 2 then
		RespawnUnits("skeleton3",Army2)
		spawnTurn = spawnTurn + 1
	elseif spawnTurn == 3 then
		RespawnUnits("skeleton4",Army2)
		spawnTurn = spawnTurn + 1
	end
	
	if spawnCounter <= 5 then
		AddTimer(3.0,SpawnLoop)
	end
end



