destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 18
Army = 10
Army1 = 9
Army2 = 8

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	
end

function onLevelStart()

	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	AddTimer(8.0, vfx1)
end

function trap_onTriggerEnter(unit)

	if unit.attacker then
		SpawnUnits("militia",Army)
		DisableTrigger("trap")
	end

end

function vfx1()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, wave1)
end

function wave1()
	SpawnUnits("enemy1",Army1)
	AddTimer(10.0, vfx2)
end

function vfx2()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, wave2)
end

function wave2()
	SpawnUnits("enemy2",Army2)
	AddTimer(12.0, vfx3)
end

function vfx3()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, wave3)
end

function wave3()
	SpawnUnits("enemy3",Army1)
	SpawnUnits("titan",Titan)
	SetWinnable(true)
end



function createStartingTroops(forPlinthInspector)

	SpawnUnits("enemy",Army)

			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("enemy",Army)
		SpawnUnits("enemy1",Army1)
		SpawnUnits("enemy2",Army2)
		SpawnUnits("enemy3",Army1)
	end
end










