destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 0
Army = 0
Army1 = 0
Army2 = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetWinnable(false)
end

function onLevelStart()
    SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave) -- Player approaches the capture point
	GiveNamedUnitMoveOrder("titan", "retreat")  -- tells the unit to run away
	Standstill()
	AddTimer(0.2, enter)  -- calls in enemy spawns
	SpawnUnits("archer",Army1)
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

-- portalvfx spawn in for enemy units desired
function enter()
	PlayVFX("PA_SpawnReinforcement", "spawn")
	PlayVFX("PA_SpawnReinforcement", "spawn1")
	PlayVFX("PA_SpawnReinforcement", "spawn2")
	AddTimer(1, spawnenter)
end
function spawnenter()
	SpawnUnits("pikeman",Army)
	SpawnUnits("ragnar",Army)
end
function spawnenter1()
	SpawnUnits("unak",Army1)
end

-- retreat functions for the enemy titan
function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("titan",false)
end
function awarenesson()
	SetCanGrowAwareness("titan",true)
end

function trap_onTriggerEnter(unit)

	if unit.attacker then

		SpawnUnits("militia",Army)
		DisableTrigger("trap")
		AddTimer(0.1,awarenesson)
		PlayVFX("PA_SpawnReinforcement", "spawn3")
		AddTimer(1.0,spawnenter1)
	
	end


end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 10 then
			SetWinnable(true)
		end
	end
end


function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 13 then			
			Army = 11 
			Army1 = 11
			Titan = 22
		elseif Rank == 14 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 24
		elseif Rank == 15 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 28
		elseif Rank == 16 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 30
		elseif Rank == 17 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 32
		elseif Rank == 18 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 34
		elseif Rank == 19 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 36
		elseif Rank == 20 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 38
		elseif Rank == 21 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 40
		elseif Rank == 22 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 44
		elseif Rank == 23 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 46
		elseif Rank == 24 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 50
	end
	
	SpawnUnits("titan",Titan)	
			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("unak",Army1)
		SpawnUnits("archer",Army1)
		SpawnUnits("militia",Army)
		SpawnUnits("pikeman",Army)
		SpawnUnits("ragnar",Army)
	end
end










