destroyed = 0
SpellLevel = 0
Rank = 0
RankFair = 19
Titan = 0
Army = 0
Army1 = 0
Army2 = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetWinnable(false)
end

function onLevelStart()
    SetVictoryBarFill(0)
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(2,enterarcher)
		AddTimer(5,spawnmilitia)
        PlayVFX("ElderStone_EnergyPropStones", "portal")
		DisableTrigger("trap")
	end	
end

-- calls in relevant troops here
function enterarcher()
	PlayVFX("PA_SpawnReinforcement", "portal1")
	PlayVFX("PA_SpawnReinforcement", "portal2")
	AddTimer(1, spawnarcher)
end
function spawnarcher()
    SpawnUnits("archer1",Army1)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end
--
function spawnmilitia()
    SpawnUnits("militia",Army)
end
--
function enterragnar()
	PlayVFX("PA_SpawnReinforcement", "portalleft")
	AddTimer(1, spawnragnar)
end
function spawnragnar()
    SpawnUnits("ragnar",Army1)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end
--
function entermossmane()
	PlayVFX("PA_SpawnReinforcement", "portalright")
	AddTimer(1, spawnmossmane)
end
function spawnmossmane()
    SpawnUnits("mossmane",Army1)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end
--
function enterelithen()
	PlayVFX("PA_SpawnReinforcement", "portalleft")
	AddTimer(1, spawnelithen)
end
function spawnelithen()
    SpawnUnits("elithen",Army1)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end
--
function enterunak()
	PlayVFX("PA_SpawnReinforcement", "portalright")
	AddTimer(1, spawnunak)
end
function spawnunak()
    SpawnUnits("unak",Army1)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end
--
function entertitan()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1, spawntitan)
end
function spawntitan()
    SpawnUnits("titan",Titan)
	StopVFX("ElderStone_EnergyPropStones", "portal")
end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
			AddTimer(2,enterragnar)
			PlayVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(0.3)
		end
		if destroyed == 6 then
			AddTimer(2,entermossmane)
			PlayVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(0.4)
		end
		if destroyed == 8 then
			AddTimer(2,enterelithen)
			PlayVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(0.6)
		end
		if destroyed == 9 then
			AddTimer(2,enterunak)
			PlayVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(0.7)
		end
		if destroyed == 11 then
			AddTimer(2,entertitan)
			PlayVFX("ElderStone_EnergyPropStones", "portal")
			SetVictoryBarFill(0.8)
		end
		if destroyed == 13 then
			SetWinnable(true)
			SetVictoryBarFill(1)
		end
	end
end

function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 19 then			
			Army =  17
			Army1 = 17
			Titan = 34
		elseif Rank == 20 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 38
		elseif Rank == 21 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 40
		elseif Rank == 22 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 44
		elseif Rank == 23 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 46
		elseif Rank == 24 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 50
	end
		
	SpawnUnits("pikeman",Army)
	SpawnUnits("archer",Army1)
		
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("archer",Army1)
		SpawnUnits("archer1",Army1)
		SpawnUnits("mossmane",Army1)
		SpawnUnits("elithen",Army1)
		SpawnUnits("ragnar",Army1)
		SpawnUnits("unak",Army1)
		SpawnUnits("militia",Army)
		SpawnUnits("pikeman",Army)
	end
end


		








