destroyeddef = 0
destroyatt = 0
Army = 2

function onDeployStart()
  SpawnUnits("Enemy",Army)
  PlayBattlefieldAnimation("ELDERSTONE2")
  SetAutoOrdersButtonEnabled(false)
  SetStandGuardButtonEnabled(false)
  SetTriggerCallbacks("dead", dead_onTriggerEnter)
 end

function onLevelStart()
	SetBattleTimeoutTime(150)
	SetVictoryBarEnabled(false)
	SetWinnable(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	DisableNecromancer(true)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CTES_1") -- The enemy has massed their forces to stop us reaching the Elder stone.
	end
end

function dead_onTriggerEnter(unit)
	if unit.attacker then
	 AddTimer(1.0,gameover)
	 ShowDialog("talkingheads/full/guard","TXT_TOOFAR")
	 local units = GetUnits("*", "*", 0)
		for i,unit in pairs(units) do
		KillUnit(unit)
		end
	end
end

function gameover()
	Lose()
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyeddef = destroyeddef + 1
		if destroyeddef == 1 then
			RespawnUnits("spawn1",Army)
			--ShowDialog("talkingheads/full/guard","TXT_CTES_1A")
		elseif destroyeddef == 2 then
			RespawnUnits("spawn2",Army)
			AddTimer(5.0, RespawnUnits, "spawn3")
		elseif destroyeddef == 6 then
			RespawnUnits("spawn2",Army)
			ShowDialog("talkingheads/full/guard","TXT_CTES_1C")
		end
	end
	if unit.attacker then
	  destroyatt = destroyatt + 1
	  if destroyatt == 1 then
	      ShowDialog("talkingheads/full/guard","TXT_CTES_1B")
	  elseif destroyatt == 2 then
	      --ShowDialog("talkingheads/full/guard","TXT_CTES_2")
	  elseif destroyatt == 3 then
	      --ShowDialog("talkingheads/full/guard","TXT_CTES_2")
	  end
	end
end

function createStartingTroops(forPlinthInspector)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		RespawnUnits("spawn1",Army)
		RespawnUnits("spawn2",Army)
	end
end


