SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0

math.randomseed(os.time())
local randomSpawn6 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

CreateRandomisedListOfThings("List_Units","MilitiaCave1")
CreateRandomisedListOfThings("List_Units2","SpearmanCave2")

function onDeployStart()
	SpawnUnits("MilitiaRaidTop", Army18)
	SpawnUnits("MilitiaTop1", Army18)
	SpawnUnits("MilitiaTop2", Army18)
	SpawnUnits("Archer1", Army18)
	SpawnUnits("Archer2", Army18)
	SpawnUnits("Spearman1", Army18)
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	GiveDefenderSpoil("H_300_5")
	GiveDefenderSpoil("H_65_5")
	GiveDefenderSpoil("H_308_5")
	GiveDefenderSpoil("H_71_5")
	GiveDefenderSpoil("H_301_10")
	GiveDefenderSpoil("H_309_10")
	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(2)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
			AddTimer(0.5, vfxWave2)
			AddTimer(1.5, spawnWave2)
		end
		if destroyed == 12 then
			AddTimer(0.5, vfxWave3)
			AddTimer(1.5, spawnWave3)
		end
		if destroyed == 20 then
			AddTimer(0.5, vfxWave4)
			AddTimer(1.5, spawnWave4)
		end
		if destroyed == 28 then
			AddTimer(0.5, vfxWave5)
			AddTimer(1.5, spawnWave5)
		end
		if destroyed == 37 then
		SetWinnable(true)
		end
	end
end

function vfxWave2()
	
end

function spawnWave2()
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army19)  -- 1 militia unit 
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army19)  -- 1 spearman unit 
	RespawnUnits("Skeleton2", Army19)
	RespawnUnits("Skeleton3", Army19)
	RespawnUnits("Skeleton4", Army19)
	RespawnUnits("Skeleton5", Army19)
	RespawnUnits("Skeleton6", Army19)
end

function vfxWave3()
	PlayVFX("PA_SpawnReinforcement", "vfxTop1")
	PlayVFX("PA_SpawnReinforcement", "vfxTop2")
	PlayVFX("PA_SpawnReinforcement", "vfxTop3")
	PlayVFX("PA_SpawnReinforcement", "vfxTop4")
end

function spawnWave3()
	RespawnUnits("SpearmanRaidTop", Army19)
	RespawnUnits("MilitiaTop1", Army19)
	RespawnUnits("MilitiaTop2", Army19)
	RespawnUnits("MilitiaTop3", Army19)
	RespawnUnits("MilitiaTop4", Army19)
	RespawnUnits("ArcherTop1", Army19)
	RespawnUnits("ArcherTop2", Army19)
	RespawnUnits("Skeleton3", Army19)
end

function vfxWave4()
	PlayVFX("PA_SpawnReinforcement", "vfxTop1")
	PlayVFX("PA_SpawnReinforcement", "vfxTop2")
	PlayVFX("PA_SpawnReinforcement", "vfxTop3")
	PlayVFX("PA_SpawnReinforcement", "vfxTop4")
end

function spawnWave4()
	RespawnUnits("ArcherRaidTop", Army20)
	RespawnUnits("MilitiaTopLeft1", Army20)
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army20)  -- 1 militia unit 
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army20)  -- 1 spearman unit 
	RespawnUnits("Skeleton4", Army20)
	RespawnUnits("MilitiaTop3", Army20)
	RespawnUnits("MilitiaTop4", Army20)
	RespawnUnits("SpearmanTop", Army20)
end

function vfxWave5()
	PlayVFX("PA_SpawnReinforcement", "vfxTop1")
	PlayVFX("PA_SpawnReinforcement", "vfxTop2")
	PlayVFX("PA_SpawnReinforcement", "vfxTop3")
	PlayVFX("PA_SpawnReinforcement", "vfxTop4")
end

function spawnWave5()
	RespawnUnits("ArcherRaidTop", Army21)
	RespawnUnits("SpearmanRaidTop", Army21)
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army21)  -- 1 militia unit 
	RespawnUnits(GetRandomisedRandomThing("List_Units2"),Army21)  -- 1 spearman unit 
	RespawnUnits("ArcherTop2", Army21)
	RespawnUnits("ArcherTop1", Army21)
	RespawnUnits("MilitiaTop4", Army21)
	RespawnUnits("MilitiaTop3", Army21)
end


function introText()
	randomIntroText1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_2_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_2_TALKING_HEAD_V2","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_2_TALKING_HEAD_V3","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)

	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	
end

