SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60
gate1 = 0
gate2 = 0
gate3 = 0
gate4 = 0
gate5 = 0

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end


function onDeployStart()
	
	RespawnUnits("start", Army24) -- 8 units 1 raid
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	
	GiveDefenderSpoil("D_6")
	GiveDefenderSpoil("D_7")
	GiveDefenderSpoil("D_8")
	GiveDefenderSpoil("D_9")
	GiveDefenderSpoil("D_10")
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(360,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(8)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 9 then
			AddTimer(1.0, spawnGate3)
		end
		if destroyed == 19 then
			AddTimer(1.0, spawnChoice1)
		end
		if destroyed == 29 then
			AddTimer(1.0, spawnChoice2)
		end
		if destroyed == 40 then
			AddTimer(1.0, spawnChoice3)
		end
		if destroyed == 50 then
			AddTimer(1.0, spawnChoice4)
			AddTimer(1.0, spawnTitan1)
		end
		if destroyed == 62 then
			AddTimer(1.0, spawnWave7)
		end
		if destroyed == 74 then
		SetWinnable(true)
		end
	end
end

function fireballGate1()
	CastSpell("Fireball", 5, "1", 0)
	CastSpell("Fireball", 5, "2", 0)
	CastSpell("Fireball", 5, "3", 0)
	CastSpell("Fireball", 5, "4", 0)
end

function fireballGate2()
	CastSpell("Fireball", 5, "5", 0)
	CastSpell("Fireball", 5, "6", 0)
	CastSpell("Fireball", 5, "7", 0)
	CastSpell("Fireball", 5, "8", 0)
end

function fireballGate3()
	CastSpell("Fireball", 5, "9", 0)
	CastSpell("Fireball", 5, "10", 0)
	CastSpell("Fireball", 5, "11", 0)
	CastSpell("Fireball", 5, "12", 0)
end

function fireballGate4()
	CastSpell("Fireball", 5, "13", 0)
	CastSpell("Fireball", 5, "14", 0)
	CastSpell("Fireball", 5, "15", 0)
	CastSpell("Fireball", 5, "16", 0)
end

function fireballGate5()
	CastSpell("Fireball", 5, "17", 0)
	CastSpell("Fireball", 5, "18", 0)
	CastSpell("Fireball", 5, "19", 0)
	CastSpell("Fireball", 5, "20", 0)
end

function spawnGate1()
	-- 8 normal 3 raid
	RespawnUnits("gate1", Army25)
end

function spawnGate2()
	-- 8 normal 2 raid
	RespawnUnits("gate2", Army25)
end

function spawnGate3()
	-- 8 normal 1 raid
	RespawnUnits("gate3", Army25)

end

function spawnGate4()
	-- 8 normal 2 raid
	RespawnUnits("gate4", Army25)
	
end

function spawnGate5()
	-- 8 normal 3 raid
	RespawnUnits("gate5", Army25)
	
end

function spawnTitan1()
	RespawnUnits("Titan1", Titan4)
end

function spawnWave7()
	-- 9 normal 2 raid 1 titan
	RespawnUnits("Titan2", Titan5)
	RespawnUnits("wave7", Army25)
end

function spawnChoice1()
	
	randomSpawn2 = math.random(2,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomSpawn2 == 1) then
		gate2 = 1
		AddTimer(3.0, spawnGate2)
		
	else
		gate4 = 1
		AddTimer(3.0, spawnGate4)
	end
	
end

function spawnChoice2()

	randomSpawn3 = math.random(1,1) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomSpawn3 == 1) then
		gate1 = 1
		AddTimer(3.0, spawnGate1)
		
	else
		gate5 = 1
		AddTimer(3.0, spawnGate5)
	end
	
end

function spawnChoice3()

	if (gate2 == 1) then
		AddTimer(3.0, spawnGate4)
		
	else
		AddTimer(3.0, spawnGate2)
	end
	
end

function spawnChoice4()

	if (gate1 == 1) then
		AddTimer(3.0, spawnGate5)
		
	else
		AddTimer(3.0, spawnGate1)
	end
	
end

function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end

function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

