-- used to keep track of the number of enemy units
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Army = 4
Army1 = 4
Army2 = 4
Titan = 9

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
		
	end
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetWinnable(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	--SetAutoOrdersButtonEnabled(false)
	SpawnUnits("Enemy",Army2)
	SpawnUnits("Enemy1",Army2)
	SpawnUnits("titan",Titan)
	AddTimer(4.5, showTitan)
end

function showTitan()
	FrameCamera("cam")
	--ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MISSION4_10_1","BOTTOM_LEFT")
	AddTimer(3.0, removeText)
	AddTimer(3.0, spawnMilitia)
end

function removeText()
	HideDialog()
end

function spawnMilitia()
	AddTimer(0.5, VFX1)
	AddTimer(1.0, VFX2)
	AddTimer(1.5, VFX3)
	AddTimer(2.0, VFX4)
	AddTimer(2.5, VFX5)
	AddTimer(3.0, VFX6)
	AddTimer(3.5, VFX7)
	AddTimer(4.0, VFX8)
end

function VFX1()
	PlayVFX("PA_SpawnReinforcement", "mil1")
	AddTimer(1.0, militia1)
end

function militia1()
	SpawnUnits("Militia1",Army)
end

function VFX2()
	PlayVFX("PA_SpawnReinforcement", "mil2")
	AddTimer(1.0, militia2)
end

function militia2()
	SpawnUnits("Militia2",Army2)
end

function VFX3()
	PlayVFX("PA_SpawnReinforcement", "mil3")
	AddTimer(1.0, militia3)
end

function militia3()
	SpawnUnits("Militia3",Army)
end

function VFX4()
	PlayVFX("PA_SpawnReinforcement", "mil4")
	AddTimer(1.0, militia4)
end

function militia4()
	SpawnUnits("Militia4",Army2)
end

function VFX5()
	PlayVFX("PA_SpawnReinforcement", "mil5")
	AddTimer(1.0, militia5)
end

function militia5()
	SpawnUnits("Militia5",Army)
end

function VFX6()
	PlayVFX("PA_SpawnReinforcement", "mil6")
	AddTimer(1.0, militia6)
end

function militia6()
	SpawnUnits("Militia6",Army2)
end

function VFX7()
	PlayVFX("PA_SpawnReinforcement", "mil7")
	AddTimer(1.0, militia7)
end

function militia7()
	SpawnUnits("Militia7",Army)
end

function VFX8()
	PlayVFX("PA_SpawnReinforcement", "mil8")
	AddTimer(1.0, militia8)
end

function militia8()
	SpawnUnits("Militia8",Army2)
	AddTimer(1.0, returnCam)
end

function returnCam()
	ReturnCamera()
	EnableControls()
end

function EnableControls()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

-- called after the deploy phase
function onLevelStart()
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
	--AddTimer(16.0, spawnWave1)
	--AddTimer(50.0, moveUnits)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 13 then
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Enemy",Army2)
		SpawnUnits("Enemy1",Army2)
		SpawnUnits("titan",Titan)
		SpawnUnits("Militia1",Army)
		SpawnUnits("Militia2",Army2)
		SpawnUnits("Militia3",Army)
		SpawnUnits("Militia4",Army2)
		SpawnUnits("Militia5",Army)
		SpawnUnits("Militia6",Army2)
		SpawnUnits("Militia7",Army)
		SpawnUnits("Militia8",Army2)
	end
end
