
dropped = 0
playonce = 0

function onDeployStart()
--	ShowMessageBox("Tutorial", "Kill the Archers")

end


function onLevelStart()
--	SetCinematicTimeout(-1)

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialog("talkingheads/full/guard","A frontal assault leaves through the marsh will leave us vulnerable. We need to find a way to destroy the enemy from range")
		SetAI()
		onSpoilSpawned()
		DisableNecromancer()
		SetTriggerCallbacks("Spawnp1", Spawnp1_onTriggerEnter) 
		SetTriggerCallbacks("Spawnp2", Spawnp2_onTriggerEnter) 
		SetTriggerCallbacks("Spawnp3", Spawnp3_onTriggerEnter) 
		SetTriggerCallbacks("Spawnp4", Spawnp4_onTriggerEnter) 
		SetTriggerCallbacks("warning", warning_onTriggerEnter)
	end
 end
	
-- get all units satisfying: any spawnId, archers, defender
function SetAI()
	local units = GetUnits("*", "CampArcher*", 1) 
	for i,unit in pairs(units) do
		print("STAND GROUND:", unit);
		SetUnitStandGuard(unit, true)
	end
end


function Spawnp1_onTriggerEnter(unit)
	if unit.attacker and playonce == 1 then
		SpawnUnits("spawn1")
		DisableTrigger("Spawnp1")
	end
end

function Spawnp2_onTriggerEnter(unit)
	if unit.attacker and playonce == 1 then
		SpawnUnits("spawn2")
		DisableTrigger("Spawnp2")
	end
end

function Spawnp3_onTriggerEnter(unit)
	SpawnUnits("spawn3")
	DisableTrigger("Spawnp3")
end

function Spawnp4_onTriggerEnter(unit)
	SpawnUnits("spawn4")
	DisableTrigger("Spawnp4")
end


function warning_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard","My Liege we will be vulnerable to the Archers moving through the marshes!")
		DisableTrigger("warning")
	end
end


-- A Spoil spawning will trigger this function
function onSpoilSpawned()
	if dropped == 0 then
		ShowGuideArrowForNextSpellDrop()
		DropSpell("Fireball", 25, "place1")
		dropped = dropped + 1
		elseif dropped == 1 then
			ShowGuideArrowForNextSpellDrop()
			DropSpell("Fireball", 25, "place2")
			dropped = dropped + 1
			playonce = 1
		elseif dropped == 2 then
			ShowGuideArrowForNextSpellDrop()
			DropSpell("Fireball", 25, "place3")
			dropped = dropped + 1
		elseif dropped == 3 then
			ShowGuideArrowForNextSpellDrop()
			DropSpell("Fireball", 25, "place4")
			dropped = 0
	end
end

-- Collecting a spoil shpould fire off a trigger to this function
function onSpellCollected(spellName, level)
	--ClearAllGuideArrows()
end

-- Using a spell will fire off a trigger to this function
function onSpellCast(spellName, level)
	if spellName == "Fireball" and level == 25 then
		AddTimer(3.0,SetTutorial,"")
		AddTimer(4.0,onSpoilSpawned)
	end
end






