Army = 2
Army1 = 1
Army2 = 4
Moving = 0
destroyed = 0

escortDead = false
escortComplete = false

function onDeployStart()
	--ShowDialogEternal("talkingheads/full/guard","TXT_MISSIONSP_3_1")
	EnableCameraControl(false)
--	EnableSelectionChange(false)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Enemy1",Army1)
	SpawnUnits("wave1", Army)
	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("waypoint_1b", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	SetTriggerCallbacks("spawn_wave1", onTriggerEnter_Skeleton1, onTriggerLeave_Skeleton1)
	SetTriggerCallbacks("spawn_wave2", onTriggerEnter_Skeleton2, onTriggerLeave_Skeleton2)
	SetTriggerCallbacks("spawn_wave3", onTriggerEnter_Skeleton3, onTriggerLeave_Skeleton3)
	AddTargetCircle("waypoint_1b")
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	AddTimer(9.5, showBuilding)
	AddTimer(5.5, showGoal)
--	AddTimer(6.0, ClearTargetCircles)
	AddTimer(5.0, removeText)
--[[
	-- <Kooz> DOT-24527: Show banner icons for allied units
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetForceShowBannerIcon(unit, true)
	end
--]]
end

function onLevelStart()
--	ClearTargetCircles()
--	SetAlliedPlayers(0,2)
--	SetEnemyPlayers(1,2)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	AddTimer(330,Lose)
end

function showGoal()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_5_1")
	FrameCamera("waypoint_1b")
	AddTimer(3.0, camReturn)
	AddTimer(2.9, removeText)
end

function camReturn()
	ReturnCamera()
end

--[[
function onTriggerEnter_Waypoint1A(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1a")
		SetUnitStandGuard(unit, true)
		AddTimer(3,waypoint1ADelay,unit)
		Moving = Moving + 2
		move1ATo1B()
	end
end
--]]

function onTriggerEnter_Skeleton1(unit)
	if unit.attacker then
		AddTimer(0.2,SpawnWaveOne)
		DisableTrigger("spawn_wave1")
	end
end

function onTriggerEnter_Skeleton2(unit)
	if unit.attacker then
		AddTimer(0.2,SpawnWaveTwo)
		DisableTrigger("spawn_wave2")
	end
end

function onTriggerEnter_Skeleton3(unit)
	if unit.attacker then
		AddTimer(0.2,SpawnWaveThree)
		DisableTrigger("spawn_wave3")
	end
end

--[[
function onTriggerEnter_Start_Zone(unit)
	if unit.attacker then
		DisableTrigger("start_zone")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
		AddTargetCircle("waypoint_1b")
		moveStartTo1A()
		--AddTimer(4,SpawnWaveOne)
	end
end

function moveStartTo1A()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
	AddTimer(2.0, moveStartTo1ACheck)
end

function moveStartTo1ACheck()
	if Moving == 0 then
		moveStartTo1A()
	end
	if Moving == 1 then
	
	end
end

function move1ATo1B()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	AddTimer(2.0, moveStartTo1BCheck)
end

function moveStartTo1BCheck()
	if Moving == 2 then
		move1ATo1B()
	end
end


function waypoint1ADelay(unit)
	SetUnitStandGuard(unit, false)
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
end

function onTriggerEnter_Waypoint1B(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1b")
		SetUnitStandGuard(unit, true)
		AddTimer(1,finish) -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
		ClearTargetCircles()
		--		LevelComplete()
	end
end

function finish() -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
	Win()
end
--]]

	
function onTriggerEnter_Waypoint1B(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10C_6_5")
		AddTimer(2.9, removeText)
		DisableTrigger("waypoint_1b")
		AddTimer(3,finish) 
		end
	end

function finish()
	ClearTargetCircles()
	Win()
end

--[[
function onUnitDestroyed(unit)
	if unit.spawnId == "movingUnit_[start]" then
	
		ShowDialog("talkingheads/full/guard","TXT_MISSIONSP_C3M1_3")
		
		escortDead = true
		AddTimer(2,Lose)
	elseif unit.defender then -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
		destroyed = destroyed + 1
		if destroyed == 11 then
			Win()
		end
	end
end



function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		--HideDialog()
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_2")
		--AddTargetCircleWithArrow("start_zone")
	end
end

function removeText()
	HideDialog()
end
--]]

function showBuilding()
	EnableCameraControl(false)
--	EnableSelectionChange(false)
	FrameCamera("cave")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSIONSP_3_2")
	AddTimer(4.0, returnCam)
	AddTimer(4.5, EnableControls)
	AddTimer(4.0, removeText)
end

function removeText()
	HideDialog()
end

function returnCam()
	ReturnCamera()
end

function EnableControls()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function SpawnWaveOne()
	ShowDialog("talkingheads/full/guard","TXT_MISSIONSP_3_3")
	SpawnUnits("Skeleton1",Army2)
end

function SpawnWaveTwo()
	SpawnUnits("Skeleton2",Army2)
end

function SpawnWaveThree()
	SpawnUnits("Skeleton3",Army2)
end

function createStartingTroops(forPlinthInspector)
	
	
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Enemy1",Army1)
		SpawnUnits("wave1",Army)
		SpawnUnits("Skeleton1",Army2)
		SpawnUnits("Skeleton2",Army2)
		SpawnUnits("Skeleton3",Army2)
	end
end
