Army = 1
titanselect = 0
selectionCount = 0
orderGiven = false
waitingForOrder = false
shouldPlayTapUnitMovie = true

function onDeployStart()
  SpawnUnits("MilitiaLeft", Army)
  SpawnUnits("MilitiaCentre", Army)
  SpawnUnits("MilitiaRight", Army)
  PlayBattlefieldAnimation("ELDERSTONE2")
  SetMultipleUnitSelectionButtonEnabled(false)
  SetStandGuardButtonEnabled(false)
  inDeploy = true
  SetMultipleUnitSelectionButtonEnabled(false)
  SetAutoOrdersButtonEnabled(false)
  DisableNecromancer(true)
  
  --SetCamera(-50, 0, -200, 0, -250) -- focusX, focusY, zoom, heading, pitch / focusX, focusY, ficusZ, angle, zoom

  if HasBattleBeenRestarted() then
    ShowDialogInPosition("talkingheads/full/guard","TXT_SP1A_BATTLE_RESTARTED","BOTTOM_LEFT")
    orderGiven = true -- Don't need to re-do the tutorial parts
	shouldPlayTapUnitMovie = false
  else
    EnableSelectionChange(false) -- Don't allow player to select unit before the popup
    SetFightButtonEnabled(false)
  end
end

function onLevelStart()
    SetMultipleUnitSelectionButtonEnabled(false)
    SetStandGuardButtonEnabled(false)
    inDeploy = false
    EnableSelectionChange(true)
    HideDialog()
    --ShowDialog("talkingheads/full/guard","TXT_MISSION1_1")
    --SetPanningCamera(-12, 106, 0, -0.41, -0.27)
	--SetCamera(0, 0, 250, 0, 250) -- focusX, focusY, zoom, heading, pitch / focusX, focusY, ficusZ, angle, zoom
    CloseTutorialMovie()
end

function onCameraAnimationFinish(cameraName)
  if cameraName == "CAMERA_INTRO*" and not orderGiven then
   -- ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE2_BATTLE_1A","BOTTOM_LEFT")
    ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_STORY_INFO1","BOTTOM_LEFT")
	
	AddTimer(1.0, selectTitan)
	
	
	--AddTimer(5, HideDialog)
    EnableSelectionChange(true)
	--playTapUnitMovie()
	--AddTimer(0.0, SetPanningCamera,12.4, -106.5, 100, -0.41, -0.27) -- focusX, focusY, zoom, heading, pitch
  end

	if cameraName == "BATTLE_START" then
		--SetPanningCamera(-12, 106, 100, -0.41, -0.27) -- focusX, focusY, zoom, heading, pitch (41.6)
--		ShowDialog("talkingheads/full/guard","TXT_SP1A_1") -- after intro camera in deploy phase display talking head
	end
end

function selectTitan ()

	local allies = GetUnits("*", "RagnarHero*", 0) -- get player titan
	if allies[1] then 
		PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
	end
end

function onUnitSelected(unit)
	if unit.attacker and not orderGiven then
		shouldPlayTapUnitMovie = false
		CloseTutorialMovie()
		--HideDialog()
		--ShowDialogInPosition("talkingheads/full/generictitan","TXT_FTUE_STORY_INFO2","BOTTOM_LEFT")
		
		--AddTimer(0.1, PlayTutorialMovieOnUnit, "Media/UI/Tutorial_UnitCommands02.swf", unit)
		EnableSelectionChange(false)
		waitingForOrder = true
		titanselect = 1
		AddTimer(0.5, tapEnemy)
		--AddTimer(15.0, moveTitan)
	end
end

function tapEnemy ()

	ShowDialogInPosition("talkingheads/full/Kobar","TXT_INTRO_TEXT_3","BOTTOM_LEFT")
	

	local allies = GetUnits("MilitiaCentre", "*", 1) -- get player Militia unit
	PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
	

end

function frameCam ()

	FrameCamera("cam")

end

--function playTapUnitMovie()
  --if shouldPlayTapUnitMovie then
   -- local allies = GetUnits("*", "Militia", 0) -- get player Militia unit
    --PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[2])
   -- shouldPlayTapUnitMovie = false
 -- end
--end

--function onUnitSelected(unit)
 -- if inDeploy and unit.attacker and not orderGiven then
	--shouldPlayTapUnitMovie = false
	--CloseTutorialMovie()
	--HideDialog()
   -- ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE2_BATTLE_1B","BOTTOM_LEFT")
	--AddTimer(5, HideDialog)
   -- AddTimer(0.1, PlayTutorialMovieOnUnit, "Media/UI/Tutorial_UnitCommands02.swf", unit)
   -- EnableSelectionChange(false)
   -- waitingForOrder = true
  --end
--end

function onUnitDestroyed(unit)
	CloseTutorialMovie()
end

function onUnitOrderGiven(unit, orderType)
  if inDeploy and waitingForOrder then
    waitingForOrder = false
    orderGiven = true
    CloseTutorialMovie()
    EnableSelectionChange(true)
	AddTimer(1.0, frameCam)
    AddTimer(1.0, function()
		--HideDialog()
        --ShowDialog("talkingheads/full/guard","TXT_SP1A_GIVE_ORDER_OK")
		ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_FIGHT","BOTTOM_LEFT")
		AddTimer(5.0, removeText)
    end)
    AddTimer(1.0, SetFightButtonEnabled, true)
  end
end

function removeText()
	HideDialog()
end

function onTalkingHeadFinish(text)
  print("onTalkingHeadFinish: '" .. text .. "'")
end

function createStartingTroops(forPlinthInspector) 
	-- Balanced for castle level 4
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("MilitiaLeft", Army)
		SpawnUnits("MilitiaCentre", Army)
		SpawnUnits("MilitiaRight", Army)
	end
end

