-- key binding
function onKeyDown(keys)

  if keys == "A" then
    GiveAllUnitsMoveOrder("move1")

  elseif keys == "B" then
    AttackFirstDefender()

  elseif keys == "C" then
    FrameCameraOnFirstAttackerUnit(3.0)

  elseif keys == "D" then
    
    FrameCamera("move1")
    AddTimer(3.0, ReturnCamera)

  elseif keys == "E" then

    FrameCamera("move2")
    SpawnRelic("H_120", "move2")

    AddTimer(13.0, ReturnCamera)

  elseif keys == "F" then
    SetBattleTimeoutTime(0,0)
    
  elseif keys == "G" then
    CastSpellOnUnit("Freeze", 10, "move2", 1)

  elseif keys == "H" then
    PrintSpawnUnit()

  end

end

function onLevelStart()
  --press in s in editor to set spawn id

  Army = 3
  SpawnUnits("Skel", Army)

  GiveNamedUnitMoveOrder("Skel", "move2")
end

function GiveAllUnitsMoveOrder(triggerZone)
	local units = GetUnits("*", "*", 1)

	for i, unit in pairs(units) do
	  GiveUnitMoveOrder(unit, triggerZone)
	end
end

-- get the first attacker and defender and order attaceker to attack
function AttackFirstDefender()

  local attackers = GetUnits("*", "*", 0) -- get all attacker units
  local defenders = GetUnits("*", "*", 1) -- get defender units

  print(attackers[1]) -- first attacker in list
  print(defenders[1]) -- first defender in list

  GiveUnitAttackOrder(defenders[1], attackers[1])
end

function PrintSpawnUnit()

  local spawnUnits = GetUnitsWithSpawnId("Skel")
  print(spawnUnits[1]) -- first spawnUnit in list

end

-- called whenever percentageHeath changes by 1%
function onHealthChanged(unit, percentageHealth)

  if percentageHealth < 10 then
    ShowDialog("talkingheads/full/guard", "TXT_AKINGDOMLOST_2")
  end
end

function FrameCameraOnFirstAttackerUnit(seconds)
  local attackers = GetUnits("*", "*", 0) -- get all attacker units

  FrameCamera(attackers[1]) -- first attacker in list
  AddTimer(seconds, ReturnCamera)
end

-- called whenever someone collects a spell, a unit or a relic
function onBattleDropCollected(battleDropId)
  ShowDialog("talkingheads/full/guard", "TXT_AKINGDOMLOST_2")
end

-- called whenever a unit start a fight (becomes IsEngaged())
function onEngaged(unit)
  ShowDialog("talkingheads/full/guard", "TXT_WINDINGROAD2_2")
end