-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
Army = 2
Titan = 5
dropped = 0
text = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
		
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Titan",Titan)
end

-- called after the deploy phase
function onLevelStart()
	DisableAiSpells()
	SetTriggerCallbacks("charge", enter_onTriggerEnter)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnter(unit)
	if unit.attacker then
		GiveNamedUnitMoveOrder("Enemy", "chargePosition")
		DisableTrigger("charge")
	end
end

function disableTrigger1()
	DisableTrigger("highlight1")
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)

	SpawnUnits("Enemy",Army)
	SpawnUnits("Titan",Titan)
	
end
