enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 30
Army = 14
Army1 = 13
Army2 = 12
Army3 = 11

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)
	SetWinnable(false)
end

function onLevelStart()
	
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			AddTimer(1.0, vfx1)
		end
		if destroyed == 8 then
			SpawnUnits("enemy2", Army2)
		end
		if destroyed == 13 then
			AddTimer(1.0, vfx2)
		end
		if destroyed == 17 then
			AddTimer(3.0, vfx3)
		end
    end
end

function vfx1()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	AddTimer(1.0, spawnWave1)
end

function spawnWave1()
	SpawnUnits("enemy1", Army)
end

function vfx2()
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	AddTimer(1.0, spawnWave2)
end

function spawnWave2()
	SpawnUnits("enemy3",Army)
end

function vfx3()
	PlayVFX("PA_SpawnReinforcement", "vfx9")
	PlayVFX("PA_SpawnReinforcement", "vfx10")
	PlayVFX("PA_SpawnReinforcement", "vfx11")
	PlayVFX("PA_SpawnReinforcement", "vfx12")
	PlayVFX("PA_SpawnReinforcement", "vfx13")
	AddTimer(1.0, spawnTitan)
end

function spawnTitan()
	SetWinnable(true)
	SpawnUnits("titan", Titan)
	SpawnUnits("enemy4",Army2)
end

function createStartingTroops(forPlinthInspector)

		SpawnUnits("enemy",Army)
			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("enemy",Army)
		SpawnUnits("enemy1",Army)
		SpawnUnits("enemy2",Army2)
		SpawnUnits("enemy3",Army)
		SpawnUnits("enemy4",Army2)
				
	end
end









