SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This establishes the scaling and what shows on the plinth inspector
	ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_4_INTRO")
end

function onLevelStart()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("fx1", fx1_onTriggerEnter, fx1_onTriggerLeave)
	SetTriggerCallbacks("fx2", fx2_onTriggerEnter, fx2_onTriggerLeave)
	SetTriggerCallbacks("fx3", fx3_onTriggerEnter, fx3_onTriggerLeave)
	SetTriggerCallbacks("fx4", fx4_onTriggerEnter, fx4_onTriggerLeave)
	SetTriggerCallbacks("fx5", fx5_onTriggerEnter, fx5_onTriggerLeave)
	SetTriggerCallbacks("fx7", fx7_onTriggerEnter, fx7_onTriggerLeave)
	SetTriggerCallbacks("fx8", fx8_onTriggerEnter, fx8_onTriggerLeave)
	SetTriggerCallbacks("fx9", fx9_onTriggerEnter, fx9_onTriggerLeave)
end

function onUnitDestroyed(unit)
	destroyed = destroyed + 1
	if unit.defender and destroyed == 5 then
		ShowDialog ("talkingheads/full/soldier", "TXT_BLACKKING_CAMPAIGN3_4_PREP")
		AddTimer(1.0, Liberate)
		PlayVFX("PA_SpawnReinforcement", "fx10")
		PlayVFX("PA_SpawnReinforcement", "fx11")
		PlayVFX("PA_SpawnReinforcement", "fx12")
		PlayVFX("PA_SpawnReinforcement", "fx13")
		AddTimer(10.0, SpawnFX)
	end
end

function Liberate()
	SpawnUnits("prisoner",Army2)
end

function SpawnFX()

		PlayVFX("PA_SpawnReinforcement", "fx1")
		PlayVFX("PA_SpawnReinforcement", "fx2")
		PlayVFX("PA_SpawnReinforcement", "fx3")
		PlayVFX("PA_SpawnReinforcement", "fx4")
		PlayVFX("PA_SpawnReinforcement", "fx5")
		PlayVFX("PA_SpawnReinforcement", "fx7")
		PlayVFX("PA_SpawnReinforcement", "fx8")
		PlayVFX("PA_SpawnReinforcement", "fx8")
		AddTimer(1.0, Counter_Attack)

end

function Counter_Attack()
		
		ShowDialog ("talkingheads/full/almarand", "TXT_BLACKKING_CAMPAIGN3_4_ATTACK")
		SpawnUnits("titan", Army2)
	    SpawnUnits("spawn", Army1)
	    SpawnUnits("spawn1", Army1)
		SpawnUnits("spawn2", Army1)
		SetWinnable(true)
		SetVictoryBarEnabled(true)
end

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 12 then			
			Army = 12
			Army1 = 11
			Army2 = 10
			SpellLevel = 10
		elseif Rank == 13 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("start1", Army1)
	SpawnUnits("start2", Army1)   	
	SpawnUnits("start", Army1)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
		SpawnUnits("start1", Army1)
		SpawnUnits("start2", Army1)   	
		SpawnUnits("start", Army)
		SpawnUnits("titan", Army2)
	    SpawnUnits("spawn", Army1)
	    SpawnUnits("spawn", Army1)
		SpawnUnits("spawn1", Army1)
		SpawnUnits("spawn2", Army1)
	end
end