destroyed = 0
SpellLevel = 0
Rank = 0
patrol = 0
Army = 24
Army1 = 24
Leader = 33

function onDeployStart()
	createStartingTroops(False)
	SpawnUnits("Leader",Leader)
	SpawnUnits("crew",Army)
	SpawnUnits("camp",Army1)
local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_2_1")
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_2_2")
	end
end


function onLevelStart()
	SetTriggerCallbacks("swamp", swamp_onTriggerEnter, swamp_onTriggerLeave)
	SetTriggerCallbacks("surprise", surprise_onTriggerEnter, surprise_onTriggerLeave)
	SetTriggerCallbacks("reinforcements", reinforcements_onTriggerEnter, reinforcements_onTriggerLeave)
	SetTriggerCallbacks("attack", attack_onTriggerEnter, attack_onTriggerLeave)
	--AddTimer(45.0, patrigger)
	--AddTimer(3.0, suicidesquad)
	--SetBattleTimeoutTime(240,0)
	SetWinnable(false)
	AddTimer(0.0, Standstillcamp)
	AddTimer(0.0, Standstillleader)
    SetVictoryBarType("ASSASSINATION")
	DisableAiSpells()
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state.
	end
end


 function Standstillleader() -- tells the titan and his crew to stand ground
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("Leader",false)
	end
	
	local units = GetUnits("crew","*", 1)
		for i,unit in pairs(units) do
		 SetUnitStandGuard(unit, true)
		 SetCanGrowAwareness("Leader",false)
	end
end

 function Standstillleaderonly() -- tells the titan to stand ground
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("Leader",false)
	end
end

function Standstillcamp() -- tells the camp to stand ground
	local units = GetUnits("camp", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("camp",false)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then -- DOT-31422 JKUng: Script called for only killing the Titan, which is inconsistent with how most missions like this are played. Now forcing complete defender wipe to win mission. 
	destroyed = destroyed + 1
		if destroyed == 10 then
		AddTimer(3,YouWin)
		end
	end
end

function YouWin()
   Win()
 end


function awarenessleader()
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
		SetCanGrowAwareness("Leader",true)
	end
end

function awarenesscamp()
	local units = GetUnits("camp", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
		SetCanGrowAwareness("camp",true)
	end
end

function awarenesscrew()
	local units = GetUnits("crew", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
		SetCanGrowAwareness("crew",true)
	end
end

-- Once "reinforcements" trigger is hit by the player, disable it, move camp towards player ("attack trigger") and turn on their awareness.
-- This is so the camp "sees" the player approaching the fort head on and goes to fight them.
function reinforcements_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_2_3")
		DisableTrigger("reinforcements")
		DisableTrigger("swamp")
		EnableAiSpells()
		AddTimer(7.0,awarenessleader)
		AddTimer(2.0,awarenesscamp)
		AddTimer(0.0,awarenesscrew)
	end
end

-- Makes sure AI spells enabled even if the player only hits the swamp trigger.
function attack_onTriggerEnter(unit)
	if unit.attacker then
		EnableAiSpells()
		DisableTrigger("attack")
		AddTimer(7.0,awarenessleader)
		AddTimer(0.0,awarenesscrew)
	end
end

-- Once "swamp" trigger is hit by the player, disable it, disable "reinforcements"" trigger and turn on their awareness.
-- This is so if the player approaches via the swamp, the camp engages them there by growing their awareness.
-- No specific trigger zone for the camp to move towards, they'll be guided by awareness only.
function swamp_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("swamp")
		DisableTrigger("reinforcements")
		AddTimer(0.0,awarenesscamp)
	end
end

-- Once "surprise" is hit by the player the enemy titan responds to them coming out of the woods. (Calls them cowards maybe?)
-- As long as the player does not trigger the "reinforcements" zone, then they can attack without engaging the second camp.
function surprise_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/rouge","TXT_CAMPAIGN10B_2_4")
		DisableTrigger("surprise")
		GiveNamedUnitMoveOrder("Leader", "attack2")
		EnableAiSpells()
		AddTimer(1.0,awarenesscrew)
		--Standstillleaderonly()
		AddTimer(4.00,awarenessleader)
	end
end



function createStartingTroops(forPlinthInspector)
	
	if forPlinthInspector then
		SpawnUnits("Leader",Leader)
		SpawnUnits("crew",Army)
		SpawnUnits("camp",Army1)
	end
end










