destroyed = 0
DefendersZone = false
AttackersZone = false
Captured = false
Army = 24
Army1 = 24
Army2 = 24
Leader = 41

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	SetWinnable(false)		
	createStartingTroops(False)
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C5_INTRO")
	--AddTargetCircle("capture")

end

function onLevelStart()

	SetBattleTimeoutTime(300,0)
	SetVictoryBarEnabled(true)
	SetVictoryBarFill(0)
	SetTriggerCallbacks("capture", capture_onTriggerEnter, capture_onTriggerLeave)
	SetTriggerCallbacks("finalspawn", finalspawn_onTriggerEnter, finalspawn_onTriggerLeave)
	SetTriggerCallbacks("fx2", fx2_onTriggerEnter, fx2_onTriggerLeave)
	triggercheck()
	
end

function triggercheck()

	local var1 = CountDefendersInTrigger("capture")
	if var1 == 0 then 
		DefendersZone = false
	elseif var1 > 0 then
		DefendersZone = true
	end 
	
	local var2 = CountAttackersInTrigger("capture")
	if var2 == 0 then 
		AttackersZone = false
	elseif var2 > 0 then
		AttackersZone = true
	end 
	
	Success()
	
end


function Success()

	AddTimer(3.0, triggercheck)
	if AttackersZone == true then 
		Captured = true
	else
		Captured = false
	end

	if Captured == true then
		FinalSpeach()
	end
end


function finalspawn_onTriggerEnter(unit)

	if unit.attacker then
		
		DisableTrigger("finalspawn")
		ClearTargetCircles()
		PlayVFX("PA_SpawnReinforcement", "fx2")	
		AddTimer(1.0, finalspawn)
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C5_TITAN")
				
	
	end


end

function onUnitDestroyed(unit)
	if unit.defender then
			destroyed = destroyed + 1
			
		if destroyed == 8 then 
			--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10C5_CLOSE")
			AddTargetCircleWithArrow("capture")
			SetVictoryBarFill(0.6)
		end
		if destroyed == 11 then 
			SetVictoryBarFill(1)
		end
	end

end

function finalspawn()

	SpawnUnits("final",Army)
	SetWinnable(true)

end

function FinalSpeach ()

		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10C5_CAPTURE")
		AddTimer(3.0, endgame)
	
end

function endgame()

	Win()
	
end

function createStartingTroops(forPlinthInspector)
	
	if forPlinthInspector then
		SpawnUnits("Enemy",Army1)
		SpawnUnits("final",Army)
		
	end
end

