function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

-- Global variables
Army = 0
Rank = 0
destroyed = 0
dead = 0

--deploy phase
function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	--SetTalkingheadForUserTitan("talkingheads/full/brendon","TXT_CAMPAIGN2_1_1","TOP_LEFT")
	SpawnUnits("frontrow",Army)
    --SetUserTitanParticle("ST_RockPrison")
	SetAlliedPlayers(3,0)
	for i,unit in pairs(GetUnits("*", "*", 0)) do
	    if unit.isTitan then 
		TeleportUnit(unit, "titan")
		SwitchSide(unit, 3)
		end
	end
end

function go()
	SetFightButtonEnabled(true)
end

-- battle start
function onLevelStart()
	SetBattleTimeoutTime(150,0)
	SetMultipleUnitSelectionButtonEnabled(false)
    SetVictoryBarEnabled(false)
	Standstill()
	--SetAlliedPlayers(3,0)
	--for i,unit in pairs(GetUnits("*", "*", 0)) do
	--if unit.isTitan then 
		--SwitchSide(unit, 3)
		--end
	--end


end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_3_3")
			moreenemies()
		end
		if destroyed == 6 then
		    --AddTimer(0.1, framecamera2)
			AddTimer(6,win)
			ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_3_4")
			--SetTalkingheadForUserTitan("talkingheads/full/guard","TXT_CAMPAIGN2_3_5","TOP_LEFT")
		end
	end
	if unit.attacker then
		dead = dead + 1
		if dead == 3 then
		    Lose()
		end
	end
end

--here is where the second wave of spearman come in
function moreenemies()
    AddTimer(1.0, spawnmoreenemies)
	AddTimer(2.0, release)
    PlayVFX("PA_SpawnReinforcement", "enter1")
	PlayVFX("PA_SpawnReinforcement", "enter2")
	PlayVFX("PA_SpawnReinforcement", "enter3")
end

function spawnmoreenemies()
    SpawnUnits("backrow",Army)
	Standstill1()
	
end

function release()
	for i,unit in pairs(GetUnits("*", "*", 3)) do
	    if unit.isTitan then 
		SwitchSide(unit, 0)
		end
	end
	EnableUserTitan()
	ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_3_6")
end

function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "frontrow", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("frontrow",false)
	AddTimer(16.5,awarenesson)
end

function Standstill1() -- tells the unit to stand ground
	local units = GetUnits("*", "backrow", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("backrow",false)
	AddTimer(20.5,awarenesson1)
end

function awarenesson()
	SetCanGrowAwareness("frontrow",true)
end
function awarenesson1()
	SetCanGrowAwareness("backrow",true)
end

function framecamera2(seconds)
	FrameCamera("endcamera")
	EnableCameraControl(false)
end

function win()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 1 then
			Army = 1
		elseif Rank >= 4 then
			Army = 1
		end
    if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("frontrow",Army)
		SpawnUnits("backrow",Army)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_3_1")
		AddTimer(6, HideDialog)
		DisableUserTitan()
	end
end

function onTalkingHeadFinish(text)
	if text == "TXT_CAMPAIGN2_3_1" then
		framecamera()
	end
	if text == "TXT_CAMPAIGN2_3_2" then
		go()
		ReturnCamera()
	end
end

function framecamera(seconds)
	ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_3_2")
	AddTimer(6, HideDialog)
	FrameCamera("camera")
	EnableCameraControl(false)
end

