destroyed = 0
Army = 1
Army1 = 1
Army2 = 1
Army3 = 2

function onDeployStart()
	SpawnUnits("Enemy",Army3)
	SetWinnable(false)
	createStartingTroops(False)
	ShowDialogInPosition("talkingheads/full/soldier","TXT_CAMPAIGN_11_1_INTRO","BOTTOM_LEFT")
	ShowDialogInPosition("talkingheads/full/guard","TXT_MISSION3A_4_1","BOTTOM_LEFT")
	AddTargetCircle("finish")
end

function onLevelStart()
	
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetTriggerCallbacks("finish", finish_onTriggerEnter, finish_onTriggerLeave)
	SetTriggerCallbacks("warning", warning_onTriggerEnter, warning_onTriggerLeave)
	HoldUnit()
	
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("reinforce",Army)
	
	if forPlinthInspector then
		SpawnUnits("Enemy",Army3)
		SpawnUnits("reinforce",Army)
		SpawnUnits("spawn1",Army1)
		SpawnUnits("spawn2",Army2)
	end
	
end

function HoldUnit()

	local units = GetUnits("reinforce", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGuard(unit, true)
	end
	AddTimer(5.0, EnemyMove)
	
end

function EnemyMove()
	local units = GetUnits("reinforce", "*", 1)
	for i,unit in pairs(units) do
	GiveNamedUnitMoveOrder("reinforce", "finish")
	end

end

function trigger1_onTriggerEnter(unit)
	if unit.attacker then

		DisableTrigger("trigger1")
		SpawnUnits("spawn1",Army1)
		ShowDialogInPosition("talkingheads/full/soldier","TXT_CAMPAIGN11_1_AMBUSH","BOTTOM_LEFT")
	end

end

function trigger2_onTriggerEnter(unit)

	if unit.attacker then
		DisableTrigger("trigger2")
		SpawnUnits("spawn2",Army2)
		ShowDialogInPosition("talkingheads/full/soldier","TXT_CAMPAIGN11_1_AMBUSH2","BOTTOM_LEFT")
	end

end

function finish_onTriggerEnter(unit)

	if unit.spawnId == "reinforce" then
		DisableTrigger("finish")
		Lose()
		ShowDialogInPosition("talkingheads/full/soldier", "TXT_CAMPAIGN11_1_LOSE","BOTTOM_LEFT")
	
	end
	if unit.attacker then
		ShowDialogInPosition("talkingheads/full/soldier", "TXT_CAMPAIGN11_1_DEFEND","BOTTOM_LEFT")
		DisableTrigger("finish")
		SetVictoryBarEnabled(true)
		SetWinnable(true)
	end	
	

end

function warning_onTriggerEnter(unit)

	if unit.spawnId == "reinforce" then
		DisableTrigger("warning")
		ShowDialogInPosition("talkingheads/full/soldier", "TXT_CAMPAIGN11_1_WARN","BOTTOM_LEFT")
	end
	
end


function onUnitDestroyed(unit)
	
	if unit.spawnId == 'reinforce' then
		destroyed = destroyed + 1
			if destroyed >= 2 then
				SetWinnable(true)
				ShowDialogInPosition("talkingheads/full/soldier", "TXT_CAMPAIGN11_1_DEFEND","BOTTOM_LEFT")
			end
	end

end

