destroyed = 0
Army = 3
Army1 = 5
Army2 = 7

function onDeployStart()
	SetTriggerCallbacks("fireballTrigger", onTriggerEnter_fireballTrigger)
	SpawnUnits("EnemyPL1",Army1)
	SpawnUnits("EnemyPL2",Army1)
	SpawnUnits("EnemyPL3",Army1)
	SpawnUnits("EnemyPL4",Army1)
	SpawnUnits("EnemyPR1",Army1)
	SpawnUnits("EnemyPR2",Army1)
	SpawnUnits("EnemyPR3",Army1)
	SpawnUnits("EnemyPR4",Army1)
	SpawnUnits("Enemy1",Army)
	SpawnUnits("Archer",Army1)
	SetWinnable(false)
	createStartingTroops(False)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_1_1")
	AddTimer(4.0, removeText)
	AddTimer(4.5, showArcher)
	local units = GetUnits("Archer", "*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onLevelStart()
	SetTriggerCallbacks("leftPikeman1", onTriggerEnter_leftPikeman1, onTriggerLeave_leftPikeman1)
	SetTriggerCallbacks("leftPikeman2", onTriggerEnter_leftPikeman2, onTriggerLeave_leftPikeman2)
	SetTriggerCallbacks("leftPikeman3", onTriggerEnter_leftPikeman3, onTriggerLeave_leftPikeman3)
	SetTriggerCallbacks("leftPikeman4", onTriggerEnter_leftPikeman4, onTriggerLeave_leftPikeman4)
	SetTriggerCallbacks("rightPikeman1", onTriggerEnter_rightPikeman1, onTriggerLeave_rightPikeman1)
	SetTriggerCallbacks("rightPikeman2", onTriggerEnter_rightPikeman2, onTriggerLeave_rightPikeman2)
	SetTriggerCallbacks("rightPikeman3", onTriggerEnter_rightPikeman3, onTriggerLeave_rightPikeman3)
	SetTriggerCallbacks("rightPikeman4", onTriggerEnter_rightPikeman4, onTriggerLeave_rightPikeman4)
	SetVictoryBarEnabled(false)

--[[GiveNamedUnitMoveOrder("EnemyPL1", "leftPikeman1") -- Jkung DOT-36560 - moving down to post fireball/fence opening
	GiveNamedUnitMoveOrder("EnemyPL2", "leftPikeman1")
	GiveNamedUnitMoveOrder("EnemyPL3", "leftPikeman1")
	GiveNamedUnitMoveOrder("EnemyPL4", "leftPikeman1")
	
	GiveNamedUnitMoveOrder("EnemyPR1", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR2", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR3", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR4", "rightPikeman1")
--]]	
	ClearTargetCircles()
	Standstill()
	local units = GetUnits("Archer", "*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onTriggerEnter_fireballTrigger(unit) -- Jkung DOT-36560 created fireballs to "open" fences
	if unit.attacker then
		DisableTrigger("fireballTrigger")
		AddTimer(1.0,fireballTrigger1)
		AddTimer(1.75,fireballTrigger2)
		AddTimer(6.0,fireballTrigger3)
		AddTimer(6.75,fireballTrigger4)
		AddTimer(3.5,moveSpearmen)
	end
end

function fireballTrigger1() -- Jkung DOT-36560 created fireballs to "open" fences
	CastSpell("Fireball", 5, "fireball1",0)
end

function fireballTrigger2() -- Jkung DOT-36560 created fireballs to "open" fences
	CastSpell("Fireball", 5, "fireball2",0)
end

function fireballTrigger3() -- Jkung DOT-36560 created fireballs to "open" fences
	CastSpell("Fireball", 5, "fireball3",0)
end

function fireballTrigger4() -- Jkung DOT-36560 created fireballs to "open" fences
	CastSpell("Fireball", 5, "fireball4",0)
end

function moveSpearmen()  -- Jkung DOT-36560 moved move commands post fireball "opening" fence
	GiveNamedUnitMoveOrder("EnemyPL1", "leftPikeman1")
	GiveNamedUnitMoveOrder("EnemyPL2", "leftPikeman1")
	GiveNamedUnitMoveOrder("EnemyPL3", "leftPikeman1")
	GiveNamedUnitMoveOrder("EnemyPL4", "leftPikeman1")
	
	GiveNamedUnitMoveOrder("EnemyPR1", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR2", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR3", "rightPikeman1")
	GiveNamedUnitMoveOrder("EnemyPR4", "rightPikeman1")
end

function onTriggerEnter_leftPikeman1(unit)
	if unit.spawnId == "EnemyPL1" then
		GiveNamedUnitMoveOrder("EnemyPL1", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPL2" then
		GiveNamedUnitMoveOrder("EnemyPL2", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPL3" then
		GiveNamedUnitMoveOrder("EnemyPL3", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPL4" then
		GiveNamedUnitMoveOrder("EnemyPL4", "leftPikeman2")
		DisableTrigger("leftPikeman1")
	end
end

function onTriggerEnter_leftPikeman2(unit)
	if unit.spawnId == "EnemyPL1" then
		GiveNamedUnitMoveOrder("EnemyPL1", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPL2" then
		GiveNamedUnitMoveOrder("EnemyPL2", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPL3" then
		GiveNamedUnitMoveOrder("EnemyPL3", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPL4" then
		GiveNamedUnitMoveOrder("EnemyPL4", "leftPikeman3")
		DisableTrigger("leftPikeman2")
	end
end

function onTriggerEnter_leftPikeman3(unit)
	if unit.spawnId == "EnemyPL1" then
		GiveNamedUnitMoveOrder("EnemyPL1", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPL2" then
		GiveNamedUnitMoveOrder("EnemyPL2", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPL3" then
		GiveNamedUnitMoveOrder("EnemyPL3", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPL4" then
		GiveNamedUnitMoveOrder("EnemyPL4", "leftPikeman4")
		DisableTrigger("leftPikeman3")
	end
end

function onTriggerEnter_rightPikeman1(unit)
	if unit.spawnId == "EnemyPR1" then
		GiveNamedUnitMoveOrder("EnemyPR1", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPR2" then
		GiveNamedUnitMoveOrder("EnemyPR2", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPR3" then
		GiveNamedUnitMoveOrder("EnemyPR3", "leftPikeman2")
	end
	if unit.spawnId == "EnemyPR4" then
		GiveNamedUnitMoveOrder("EnemyPR4", "leftPikeman2")
		DisableTrigger("rightPikeman1")
	end
end

function onTriggerEnter_rightPikeman2(unit)
	if unit.spawnId == "EnemyPR1" then
		GiveNamedUnitMoveOrder("EnemyPR1", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPR2" then
		GiveNamedUnitMoveOrder("EnemyPR2", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPR3" then
		GiveNamedUnitMoveOrder("EnemyPR3", "leftPikeman3")
	end
	if unit.spawnId == "EnemyPR4" then
		GiveNamedUnitMoveOrder("EnemyPR4", "leftPikeman3")
		DisableTrigger("rightPikeman2")
	end
end

function onTriggerEnter_rightPikeman3(unit)
	if unit.spawnId == "EnemyPR1" then
		GiveNamedUnitMoveOrder("EnemyPR1", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPR2" then
		GiveNamedUnitMoveOrder("EnemyPR2", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPR3" then
		GiveNamedUnitMoveOrder("EnemyPR3", "leftPikeman4")
	end
	if unit.spawnId == "EnemyPR4" then
		GiveNamedUnitMoveOrder("EnemyPR4", "leftPikeman4")
		DisableTrigger("rightPikeman3")
	end
end

function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("EnemyPL1",Army1)
		SpawnUnits("EnemyPL2",Army1)
		SpawnUnits("EnemyPL3",Army1)
		SpawnUnits("EnemyPL4",Army1)
		SpawnUnits("EnemyPR1",Army1)
		SpawnUnits("EnemyPR2",Army1)
		SpawnUnits("EnemyPR3",Army1)
		SpawnUnits("EnemyPR4",Army1)
		SpawnUnits("Enemy1",Army)
		SpawnUnits("Archer",Army1)
	end
	
end

function HoldUnit()

	local units = GetUnits("reinforce", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGuard(unit, true)
	end
	AddTimer(30.0, EnemyMove)
	
end

function removeText()
	HideDialog()
end

function showArcher()
	FrameCamera("archerCamera")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_1_2")
	AddTargetCircle("archerCamera")
	AddTimer(4.0, removeText)
	AddTimer(4.0, flankingText)
end

function flankingText()
	ReturnCamera()
	ShowDialog("talkingheads/full/guard","TXT_MISSION3B_1_3")
	AddTimer(4.0, removeText)
	AddTimer(4.0, EnableControls)
end

function EnableControls()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function EnemyMove()
	local units = GetUnits("reinforce", "*", 1)
	for i,unit in pairs(units) do
	GiveNamedUnitMoveOrder("reinforce", "finish")
	end

end

function onUnitDestroyed(unit)
	if unit.spawnId == "Archer" then
	   AddTimer(0.5,YouWin)
	end
end

function YouWin()
   Win()
 end

 function Standstill() -- tells the unit to stand ground
                local units = GetUnits("Archer", "*", 1)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
                SetCanGrowAwareness("Archer",false)
				AddTimer(1.0, Standstill)
end
