SpellLevel = 0
Rank = 0
destroyed = 0
Army = 4
Army1 = 4
Army2 = 3
Titan = 8

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SpawnUnits("Enemy",Army2)
    SetWinnable(false)	-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	AddTimer(5.0, showPortal)
end

function showPortal()
	FrameCamera("win")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_6_1")
	AddTargetCircle("win")
	AddTimer(4.0, returnCam)
	AddTimer(4.0, removeText)
end

function returnCam()
	removeText()
	ReturnCamera()
	EnableControls()
end

function EnableControls()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function removeText()
	HideDialog()
end

--removes dialog and adds combat buttons onto screen
function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

--sets the triggers in the level
function onLevelStart()
	AddTimer(5.0, spawnVFX1)
	SetBattleTimeoutTime(180,0)
	AddTimer(180,Lose)
end

function spawnVFX1()
   ShowDialog("talkingheads/full/guard","TXT_MISSION3C_6_2")
   PlayVFX("PA_SpawnReinforcement", "skeleton1")
   PlayVFX("PA_SpawnReinforcement", "skeleton2")
   AddTimer(1.0, spawnWave1)
end

function spawnWave1()
   SpawnUnits("wave1",Army)
   AddTimer(7.0, spawnVFX2)
end

function spawnVFX2()
--   PlayVFX("PA_SpawnReinforcement", "militia1")
--   PlayVFX("PA_SpawnReinforcement", "militia2")
   AddTimer(1.0, spawnWave2)
end

function spawnWave2()
   SpawnUnits("wave2",Army)
   AddTimer(7.0, spawnVFX3)
end

function spawnVFX3()
   PlayVFX("PA_SpawnReinforcement", "pikemen1")
   PlayVFX("PA_SpawnReinforcement", "pikemen2")
   PlayVFX("PA_SpawnReinforcement", "archer1")
   PlayVFX("PA_SpawnReinforcement", "archer2")
   AddTimer(1.0, spawnWave3)
end

function spawnWave3()
   SpawnUnits("wave3",Army2)
   AddTimer(8.0, spawnVFX4)
end

function spawnVFX4()
   PlayVFX("PA_SpawnReinforcement", "skeleton3")
   PlayVFX("PA_SpawnReinforcement", "skeleton4")
   PlayVFX("PA_SpawnReinforcement", "titan")
   AddTimer(1.0, spawnWave4)
end

function spawnWave4()
   SpawnUnits("wave4",Army)
   SpawnUnits("titan",Titan)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 12 then
			--ShowDialog("talkingheads/full/guard","TXT_MISSION3C_6_3")
			SetTriggerCallbacks("win", win_onTriggerEnter, win_onTriggerLeave)
		end
	end
end

function win_onTriggerEnter(unit)
	if unit.attacker then
		Win()
	end
end

function createStartingTroops(forPlinthInspector)
		
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army2)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army2)
		SpawnUnits("wave4",Army)
		SpawnUnits("titan",Titan)
	end
end