
SpellLevel = 0
Army = 4
Army1 = 5
Army2 = 4
Rank = 0
destroyed = 0

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)

end


function onLevelStart()
	SetupVictoryBar()
	SetWinnable(false)
end


function createStartingTroops(forPlinthInspector)
	SpawnUnits("start",Army)
	SpawnUnits("start2",Army)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army2)
		SpawnUnits("start2",Army)
		SpawnUnits("wave2",Army2)
		SpawnUnits("wave3",Army2)
	end
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			SetVictoryBarFill(0.1)
		elseif destroyed == 2 then
			SpawnUnits("wave1",Army2)
			SetVictoryBarFill(0.2)
		elseif destroyed == 3 then
			SetVictoryBarFill(0.3)
		elseif destroyed == 4 then
			SetVictoryBarFill(0.4)
		elseif destroyed == 5 then
			SpawnUnits("wave2",Army2)
			SetVictoryBarFill(0.5)
		elseif destroyed == 6 then
			SetVictoryBarFill(0.6)
		elseif destroyed ==	7 then
			SpawnUnits("wave3",Army2)
			SetVictoryBarFill(0.7)
			SetWinnable(true)
		elseif destroyed == 8 then
			SetVictoryBarFill(0.8)
		elseif destroyed == 9 then
			SetVictoryBarFill(0.9)
		elseif destroyed == 10 then
			SetVictoryBarFill(1)
		end
	end
end


function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/10)
	AddVictoryBarMarker(6/10)
	AddVictoryBarMarker(8/10)
	AddVictoryBarMarker(1.0)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("camera")
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_6_1")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6,intro)
end

function intro()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_6_2")
	AddTimer(6,buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end
