Army = 6
Army1 = 6
Army2 = 6
Titan = 9
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0
playonce = 0
spellonce = 0
onemessage = 0

-- The below is for spawning a spell in a trigger at the start of a match.

function QueueAssets()
	QueueVFX("ElderStone_EnergyProp") -- main effect
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	SpawnUnits("Enemy1",Army2)
	PlayVFX("ElderStone_EnergyProp", "fx1") -- main effect
	SetTriggerCallbacks("drop4", drop4_onTriggerEnter, drop4_onTriggerLeave)
	SetTriggerCallbacks("drop3", drop3_onTriggerEnter, drop3_onTriggerLeave)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			PlayVFX("PA_SpawnReinforcement", "titan")
			AddTimer(1,titanspawn)
		end
	end
end

function titanspawn()
    SpawnUnits("titan",Titan)
end

function createStartingTroops(forPlinthInspector)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("Enemy",Army1)
	    SpawnUnits("Enemy1",Army2)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		DropSpell("Fireball", 5, "drop4")
		DropSpell("Lightning", 5, "drop3")
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("camera")
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4D_6_1")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6,buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end
