
SpellLevel = 0
Army = 0
Rank = 0
PlayerUnits = 0
Endpoint = 0
destroyed = 0
deadarcher = 0
Army1 = 6
Army2 = 6


function onDeployStart()
	createStartingTroops(False)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	local units = GetUnits("*", "CampArcher*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	raininghell()
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 9
	SpellLevel = 7
	Army = 7
    SpawnUnits("CampArcher",Army2)
	SpawnUnits("skeletonright",Army1)
	SpawnUnits("left",Army1)
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("CampArcher")
		SpawnUnits("skeletonright")
	    SpawnUnits("left")
	end
end

function onLevelStart()
    SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "CampArcher*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_3")
	SetTriggerCallbacks("enter", enter_onTriggerEnter)
end

function raininghell()
	CastSpell("Lightning", SpellLevel, "storm"..math.random(7), 3)
	AddTimer(math.random(5), raininghell)
end

function enter_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("enter")
		GiveNamedUnitMoveOrder("left", "defendl")
		GiveNamedUnitMoveOrder("skeletonright","defendr")
	end
end

function onUnitDestroyed(unit)
	--if unit.defender then
		--destroyed = destroyed + 1
		--if destroyed == 5 then
		--	RespawnUnits("start2",Army1)		
		--end
	--end
	if unit.spawnId == "CampArcher" then
		deadarcher = deadarcher + 1
		if deadarcher == 3 then
            AddTimer(0.5,YouWin)
		end
	end
end

function YouWin()
   Win()
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
   -- ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_1","TOP_LEFT")
	FrameCamera("camera")
	AddTimer(5, ReturnCamera)
	EnableCameraControl(false)
	AddTargetCircleWithArrow("circle")
	AddTargetCircleWithArrow("circle2")
	AddTargetCircleWithArrow("circle1")
	AddTimer(6,intro)
end

function intro()
   -- ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_2","TOP_LEFT")
	AddTimer(6,buttonunlock)
	--ClearTargetCircles()
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end





