Army = 6



function onDeployStart()
	SetTriggerCallbacks("switchsides1", onTriggerEnter_trigger_switchsides1, onTriggerLeave_trigger_switchsides1)
	SetTriggerCallbacks("switchsides", onTriggerEnter_trigger_switchsides, onTriggerLeave_trigger_switchsides)
	SpawnUnits("traitor",Army)
	SpawnUnits("loyal",Army)
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN6C_2_1")
	end
end


function onTriggerEnter_trigger_switchsides(unit)

	--if it's a friendly unit entering
	if unit.attacker then
		DisableTrigger("switchsides") -- disable the trigger
		ShowDialog("talkingheads/full/Kobar", "TXT_CAMPAIGN6C_2_2")
	end
	local units = GetUnits("*", "*",3) --switches sides if all units on this side
	for i,unit in pairs(units) do
			SwitchSide(unit, 0)
	end
end


function onTriggerEnter_trigger_switchsides1(unit)

	--if it's a friendly unit entering
	if unit.attacker then
		DisableTrigger("switchsides1") -- disable the trigger
		ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN6C_2_3")
	end
	local units = GetUnits("traitor*", "*",0) --switches sides if all units with traitor in spawnid
	for i,unit in pairs(units) do
			SwitchSide(unit, 1)
	end
end



function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 6-7
	SpellLevel = 9

	
-- For plinth inspector, we want the later waves too HAVE YET TO UPDATE THIS PROPERLY
	if forPlinthInspector then
		SpawnUnits("traitor",Army)
		SpawnUnits("loyal",Army)
	end
end