Army = 8
Army1 = 8
destroyed = 0

-- called at before the deploy phase
function onDeployStart()
	SpawnUnits("Enemy",Army)
	SpawnUnits("enemy2",Army1)
	SpawnUnits("allies",Army1)
--	AddTimer(1, killdummies)
	SetWinnable(false)	
	-- register the triggers in the level
	SetTriggerCallbacks("NEW_SHAPE", onTriggerEnter_trigger_NEW_SHAPE, onTriggerLeave_trigger_NEW_SHAPE)
	SetTriggerCallbacks("kill", onTriggerEnter_trigger_kill, onTriggerLeave_trigger_kill)
	ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN6D_4_1")	
end

function onTriggerEnter_trigger_kill(unit)
	SpawnUnits("dummies",Army1)
	local units = GetUnits("dummies", "*", 1)
	for i,unit in pairs(units) do
		KillUnit(unit)
	end
end

-- called after the deploy phase
function onLevelStart()
	--SetPanningCamera(26.2,-99,53,-0.43,-0.40)
	SetBattleTimeoutTime(480)
	SetAI1() -- allies
	SetAI2() -- enemy attacking allies
	HideDialog()
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("allies", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("enemy2", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end
 

function onTriggerEnter_trigger_NEW_SHAPE(unit)
	if unit.attacker then
		DisableTrigger("NEW_SHAPE") 
	local units = GetUnits("allies", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		local units = GetUnits("enemy2", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
	end
end

function createStartingTroops(forPlinthInspector)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("enemy2",Army1)
		SpawnUnits("dummies",Army1)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 15 then
			AddTimer(3,YouWin)
		end
	end
end

function YouWin()
	SetWinnable(true)	
	Win()
end
