destroyed = 0
SpellLevel = 0
Army = 8
Army1 = 8
Army2 = 8
Rank = 0

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
end

function onLevelStart()
	SetupVictoryBar()
	SetTriggerCallbacks("protect", protect_onTriggerEnter) -- central area player is supposed to protect
	
end

function FireText()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN6F_3_1")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN6F_3_2")
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			RespawnUnits("start1", Army1)
			AddTimer(1.0,  FireText)
		elseif destroyed == 8 then
			RespawnUnits("start2", Army1)
		elseif destroyed == 10 then
			RespawnUnits("start3", Army2)
			--ShowDialog ("talkingheads/full/guard","TXT_CAMPAIGN6F_3_3")
		elseif destroyed == 13 then
			SetWinnable(true)
		end
	end
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(4/14)
	AddVictoryBarMarker(8/14)
	AddVictoryBarMarker(10/14)
	AddVictoryBarMarker(1.0)
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 6
	SpellLevel = 10
	
	SpawnUnits("start", Army)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start", Army)
		SpawnUnits("start1", Army1)
		SpawnUnits("start2", Army1)
		SpawnUnits("start3", Army2)
	end
end










