
SpellLevel = 5
destroyed = 0
wizardsdead = 0
Army = 19
Titan = 30

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SpawnUnits("firewizard",Army)
	SpawnUnits("lightwizard",Army)
	SpawnUnits("start",Army)
	PlayVFX("ElderStone_EnergyPropStones", "vfx1")
	PlayVFX("ElderStone_EnergyPropStones", "vfx2")
	AddTimer(1.0,fireside)
	AddTimer(1.0,lightside)
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_1")
end

function onLevelStart()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_2")
end

function fireside()
	CastSpell("Lightning", SpellLevel, "strikes"..math.random(3), 1)
	AddTimer(math.random(4), fireside)
end

function lightside()
	CastSpell("Lightning", SpellLevel, "ice"..math.random(3), 1)
	AddTimer(math.random(4), lightside)
end

function onUnitDestroyed(unit)
	if unit.spawnId == "firewizard" then
		wizardsdead = wizardsdead + 1
		CancelTimer(fireside)
			if wizardsdead == 1 then
				ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_3")
			elseif wizardsdead == 2 then
				PlayVFX("PA_SpawnReinforcement","newshape")
				SpawnUnits("Leader",Titan)
				ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_4")
			end
	end
	if unit.spawnId == "lightwizard" then
		wizardsdead = wizardsdead + 1
		CancelTimer(lightside)
			if wizardsdead == 1 then
				ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_3")
			elseif wizardsdead == 2 then
				PlayVFX("PA_SpawnReinforcement","newshape")
				SpawnUnits("Leader",Titan)
				ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_5_4")
			end
	end
end

function createStartingTroops(forPlinthInspector)
	
	
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("lightwizard",Army)
		SpawnUnits("firewizard",Army)
        SpawnUnits("Leader",Titan)
		SpawnUnits("start",Army)
	end
end