destroyed = 0
SpellLevel = 11
Army = 12
Army1 = 12
Army2 = 12
Rank = 0
Titan = 22

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	--AddTargetCircle("moveto2")   -- move to targets for player 
	--AddTargetCircle("moveto1")	-- move to targets for player
	PlayVFX("ElderStone_EnergyPropStones", "stone1")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyPropStones", "stone3")
	PlayVFX("ElderStone_EnergyProp", "elderstone")
	--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP_ELITHEN3_3_PATROL_1")
	
end



function onLevelStart()
	SetBattleTimeoutTime(300, 0) -- set battle timer for 6 minutes
	SetVictoryBarEnabled(false)
	AddTimer(300, outoftime) -- set lose condition to kick in after 4 minutes
	SetWinnable(false)	-- level cannot be completed even if no enemy units are alive
	SetTriggerCallbacks("patrol2", patrol2_onTriggerEnter, patrol2_onTriggerLeave)
	SetTriggerCallbacks("patrol3", patrol3_onTriggerEnter, patrol3_onTriggerLeave)
	SetTriggerCallbacks("patrol4", patrol4_onTriggerEnter, patrol4_onTriggerLeave)
	SetTriggerCallbacks("exit", exit_onTriggerEnter, exit_onTriggerLeave)
	--GiveNamedUnitMoveOrder("spawn1", "gohere")
    DisableAiSpells()
end

function patrol2_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol2")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP_ELITHEN3_3_PATROL_2")
	end	
end

function patrol3_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol3")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP_ELITHEN3_3_PATROL_3")
		PlayVFX("PA_SpawnReinforcement", "impact4")
		AddTimer(1,spawnspear)
	end	
end

function spawnspear()
    SpawnUnits("spawn1",Army)
end

function patrol4_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol4")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP_ELITHEN3_3_PATROL_4")
		SpawnUnits("spawn2",Army)
	end
end

function exit_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("exit")	
		--SpawnUnits("spawn3",Army)
		PlayVFX("PA_SpawnReinforcement", "impact1")
		PlayVFX("PA_SpawnReinforcement", "impact2")
		PlayVFX("PA_SpawnReinforcement", "impact3")
		AddTimer(1,spawnenemies)
	end	
end

function spawnenemies()
    SpawnUnits("spawn3",Army)
	SpawnUnits("titan",Titan)
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank -3
			Titan = 8
		elseif Rank == 7 then			
			Army =  5
			Army1 = 6
			Army2 = 4
			Titan = 9
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank -3
			Titan = 10
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank -3
			Titan = 12
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
		    Army2 = Rank -3
			Titan = 14
		elseif Rank == 11 then			
			Army = 9
			Army1 = 10
			Army2 = 8
			Titan = 16
		elseif Rank == 12 then			
			Army = 10
			Army1 = 11
			Army2 = 9
			Titan = 18
		elseif Rank == 13 then			
			Army = 11
			Army1 = 12
			Army2 = 10
			Titan = 20
		elseif Rank >= 14 then			
			Army = 12
			Army1 = 13 
			Army3 = 11
			Titan = 22
		end
--]]
--		SpawnUnits("spawn1",Army) 
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn3",Army)
		SpawnUnits("titan",Titan)
	end
end

function outoftime()
    Lose()
end

