SpellLevel = 9
Army = 9
Rank = 0
Titan = 18



function onDeployStart()
	SetTriggerCallbacks("rivertrigger", onTriggerEnter_trigger_rivertrigger, onTriggerLeave_trigger_rivertrigger)
	SetTriggerCallbacks("camptrigger", onTriggerEnter_trigger_camptrigger, onTriggerLeave_trigger_camptrigger)
	createStartingTroops(False)
	local units = GetUnits("*", "Titan", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_2_6_1")
end

function onLevelStart()
	SetVictoryBarType("ASSASSINATION")
	DisableAiSpells()
	local units = GetUnits("*", "Titan", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		if unit.spawnId == "Titan" then
			AddTimer(0.5,YouWin)
		end
	end
end

function YouWin()
   Win()
 end
 
 function onTriggerEnter_trigger_rivertrigger(unit)
	--[[local units = GetUnits("*", "*",2) --switches the titan back to aggro.
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
	end]]
	if unit.attacker then
		DisableTrigger("rivertrigger")
		DisableTrigger("camptrigger")
		GiveNamedUnitMoveOrder("Titan", "rivermove")
		GiveNamedUnitMoveOrder("Leader1", "rivermove")
	end
end

 function onTriggerEnter_trigger_camptrigger(unit)
	--[[local units = GetUnits("*", "*",2) --switches the titan back to aggro.
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
	end]]
	if unit.attacker then
		DisableTrigger("rivertrigger")
		DisableTrigger("camptrigger")
		GiveNamedUnitMoveOrder("Titan", "campmove")
		GiveNamedUnitMoveOrder("Leader1", "campmove")
	end
end

 
 function createStartingTroops(forPlinthInspector)
 --[[
 	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("Titan",Titan)
	SpawnUnits("Leader1",Army)
	SpawnUnits("start",Army)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("Leader1",Army)
		SpawnUnits("start",Army)
	end
end

