destroyed = 0
death = 0
SpellLevel = 11
Rank = 0
Army = 10
Army1 = 10
Titan = 20

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	--ShowDialogEternal("talkingheads/full/guard", "TXT_CAMPAIGN_MOSSMANE_3_6_1")
    AddTimer(4,talk)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function talk()
    HideDialog()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer (1,starttitan)
end

function starttitan()
    SpawnUnits("starttitan",Titan)
	--ShowDialog("talkingheads/full/hero", "TXT_CAMPAIGN_MOSSMANE_3_6_2")
	AddTimer(4.8,startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function onLevelStart()
	
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			RespawnUnits("start2",Army)
		end
		if destroyed == 7 then
		    AddTimer(6,ending)
			--ShowDialogEternal("talkingheads/full/mossdip", "TXT_CAMPAIGN_MOSSMANE_3_6_4")
		end
	end
	if unit.attacker then
		death = death + 1
		if death == 1 then
			SpawnUnits("backup",Army)
			--ShowDialogEternal("talkingheads/full/mossdip", "TXT_CAMPAIGN_MOSSMANE_3_6_3")
			AddTimer(4,closetalk)
		end
	end
end

function closetalk()
    HideDialog()
end

function ending()
    HideDialog()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
	SpawnUnits("start",Army)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("starttitan",Titan)
	end
end










