destroyed = 0
convo_done = false
in_zone = 0
Army = 7
Army1 = 7

function onDeployStart()

	createStartingTroops(False)
	SetTriggerCallbacks("allyspawn", allyspawn_onTriggerEnter, allyspawn_onTriggerLeave)
	SetTriggerCallbacks("flip", flip_onTriggerEnter, flip_onTriggerLeave)
	--ShowDialog("talkingheads/full/guard", "TXT_CAMP_UNAK3_2_INTRO")
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	
	
end

function onLevelStart()
	
	SetAI1() -- allies
	SetAI2() -- enemy attacking allies3
	SetVictoryBarEnabled(false)
	
	
end

-- AI Fight START

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 3)
	for i,unit in pairs(units) do
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function flip_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("flip") 
		SetVictoryBarEnabled(true)
		SetVictoryBarFill(0)
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
			--DisableInvincibility(unit)
			--ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_2_HELP")
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		
		destroyed = destroyed + 1
		if destroyed == 2  then
			--ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_2_ALLY")
			AddTargetCircle("objective")
			RagnarWalkies()
		end
		if destroyed == 3  then
			SetVictoryBarFill(0.2)
		end
		if destroyed == 7  then
			SetVictoryBarFill(0.7)
		end
		if destroyed == 10  then
			SetVictoryBarFill(1)
		end
	end
end


-- AI Fight END

--START Story Section

function RagnarWalkies()

	GiveNamedUnitMoveOrder("ragnarpal", "objective")
	
end

function allyspawn_onTriggerEnter(unit)

	if unit.attacker then
		in_zone = in_zone + 1
		if in_zone >= 1 then
			ClearTargetCircles("objective")
			local units = GetUnits("*", "*", 2) --switches sides and puts damage on
	        for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			--EnableAttackDamage(unit)
			DisableInvincibility(unit)
			--ShowDialog("Portraits/dip_ragnar_talkinghead", "TXT_CAMP_UNAK3_2_HELP")
	        end
			SpawnUnits("allyspawn",Army)
			DisableTrigger("allyspawn")
			--ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_2_THANK")
			SetVictoryBarFill(0.5)
			AddTimer(8.0, finalspawn)
		end
	end

end

function finalspawn()

	SpawnUnits("finalspawn",Army1)
	SetWinnable(true)
	--ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_2_ENEMY")

end

-- End Story Section

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 and Rank <= 13 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		elseif Rank >= 14 then
			SpellLevel = 13
			Army = 11
			Army1 = 12
			Army2 = 14
		end
--]]	
	SpawnUnits("start",Army)
	SpawnUnits("ragnarpal",Army)
	

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("finalspawn",Army1)
	end
end