AttackersZone1 = false
AttackersZone2 = false
DefendersZone1 = true
DefendersZone2 = true
captured = false
captured1 = false
respawner = 0
killcount = 0
SpellLevel = 0
Army = 0
Army1 = 0
Rank = 0
Timer = 0
EnemySpawnTimer = 0

CreateRandomisedListOfThings("List_Dialogue","TXT_DAILY_BATTLEORDER_VILLAGE_1","TXT_DAILY_BATTLEORDER_VILLAGE_2", "TXT_DAILY_BATTLEORDER_VILLAGE_3","TXT_DAILY_BATTLEORDER_VILLAGE_4")
CreateRandomisedListOfThings("List_Defeat","TXT_DAILY_BATTLEORDER_LOSE_1","TXT_DAILY_BATTLEORDER_LOSE_2","TXT_DAILY_BATTLEORDER_LOSE_3","TXT_DAILY_BATTLEORDER_LOSE_4")
CreateRandomisedListOfThings("List_Leavemessage","TXT_DAILY_BATTLEORDER_EXIT_1","TXT_DAILY_BATTLEORDER_EXIT_2","TXT_DAILY_BATTLEORDER_EXIT_3","TXT_DAILY_BATTLEORDER_EXIT_4")
CreateRandomisedListOfThings("List_Units","spawn_1","spawn_2","spawn_3")

function onDeployStart()
	AddTargetCircle("circle")
	createStartingTroops(False)
	--ShowDialog("talkingheads/full/guard","TXT_KOH_1")
end

function onLevelStart()
	SetTriggerCallbacks("capture", capture_onTriggerEnter, capture_onTriggerLeave) -- Player approaches the capture point
	SetTriggerCallbacks("leaving", leaving_onTriggerEnter, leaving_onTriggerLeave)
	triggercheck()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	AddTimer(45,capturecheck)
	
end

function capturecheck()
	local var1 = CountDefendersInTrigger("capture")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true	
	end 
		
	local var3 = CountAttackersInTrigger("capture")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	capturecheckresult()
end
function capturecheckresult()
	if AttackersZone1 == true then 
		captured = true
	else
		captured = false 			
	end
	
	if captured == false then
		ShowDialog("talkingheads/full/guard",GetRandomisedRandomThing("List_Defeat"))
		AddTimer(5,Defeat)
	end
end

function triggercheck()
	local var1 = CountDefendersInTrigger("capture")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true	
	end 
		
	local var3 = CountAttackersInTrigger("capture")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	Success()
	
end

function triggercheckend()
	local var1 = CountDefendersInTrigger("capture")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true	
	end 
		
	local var3 = CountAttackersInTrigger("capture")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	result()	
end

function Success()
	AddTimer(3.0, triggercheck)
	if AttackersZone1 == true then 
		captured = true
	else
		captured = false 			
	end
	
	if captured == false then
	
	end
	
	if captured == true then
		wincondition()
	end
end

-- this trigger will check if the player has captured the starting zone
function capture_onTriggerLeave(unit)
	if unit.attacker and captured==false then
	AddTimer(3.0, triggercheck)	
	end
end

--This trigger when left will send a message warning the player not to leave the defensive area
function leaving_onTriggerLeave(unit)
	if unit.attacker then
	ShowDialog("talkingheads/full/guard",GetRandomisedRandomThing("List_Leavemessage"))
	DisableTrigger("leaving")
	end
end


function wincondition()
		CancelTimer(triggercheck)
		ShowDialog("talkingheads/full/guard",GetRandomisedRandomThing("List_Dialogue"))
		-- Needs randomised message so player never always sees the same message
		SpawnUnits(GetRandomisedRandomThing("List_Units"),Army)
		AddTimer(Timer,ending)
		-- need to create timer based on player CL
		AddTimer(30.0,Spawnloop)
		--SetVictoryBarFill(0)
end


function Spawnloop()
-- Random function to randomise what troop comes from what direction
	RespawnUnits(GetRandomisedRandomThing("List_Units"),Army)
	AddTimer(EnemySpawnTimer,Spawnloop)
end

function ending()
    triggercheckend()
end

function result()
	if AttackersZone1 == true then 
		captured = true
	else
		captured = false 			
	end
	
	if captured == false then
		Defeat()
	end
	
	if captured == true then
		Victory()
		--SetVictoryBarFill(1)
	end
end

function Victory()
	Win()
end
function Defeat()
	Lose()
end

--Here is where the ranking of the grind will be made for time duration and enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 5 then			
			Army = 4
			Army1 = 3
			Titan = 3
			Timer = 60
			EnemySpawnTimer = 40
		elseif Rank == 6 then			
			Army = Rank -2
			Army1 = Rank
			Titan = Rank
			Timer = 60
			EnemySpawnTimer = 30
		elseif Rank == 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = Rank
			Timer = 60
			EnemySpawnTimer = 20
		elseif Rank == 8 then			
			Army = Rank -1
			Army1 = Rank
			Titan = Rank 
			Timer = 90
			EnemySpawnTimer = 35
		elseif Rank == 9 then			
			Army = Rank -1
			Army1 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 30
		elseif Rank == 10 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 30
		elseif Rank == 11 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 30
		elseif Rank == 12 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 30
		elseif Rank == 13 then			
			Army = Rank -1
			Army1 = Rank 
			Army2 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 25
		elseif Rank == 14 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 90
			EnemySpawnTimer = 20
		elseif Rank == 15 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 120
			EnemySpawnTimer = 20
		elseif Rank == 16 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 120
			EnemySpawnTimer = 20
		elseif Rank == 17 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 120
			EnemySpawnTimer = 20
		elseif Rank == 18 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 120
			EnemySpawnTimer = 20
		elseif Rank == 19 then			
			Army = Rank -1
			Army1 = Rank
			Army2 = Rank
			Titan = Rank
			Timer = 120
			EnemySpawnTimer = 20
		elseif Rank >= 20 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -2
			Army2 = Rank -2
			Titan = Rank
			Timer = 150
			EnemySpawnTimer = 20
	end
		
	SpawnUnits("start",Army)
		
	if forPlinthInspector then
		SpawnUnits("spawn_1",Army)
		SpawnUnits("spawn_2",Army)
		SpawnUnits("spawn_3",Army)
	end
end