destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 0
Army = 0
Army1 = 0
Army2 = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetWinnable(false)
	AddTargetCircle("Capture1")
end

function onLevelStart()
    SetTriggerCallbacks("Capture1", Capture1_onTriggerEnter, Capture1_onTriggerLeave) -- Player approaches the capture point
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

--When player enters circle trigger
function Capture1_onTriggerEnter(unit)

	if unit.attacker then

		SpawnUnits("pikeman",Army)
		DisableTrigger("Capture1")
	
	end


end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			SpawnUnits("militia1",Army)
		end
		if destroyed == 2 then
			SpawnUnits("unak",Army1)
			SpawnUnits("ragnar",Army)
		end
		if destroyed == 3 then
			SpawnUnits("archer",Army1)
		end
		if destroyed == 5 then
		    PlayVFX("PA_SpawnReinforcement", "titanentry")
			AddTimer(1,titanspawn)
		end
		if destroyed == 10 then
			SetWinnable(true)
		end
	end
end

function titanspawn()
    SpawnUnits("titan",Titan)
end

function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 13 then			
			Army = 11 
			Army1 = 11
			Titan = 22
		elseif Rank == 14 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 24
		elseif Rank == 15 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 28
		elseif Rank == 16 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 30
		elseif Rank == 17 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 32
		elseif Rank == 18 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 34
		elseif Rank == 19 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 36
		elseif Rank == 20 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 38
		elseif Rank == 21 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 40
		elseif Rank == 22 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 44
		elseif Rank == 23 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 46
		elseif Rank == 24 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 50
	end
		
    SpawnUnits("militia",Army)
			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("unak",Army1)
		SpawnUnits("archer",Army1)
		SpawnUnits("militia",Army)
		SpawnUnits("militia1",Army)
		SpawnUnits("pikeman",Army)
		SpawnUnits("ragnar",Army)
	end
end










