destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 0
Army = 0
Army1 = 0
Army2 = 0

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetWinnable(false)
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onLevelStart()
    SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state.
	end
	GiveNamedUnitMoveOrder("Leader", "point1")  -- tells the unit to run away
	Standstill() -- tells the unit to stand ground
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			GiveNamedUnitMoveOrder("Leader", "point2") -- tells the unit to run away
				Standstill() -- tells the unit to stand ground
		elseif destroyed == 6 then
			GiveNamedUnitMoveOrder("Leader", "point3")
				Standstill2()
		elseif unit.spawnId == "Leader" then
			AddTimer(0.5,YouWin)
		end
	end
end

function YouWin()
   Win()
 end
 
function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("Leader",false)
end

function Standstill2() -- tells the unit to stand ground
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("Leader",false)
	AddTimer(5.0,awarenesson)	
end

function awarenesson()
	SetCanGrowAwareness("Leader",true)
end

function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 17 then			
			Army =  15
			Army1 = 17
			Titan = 30
		elseif Rank == 18 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 33
		elseif Rank == 19 then			
			Army = Rank -2
			Army1 = Rank -2
			Titan = 36
		elseif Rank == 20 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 38
		elseif Rank == 21 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 40
		elseif Rank == 22 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 44
		elseif Rank == 23 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 46
		elseif Rank == 24 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 50
	end
		
		SpawnUnits("Leader",Titan)
		SpawnUnits("skeleton",Army)	
		SpawnUnits("archer",Army1)
		SpawnUnits("mossmane",Army1)
		SpawnUnits("elithen",Army)
		SpawnUnits("militia",Army)
		
	if forPlinthInspector then
		SpawnUnits("Leader",Titan)
		SpawnUnits("skeleton",Army)	
		SpawnUnits("archer",Army1)
		SpawnUnits("mossmane",Army1)
		SpawnUnits("elithen",Army)
		SpawnUnits("militia",Army)
	end
end










