destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 0
Army = 0
Army1 = 0
Army2 = 0
leftdead = 0
rightdead = 0
backdead = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetWinnable(false)
end

function onLevelStart()
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
end

-- calls in relevant troops here
function enterleft()
	SpawnUnits("ragnar",Army1)
	SpawnUnits("mossmane",Army1)
end
function enterright()
	SpawnUnits("elithen",Army1)
	SpawnUnits("unak",Army1)
end
function entertitan()
	SpawnUnits("titan",Titan)
end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.spawnId == "left" then
		leftdead = leftdead + 1
		if leftdead == 1 then
			PlayVFX("PA_SpawnReinforcement", "left1")
		    PlayVFX("PA_SpawnReinforcement", "left2")
		    AddTimer(1,enterleft)
		end
	end
	if unit.spawnId == "right" then
		rightdead = rightdead + 1
		if rightdead == 1 then
			PlayVFX("PA_SpawnReinforcement", "right1")
		    PlayVFX("PA_SpawnReinforcement", "right2")
		    AddTimer(1, enterright)
		end
	end
	if unit.spawnId == "back" then
		backdead = backdead + 1
		if backdead == 3 then
			AddTimer(1,entertitan)
		    PlayVFX("PA_SpawnReinforcement", "titan")
		end
	end
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 13 then
			SetWinnable(true)
		end
	end
end

function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 19 then			
			Army =  17
			Army1 = 17
			Titan = 34
		elseif Rank == 20 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 38
		elseif Rank == 21 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 40
		elseif Rank == 22 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 44
		elseif Rank == 23 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 46
		elseif Rank == 24 then
			Army = Rank -2
			Army1 = Rank -2
			Titan = 50
	end
		
	SpawnUnits("left",Army)
	SpawnUnits("right",Army)
	SpawnUnits("back",Army1)
		
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("back",Army1)
		SpawnUnits("mossmane",Army1)
		SpawnUnits("elithen",Army1)
		SpawnUnits("ragnar",Army1)
		SpawnUnits("unak",Army1)
		SpawnUnits("left",Army)
		SpawnUnits("right",Army)
	end
end










